Changes since Lynx 2.8 release
===============================================================================

2001-11-08 (2.8.5dev.4)
* if file-upload code is configured, suppress message that indicates it is not
  implemented, i.e., "[FILE Input] (not implemented)" -TD
* modify file-upload submission to send plain text if the file is entirely
  printable text.  Mime encoding is needed if the file contains nulls, etc.,
  but reportedly may confuse some hosts -TD
* suppress "charset=" clause on form submission if it is iso-8859-1 -TD
* move case for F_FILE_TYPE in HText_SubmitForm() to obtain original behavior
  of fallthrough for F_SUBMIT_TYPE, F_TEXT_SUBMIT_TYPE, F_IMAGE_SUBMIT_TYPE to
  translate their character set, etc.  (report by KW) -TD
* revert 2.8.4dev.21 change to avoid truncating cookie path in LYSetCookie().
  The server that wouldn't work with the current lynx behavior is
  identified as "Oracle_Web_Listener/4.0.8.2.3EnterpriseEdition"  -DK
* modify LYLegitimizeHREF() change from 2.8.4dev.21 to eliminate newlines from
  the HREF rather than converting them to spaces.  This fixes a problem with
  www.ebay.com which splits up HREFs with newlines.  Changing the newlines to
  spaces made the HREF no longer match, e.g., when it was built up from
  a CGI script (report by Morten Bo Johansen) -TD
* add two test files for testing UTF-8, based on Markus Kuhn's demos
  (quickbrown.html and utf-8-demo.html).  These work with ncurses 20011103
  patch, for wide-characters except for combining characters (more work is
  needed in ncurses).  Tested with XFree86 xterm (patch #163) -TD
* modify select_multi_bookmarks() check for interrupt character to limit it to
  "hard" interrupt characters such as ^G.  This fixes a case where "z" would
  have been treated as an interrupt character in advanced multibookmark mode
  (reports by Michael Warner, HN, as well as Debian #111463) -TD
* modify SUPPORT_MULTIBYTE_EDIT logic in LYUpperCase() and LYLowerCase() to
  check for a null character following an upper-128 code.  This is more likely
  to occur in EBCDIC, though the multibyte strings should not have a null at
  this position in any case (report by PG) -TD
* for wide-character curses configuration, do not force repainting at the end
  of display_page() -TD
* modify configure test for mkstemp() to check if that function returns
  distinct values (report by Fr3dY indicates that AmigaOS has a broken version
  of mkstemp() which always returns the same value) -TD
* modify LYwaddstr() to use wide-character curses functions to make UTF-8 output
  work without relying upon side-effects of narrow-character functions.  Note
  that this relies on the user having set a UTF-8 locale, e.g., en_US.UTF-8 -TD
* modify HText_appendCharacter() to not use utfxtra_on_this_line when compiling
  with WIDEC_CURSES, since the curses library already does this adjustment -TD
* correct the following names in LYrcFile.c which were added to allow
  ENABLE_LYNXRC lines in lynx.cfg to enable them to be saved in ~/.lynxrc
    old           new          where-used
    -------------------------------------
    DTD_recovery  tagsoup      (command-line option and lynx.cfg)
    show_rate     show_kb_rate (lynx.cfg)
    user_agent    useragent    (command-line option)
    -------------------------------------
  (report by Michel Such <msuch@free.fr>) -TD
* modify LYRefreshEdit() to clear field before repainting (patch by Hataguchi
  Takeshi)
* for CJK configuration, force clearing/repainting in HTUserMsg() (patch by
  Hataguchi Takeshi)
* make HTInfoMsg() sleep condition consistent with other messages by using
  LYSleepInfo() -TD
* reduce clutter with new function utf8_length() -TD
* replace !isascii(ch) with new macro is8bits(ch), to reduce clutter, fix some
  sign-extensions and make it more portable -TD
* change some of the "#if" statements to "#ifdef", to work around broken
  versions (2.96, 3.0.1) of gcc distributed with Mandrake 8.1 (though
  reportedly this is due to Redhat):  the -C option passes through comments as
  usual, but some comments expand on preprocessor lines, which causes the
  preprocessor to report an expression error.  This prevented "make
  install-help" from running, though the -C option is not needed for that. 
  However, lacking a working -C option makes the C preprocessor useless for
  analyzing bugs -TD
* modify configure script to accept --with-screen=ncursesw, to build with the
  wide-character version of ncurses -TD
* modify configure script to look for mkdtemp(), to quiet another bogus linker
  message -TD

2001-10-06 (2.8.5dev.3)
* add CF_MKSTEMP configure macro, from vile, to check for a working mkstemp().
  This will quiet some bogus warning messages in recent runtime support, but
  (see 2.8.3) does not affect the security of temporary files in lynx -TD
* updated CF_PATH_SYNTAX configure macro, from vile, to handle leading "\\" in
  a win32 pathname -TD
* for configurations that provide scrollbar, add a checkbox to the Options menu
  to enable or disable it -TD
* modify LYGetHostByName() in HTTCP.c to use the threaded _WINDOWS_NSL code for
  all Cygwin machines.  The ability to interrupt nameserver lookup has not
  worked in Win98 using the Cygwin port, despite defining _WINDOWS_NSL.  It
  looks like the threaded code was only for WinNT.  At least under Cygwin, that
  code also seems to work fine under Win98 -DK
* add FIELDS_ARE_NUMBERED as a possible value for DEFAULT_KEYPAD_MODE in
  lynx.cfg as well as keypad_mode in .lynxrc -TD
* add NUMBER_FIELDS_ON_LEFT and NUMBER_LINKS_ON_LEFT to lynx.cfg, use these to
  control where field- and link-numbering is placed.  Caveat:  there are some
  cases where fields that do popup's are truncated, e.g., in the Options menu,
  when right-alignment is used -TD
* support for DJGPP's two forms of file addressing, [a-zA-Z]:[/\\] and
  /dev/[a-zA-z]/ -DK
* add samples/lynxdump script, to illustrate how to use lynx -dump with no
  link references (prompted by discussion with LV) -TD
* add samples/keepviewer script, to illustrate how to retain a temporary file
  for use in an external viewer -TD
* add ifdef's in is_url() to avoid recognizing URLs if they are disabled in the
  given configuration, i.e., bibp, finger, ftp, gopher, news (report by
  Frederic L W Meunier) -TD
* modify LYrefresh() to take into account whether a popup window exists, so
  that a search prompt will not overwrite a popup.  This bug was introduced by
  the curses pads (reported by Felicia Neff <neff@panix.com> and Fr3dY
  <fr3dy@retemail.es>) -TD
* add note in keystroke_help.html about CTRL-V as literal-next (lnext) for
  users who are unfamiliar with stty -TD
* add NcFTP-style ftp-URLs which are supported by Netscape and wget (request
  by Martin Mokrejs) -TD
* add traces in LYReadCFG.c and LYrcFile.c to report lines which are not found
  in the symbol table, to help diagnose when a user adds lynx.cfg information
  to .lynxrc -TD
* define additional -trace-mask option, 8=config -TD
* modify LYtouchline() to avoid using wredrawln() for ncurses, since the
  LYwin variable may be a pad much wider than the screen, which is not handled
  properly (report by Karl Eichwalder <keichwa@gmx.net>) -TD
* correct beginning configure script, which was supposed to remove
  config.cache, but did not, due to a misplaced line when it was added
  1998-06-04 (prompted by a report by Fr3dY <fr3dy@retemail.es> that the
  checks for srand/rand did not work) -TD

2001-08-15 (2.8.5dev.2)
* several small fixes to HTFile.c to make directory listings work properly on
  win32, e.g., stat'ing a directory with a trailing slash fails (reported by
  Hataguchi Takeshi) -TD
* adjust definitions in LYCurses.h to get rid of slang-ifdef's for getyx() and
  wmove() -TD
* change order of random and rand48 -DK
* patch to get the DJGPP port to use the configure script -DK
  It seems to work well in the variations I have tried, including both PDCurses
  and SLang.  revised INSTALLATION for DOS, giving a URL for my DOS patch to
  openssl.  I dropped the reference to goto URL of the form
  file:///dev/c/path/filename, since this only works in certain parts of lynx
  (such as lynx.cfg).  I'll try to get this working in the future.  In fixing
  makefile.in, I patched the sed script for converting the path to docdir.  As
  far as I can tell, however, from my examination of lynx.cfg, this isn't used
  for any platform.  Does this part of the sed script do anything?
  Things still needing fixing for DOS:
  + support for both forms of file addressing, [a-zA-Z]:[/\\] and
    /dev/[a-zA-z]/.
  + support for gzipped help files.  This works with long file names in a DOS
    box under Windows, but not in plain DOS, which doesn't allow double
    extensions.
  + better handling of local files in root directory.  "file:///c:/" takes a
    long time to work, but "file:///c:/." works fine.  I haven't really looked
    to see why.
  + no ability to break out of hung nameserver lookups or http requests without
    closing lynx with SIGINT.  This is the biggest complaint I get by email.
* modify ifdef for myGetChar() in LYStrings.c to build with PDCurses 2.3 e.g.,
  to use a version which is modified for Japanese input (patch by Hataguchi
  Takeshi <patakuti@t3.rim.or.jp>).
* review LYSafeGets() calls, stripping newlines from a few places where they
  were overlooked, and simplifying some places where LYSafeGets() would
  normally return a buffer ended with a newline (prompted by a report by Brian
  S Queen <bqueen@nas.nasa.gov> for LYTraversal.c) -TD
* correct reallocation-size in ProcessMailcapEntry()
* modify HTLoadHTTP() to omit "Accept-Encoding: gzip" if command-line "-base"
  option is given.  This makes
	lynx -base -source excite.com
  work as expected.  Otherwise, excite.com will transmit the document gzip'd,
  and the ensuing logic in HTSaveToFile() would see the mime-type as gzip
  rather than text/html, and not prepend the base URL (report by Kai Shih
  <kai@mit.edu>) -TD
* work around defect in move_anchors_in_region() and related logic by changing
  default for nested-tables to FALSE when Lynx is not configured for
  color-style.  The problem is that when an anchor is shifted right by
  nested-table logic, if it has a <BR> near the beginning of a table cell and
  it happens to be split across a line, its size will not be adjusted properly
  (report by Hataguchi Takeshi) -TD
* correct logic used for trimming TEXTAREA introduced in 2.8.4pre.3, which did
  not trim carriage-return characters if TRIM_INPUT_FIELDS was false.
  (report by Hataguchi Takeshi <patakuti@t3.rim.or.jp>) -TD
* correct a bug in search logic which happens with pages shorter than the
  screen, due to improper starting-line value sent to search function.  Fixed
  by adding checks in www_search_backward() and www_search_foreward(), (report
  by -Frederic L W Meunier) -TD

2001-07-24 (2.8.5dev.1)
* modify GetChar() definition for PDCurses to ignore key-modifiers which are
  passed back from getch() as if they were key codes.  Those interfere with
  shifted commands such as 'Q' -TD
* modify parse_style() function to operate on a copy of its parameter, to avoid
  changing it.  Otherwise, when parse_style() is executed as a side effect of
  start_curses(), its data is modified and not valid on successive calls.
  This bug existed prior to 2.8.4dev.17 -TD
* set return value of edit_current_file() to true if the file is edited.  This
  forces a reload for example if one edits the current html file, and is needed
  to make PDCurses repaint the screen as well (report by vtailor@gte.net,
  bug introduced in 2.8.4dev.21) -TD
* add ifdef for wresize() to accommodate FreeBSD 3.x which has resizeterm() but
  not wresize().  Also, use a 'long' rather than 'attr_t'.  These changes are
  needed to build with the 1.8.6ache patches to ncurses (report by Matt
  <matt@greenviolet.net>) -TD

2001-07-17 (2.8.4rel.1)
* remove comment in README.ssl directing people to
  http://www.moxienet.com/lynx/, since that page is moot with 2.8.4 (report by
  DK)
* add an ifdef in CF_CURSES_FUNCS configure macro to avoid confusing ncurses'
  term.h with other versions -TD
* update URL for zlib -Frederic L W Meunier

2001-07-14 (2.8.4pre.5)
* document CHARSETS_DIRECTORY and CHARSET_SWITCH_RULES in lynx.cfg -IZ
* add a fallback in _Switch_Display_Charset() if no CHARSETS_DIRECTORY was
  specified -IZ
* ensure that config variable names in LYReadCFG.c are in alphabetic order,
  though only the first character matters (report by IZ) -TD
* updated notes on DOS in INSTALLATION -DK
* modify ifdef in HTTP.c to build with configure --with-ssl --disable-news
  (report by Frederic L W Meunier) -TD

2001-07-10 (2.8.4pre.4)
* correct red/blue color swapping for PDCurses when built on Unix, which uses
  X11 -TD
* correct order of checks for wrapping in www_search_forward() and
  www_search_backward(), which would allow an infinite loop if there were no
  anchors on the current page (report by Frederic L W Meunier) -TD
* add a missing chunk to reverted change of SGML_character()
  -nsh@horae.dti.ne.jp

2001-07-07 (2.8.4pre.3)
* review/add descriptions of new command-line options in lynx.man, lynx.hlp and
  Lynx_users_guide.html -TD
* update da.po, ja.po, ru.po, sv.po from
    http://www.iro.umontreal.ca/contrib/po/maint/lynx/
  (report by JS) -TD
* add command-line option -curses-pads which can be used to disable the
  left/right scrolling logic.  This is used for testing, e.g., the repaint
  bug reported below -TD
* remove logic in lynx_force_repaint() which reset the window background, since
  it does not work with the logic used to implement left/right scrolling.
  Retested older versions of ncurses and did not find a case where this was
  needed after all (report by IZ) -TD
* revert dev.21 change to SGML_character() S_equals case, which has undesirable
  side effects regarding spacing around '=' (report by nsh@horae.dti.ne.jp) -TD
* define additional -trace-mask option, 1=SGML -TD
* add -trim_input_fields command-line option and corresponding
  TRIM_INPUT_FIELDS to lynx.cfg to suppress trimming of TEXT and TEXTAREA
  fields in forms.  This does not retain trailing blank lines in a TEXTAREA;
  more work would be needed to do that (reported by VH, most browsers appear to
  retain trailing blanks) -TD
* modify parsing of "<script>...</script>" to allow "<!-- ... -->" comments
  in SGML_character().  Though the HTML 4.0 spec is fairly clear, other
  browsers (and some webpages) assume that "</" does not have to be escaped
  when it appears in a script which is commented to avoid confusion with older
  browsers.  This change doesn't ensure that the comment is at the beginning
  of a line, since that's awkward to do with SGML_character(), and also leaves
  the script in a comment which works for lynx since lynx does not interpret
  it anyway -TD
* remove redundant enum identifiers in typedefs -TD
* modify parse_attributes() in LYStyle.c to allow video attributes such as bold
  and reverse to be combined with colors, used this to debug problem with
  <script> and comment -TD
* improve logic for nested-tables to handle cases such as www.tin.org -IZ
  TRST ignores the horizontal alignment *inside* a multi-line cell of a table.
  This limitation, in conjunction with the nested-tables modifications does not
  work well when text with a horizontal alignment (e.g., <ul>) is put in a
  table cell.  This patch introduces a *limited* logic to take this info into
  account.  It should work OK as far as the last non-empty line of the cell is
  ended by a "line-end" command, not by a </td> (this is often the case with
  contents using horizontal formatting).
* updated URLs for ncurses (report by DK) -TD
* updated samples/bright-blue.lss -IZ
* make definition of $(SHELL) in makefile.in's consistent, in terms of
  CONFIG_SHELL, since the configure script no longer uses 'include', and
  this creates some problem with nonstandard shells (report by IZ) -TD
* update/extend lists in lynx_help_main.html -Frederic L W Meunier
* add note about lynx.cfg mouse and color configuration to user's guide -PW
* document -cmd_log and -cmd_script options in user's guide (Michael Warner).

2001-06-10 (2.8.4pre.2)
* corrected order of parameters of is_prefix() function in the
  scan_cookie_sublist() function, broken in dev.21 changes (report by Ken Scott
  <admin@shellworld.net>) -TD
* add a fallback definition for SA_LEN(), to build with glibc 2.2 (report by
  Mark Sutton <mes@lazo.ca>, patch by Arkadiusz Miskiewicz at
  http://cvs.pld.org.pl/SOURCES/lynx-SA_LEN.patch?rev=1.1)
* modify ifdef in HTCheckForInterrupt() to build with DJGPP -DK
* remove include for <pdcurses.h>, use <curses.h> which is the default for
  PDCurses - DK
* reviewed/reverted some changes from dev.20 which changed explicit "r", "w",
  and "a+" fopen modes to TXT_R, TXT_W and TXT_A, where they relied on the
  default mode set via SetDefaultMode().  With DJGPP, files containing special
  graphics such as README's might not otherwise display, for example (report by
  DK) -TD

2001-06-03 (2.8.4pre.1)
This version has been test-built on Linux (BSD curses, ncurses,
slang), Tru64 5.1 (cc, curses/ncurses/slang), OpenVMS, OS/2 EMX, win32
(both Visual C++ 4.1 and 5.0 as well as Borland C++), AIX 4, HPUX 11,
Solaris 8.  Recent builds include SunOS 4.1.4 (cc and gcc,
curses/ncurses/slang), Solaris 2.5.1 (cc and gcc,
curses/ncurses/slang) and IRIX 6.5 (cc and gcc, curses/ncurses).  Less
recently, FreeBSD 4.1, NetBSD 1.5 and OpenBSD 2.8 (curses/ncurses).

2001-06-02 (2.8.4dev.21)
* regenerated lynx.pot and resync'd the .po files against it with msgmerge,
  formatted to 132 columns to minimize line-breaks, for ease of comparison -TD
* add a few more #undef's to work with glibc 2.1.3 -TD
* include <signal.h> before <curses.h> to work around bug in glibc 2.1.3, which
  apparently was not used to build a system before release.  Note that the
  preferred solution is to patch /usr/include/sys/ucontext.h to avoid defining
  ERR, which is defined by all versions of curses.h (report by Karl Eichwalder
  <ke@suse.de>) -TD
* change lynx.cfg entry for COLOR #6 to brightred/black, which is what
  Slackware uses, to make links more visible -TD
* remove several chunks of dead (#if 0) or commented-out code, especially in
  TRSTable.c, except a few used for debugging -TD
* add checks for potential buffer overflow in increment_tagged_htline() -TD
* consolidate scattered calls to editor with function edit_temporary_file(),
  which fixes terminal modes when editing TEXTAREA -TD
* modify LYisNonAlnumKeyname(), etc., using new functions LYindex2MBM() and
  LBMBM2index() so that it should work with EBCDIC, as well as similar case of
  translation in LYBookmarks.c which assume that there are no gaps in the
  coding for the alphabet -TD
* workaround in lynx_nl2crlf() for ncurses, which did not refrain from using
  cursor-down if it was set to a newline when nonl() was specified -TD
* replace permissions[] array in LYLocal.c because cygwin (mis)implements the
  S_xxx values as a function -TD
* add ENABLE_LYNXRC setting to lynx.cfg, which allows one to modify the list
  of values which are visible on the O'ptions form which can be saved to the
  .lynxrc file -TD
* check the width of entries displayed by LYOptions.c non-forms
  boolean_choice(), to pad shorter ones with spaces -TD
* change type of LYMultiBookmarks to integer, combine with LYMBMAdvanced, to
  use enumMultiBookmarks to set it, making its configuration more easily
  table-driven -TD
* make the style of menu border/bg/entry/number/active-entry and scroll
  indicator settable -IZ
  The names in lynx.lss are
    menu.frame menu.bg menu.n menu.entry menu.active menu.sb
* modify cookie path prefix-comparison to ignore a trailing slash, e.g.,
  /group/sftvnews/ versus /group/sftvnews (workaround for LV visiting
  http://groups.yahoo.com/group/sftvnews) -TD
* cookie path= should be a prefix of the request-URI path, so do not truncate
  request-URI path in LYSetCookie() [we got mistaken "invalid cookie path=..."
  prompt in some cases previously] -LP
* parameterized the logic around URL_edit_history to add MAIL_edit_history,
  used to store addresses for Printing Options, mail file to user (request by
  LV) -TD
* check, fix minor problems with some .po files based on check_po script
  (mentioned on mutt-dev mailing list by Bjorn Jacke <bjacke@suse.de>) -TD
* fixes to build with U/Win -TD
* check width in LYpaddstr(), truncate the string if needed.  This fixes a
  case where items in very wide popup menus would wrap, e.g., the EXTERN_LINK
  menu -TD
* add a configure checks for term.h, to work around broken package for ncurses
  on cygwin -TD
* combine checks for useragent into one function LYCheckUserAgent() -TD
* add runtime toggle for EXP_NESTED_TABLES, bind this to "~" (see www.tin.org
  for comparison) -TD
* regenerate ja.po from lynx-2.8.3rel1.ja.po using gettext 0.10.37 and libiconv
  1.6.1 (updated by Masayuki Hatta <mhatta@po.airs.net>)
* changed -DNCURSES in DOS makefile to -DPDCURSES -TD
* changes for DOS makefiles with DJGPP -DK
  These changes are for DOS under DJGPP with Internationalization and SSL.  The
  openssl port for DOS is dependent on WATT32, so the link order for libraries
  has to be set appropriately.  Made EXP_NESTED_TABLES the default and changed
  the default locations for WATT-32 and PDCURSES to top-level directories.  The
  DOS port of gettext is now dependent on libiconv.a to convert character sets
  as the .mo file is read.  The format for the makefile in WWW/Library/djgpp
  now reflects the changes previously made in the src makefile.
* improve definition of CTRACE, making it an expression again as it was before
  dev.20 -PG
* move logic for cookie_domain_flag_set() out of LYReadCFG.c into LYCookie.c
  rewriting it to make it table-driven, where it is now shared with LYrcFile.c
  -TD
* rewrote LYrcFile.c, making it table-driven as is LYReadCFG.c -TD
* reviewed/corrected several pointer-mismatches in PARSE_xxx() macro usage -TD
* corrected return-types of several functions in LYLocal.c, which were given as
  BOOLEAN though they return a signed integer -TD
* add DIRED support to makefile.bcb -TD
* filter the list of mime types sent in "Accept:" header for GET, to eliminate
  repeated or shadowed types, using new function HTFilterPresentations()
  (addresses Debian bug report #41594) -TD
* fix several typos in Lynx help-files -LV
* change most configure script C-preprocessor assignments to $CFLAGS to
  $CPPFLAGS, and modify logic of $TRY_CFLAGS to use CF_ADD_CFLAGS, which
  does the same thing -TD
* enable scroll indicators on the menus - shown if there is a part of menu
  before/after the visible area -IZ
* modify the context-sensitive mouse-menu, making it easier to to configure by
  reorganizing the tables used to generate the popup menu -IZ
* correct a couple of places in form_getstr() when keys were "generated"
  instead of actions, which broke mouse-navigation in input fields -IZ
* fix return value of Stbl_finishTABLE(), retesting curpos whose value may have
  been altered, e.g,.  in split_line(), causing a cell to overflow to the right
  of the visible area (even if line wrap is requested) -IZ
* change the logic of -display-charset:  before it was sometimes descriptive
  (here is the charset, behave as if it was used for display), sometimes
  prescriptive (make the display to use charset if you can).  Now it is only
  descriptive.  One is forced to use the 'O'ptions to manually load a different
  font -IZ
* move $(DEFS) and $(CHARSET_DEFS) into $(CPP_OPTS) in src/makefile.in -TD
* renamed -blink_is_boldbg command-line option to -blink, corrected ifdef's -TD
* implement -blink_is_boldbg option for OS/2 EMX and ncurses, then integrated
  some ifdef's to merge with equivalent slang code -IZ
* rewrote hardcoded if/then/else chains in handle_LYK_SHIFT_LEFT()
  handle_LYK_SHIFT_RIGHT() to repeat_to_delta() function -TD
* implement a key-accelerator for shift-left/right commands, i.e., repeating
  the shift command increases the amount by which the screen is shifted -IZ
* modify ifdef in handle_LYK_LINEWRAP_TOGGLE() to use popup menus for each
  configuration rather than limit it only to mouse-supported ones such as
  ncurses or PDCurses -TD
* changes to left/right scrolling to limit its effect to tables (IZ):
  + rename LYlineWrap variable (used to denote the column at which content is
    wrapped) to LYwideLines (used to denote the opposite sense:  true if
    wrapping is disabled).
  + add global variable LYtableCols to control the column-limit for tables.
    The two variables LYLineWrap and LYtableCols have the same effect as did
    altering LYlineWrap and LYcols, but are limited to table layout.
  + modify handle_LYK_LINEWRAP_TOGGLE(), use a popup menu to set LYwideLines
    and LYtableCols.  The latter is set to a positive integer, in units of
    1/12 of the physical screen width.
  + modify GridText.c, replacing LYcols with new macros DISPLAY_COLS and
    WRAP_COLS.
  + keep scrollbar on the right margin of the screen when the contents are
    shifted left or right.
* modify makefile.bcb, add (tested) commented-out lines for building with
  color-styles -TD
* modify makefile.msc and makefile.bcb, add (tested) commented-out lines for
  building with winsock2 -TD
* add a configure check for napms(), use this if available to support subsecond
  delay times for INFOSECS, MESSAGESECS, ALERTSECS -TD
* rewrote www_user_search() to support both forward and backward search.
  Bound backward-search to 'N' -TD
* split-out anchor_has_target() and link_has_target() to separate the search
  loops from the search comparisons -TD
* reduce some clutter with LYno_attr_strstr() and LYno_attr_mb_strstr() macros,
  which combine the caseless/case-sensitive functions -TD
* modify S_equals in SGML_character() to recover when no attribute value
  is given, e.g., if "alt=" is followed by whitespace.  Before, the next
  attribute was used for the missing value -TD
* replace call to LYRemoveBlanks() from LYLegitimizeHREF(), which had the
  effect of removing all blanks from HREFs, with the less drastic step of
  reducing newlines and tabs to spaces and trimming leading/trailing blanks.
  Though they do not belong there, it is more likely that the HREF will work
  with embedded blanks retained -TD
* add a configure check for BSD- and SYSV-style curses touchline function,
  needed to build with NetBSD 1.5 curses which has a partial implementation
  of X/Open curses (report by JS) -TD
* correct insert_blanks_in_line(), which did not copy trailing style codes
  such as stop-underline, causing "lynx -dump -with_backspaces" to produce
  some odd effects -TD
* modify configure script macro CF_NCURSES_VERSION to define NCURSES, in case
  it is used in the default screen setting, since lynx uses this definition in
  some places rather than NCURSES_VERSION to distinguish it from other curses
  implementations -TD
* modify configure script macro CF_NCURSES_CPPFLAGS to check for ncurses.h
  before curses.h, and to specifically check for <ncurses/ncurses.h>, to avoid
  spurious matches against a /usr/include/ncurses.h, to workaround problems
  with obsolete versions of ncurses on FreeBSD and NetBSD where the current
  version is often available only as a "port" (reports by Jim Spath,
  Michael Warner) -TD
* add fallback definition for SLSMG_xxx_CHAR symbols which may be missing in
  older versions of slang (reported by Eduardo Chappa) -TD
* update config.guess, config.sub

2001-04-01 (2.8.4dev.20)
* rename KEYMAP 'EXTERN' to 'EXTERN_LINK', adding 'EXTERN_PAGE'.  Existing
  keymaps should work since 'EXTERN_LINK' matches first.  EXTERN_PAGE runs the
  external command on the current page.  Map comma (,) to EXTERN_PAGE -TD
* replace most calloc calls with typecalloc or typecallocn -TD
* modify LYExtern.c to recognize if more than one EXTERN command has been
  defined in lynx.cfg for a given name, and allow the user to select one
  command from a popup menu -TD
* split-out code that opens lynx.cfg and lynx.lss as LYOpenCFG() function,
  making that check if the given pathname is absolute.  If not, it attempts
  to look in the same directory as the parent file (when processing includes),
  or the directory of the default config file -TD
* replace some explicit "r", "w", and "a+" fopen modes with TXT_R, TXT_W and
  TXT_A, add/use corresponding BIN_R, BIN_W, BIN_A definitions.  Correction to
  OpenHiddenFile(), which would have appended text to a binary file -TD
* combined lynx_html_item_type and lynx_printer_item_type structs as
  lynx_list_item_type to simplify LYReadCFG.c and incidentally fixing a bug in
  add_printer_to_list by merging it with add_item_to_list -TD
* implement a simple workaround for staircased messages from running xli as an
  external viewer, with lynx_nl2crlf() function -TD
* add bright-blue.lss sample (from IZ) -TD
* modify makefile.in's to use symbol _O for object suffix to allow simple
  override for OS/2 EMX -Zomf compiler option (request by IZ) -TD
* add HAVE_LYHELP_H definition in config.hin and use that in LYGlobalDefs.h
  to workaround misuse of HAVE_CONFIG_H in makelynx.bat -TD
* work-around in LYrefresh() when curses pads are used, for special case where
  cursor is not set properly when prompting with long subject line for mailto
  URL -TD
* eliminate some pointer mismatch compiler warnings in LYEditInsert() for
  EXP_KEYBOARD_LAYOUT configuration -TD
* improve handling of tables with respect to bad HTML.  Also took an
  opportunity to macroize a couple of places which missed in
  unobfuscation-of-faking <td></td> (this faking happens when line break
  happens in a non-first column of a table) -IZ
  For example:
    <TR>
      <TD>
             <FORM ACTION="FrameWork.class" METHOD="post">
          y
      </TD>
      <TD>
         <DIV>
              x
         </DIV></FORM>
      </TD>
    </TR>
  Note FORM which spans cells.  -trace'ing it gives very unintuitive
  results: it skips </TD> inside FORM, but not <TD>.  Then it supplied
  </TD> when the FORM ends.
* repair treatment of colspans in TRST, making it work again in one of the
  special cases it worked before.  Another bug was in interaction of
  justification and tables -IZ
* marked more TRACEs in TRST as "BUG"s -IZ
* TRST would sometimes produce non-intuitive results if <td> follows </tr>.
  Add error recovery for this case -IZ
* corrections for nested-table configuration -IZ
  + make trailing <BR> in table cells "behave well" again (the following cell
    would not be horizontally offset).
  + fix highlighting of multiline links inside tables, and a "80M tracelog" bug
    (due to a misprint update of the enclosing table was performed once-per-row
    instead of once-per-table).  Extra updates would not hurt, but led to
    slowdowns and quadratic-size logs.
  + fix a special case with table-in-table for partial-display
* resizing a window on a console may lead to a switch of the character-cell
  size.  The "downloaded font" loaded during an auto-switch of display-charset
  may be no longer valid.  In this case, force a re-download of the suitable
  font for the current charcell size -IZ
* add reverse-video style for forwbackw.arrow to lynx.lss -TD
* while an error in .lynx-keymaps is fatal, but a more or less equivalent error
  in the KEYMAP section of lynx.cfg is benign.  Make them both benign -IZ
* change remaining uses of lookup_keymap(LYK_xxx) to LAC_TO_LKC0(LYK_xxx) -TD
* modify set_clicked_link() to return lynx keycodes rather than character
  values -IZ
* remove line_for_char() function since it is used for HTLine.start
  computations -TD
* several changes to GridText.c -IZ
  + '#' (shown at the UL corner when there is a toolbar) is shown even at the
    beginning-of-the document.
  + with mouse enabled, the first 6 chars in the UL corner were "always"
    sensitive to Click-1, behaving as PREV_DOC (usually on Left).  This patch
    changes this logic (for color-style):
       If '#' is shown there, clicking on it behaves as pressing #;
       Clicking on the next 6 chars behaves as PREV_DOC/NEXT_DOC (3+3);
  + if you define a style for forwbackw.arrow, then suitable arrows are shown
    in these 3+3 positions; in fact they are shown only if it makes sense to do
    PREV_DOC/NEXT_DOC, providing additional feedback.
  + remove the first empty line shown on any HTML document.
  + correct an off-by-one error in the removal-of-zero-length-markup logic.
    Due to this bug, zero-length markup was never removed, which led to
    accumulation of style change entries, eventually to a buffer overflow.  At
    this moment lynx color-style engine would give up, resulting in
    incomprehensible ocean of colors on the display.  To demonstrate, make a
    select entry with more than 46 entries.  [My auto-display-charset logic
    added 2 new encodings to the table of Lynx, bringing the number to 46 on
    the 'o'ption form.  ;-]
  + fixes a bug with incorrectly calculated width of a numeric tag [12]
    as far as 12 is 10 or more (still fixes Debian #68542).
  + remove unused members from HTLine struct.
  + make variables underline_on and bold_on private.
  + rewrote insert_blanks_in_line(), splitting out move_anchors_in_region().
  + make split_line() easier to maintain by adding variables to represent
    common subexpressions, e.g., s_post, s_pre.
  + use set_style_by_embedded_chars() in split_line() to simplify/improve test
    for whether lynx should add a bold/underline control.
  + recode to eliminate HTLine.start
  + recode to eliminate HTLine.chars
  + several changes to split_line(), using pointers to HTChangeStyle structs
    rather than array indices.
* adjust some ifdef's to make configure --disable-trace compile -TD
* correct allocation size in mailcap_substitute(), which did not count the
  trailing null -TD
* add configure --enable-vertrace option, to put __FILE__ and __LINE__ into
  trace log -PG
* improve description of USE_MOUSE in lynx.cfg -PW
* fix a few warnings from antic (unreached statements due to quirks of ifdef's,
  incorrectly-indented code) -TD
* eliminate a few references to USE_HASH and LINKEDSTYLES in documentation -TD
* fix a couple of compiler warnings for SCO (report by BL)
* fix a comparison in HTChunkPutUtf8Char() to work with EBCDIC -PG
* fix a typo in LYCharUtils.c CTRACE macro, amend tracing to avoid suppressing
  a related user message -PG
* change CF_TERMCAP_LIBS configure macro to warn rather than exit with an error
  if it cannot find the libraries it is looking for.  This allows one to
  configure with the slang library on systems without a termcap library (report
  by Atsuhito Kohda) -TD

2001-02-26 (2.8.4dev.19)
* add experimental configure option for post-dev.16 TRST changes by IZ
  (--enable-nested-tables), ifdef'd with EXP_NESTED_TABLES -TD
* correct a couple of places that used attrset() rather than wattrset(), which
  caused the status line to lose color when configured for curses pads but not
  using color-style (report by Fr3dY <fr3dy@retemail.es>) -TD
* add a restriction for the chdir command, so it is not normally enabled in
  anonymous mode -TD
* reduce putenv logic for presetting $LINES and $COLUMNS to a special case
  for MVS -PG
* enable pasting an URL into Lynx (similar to 'g'), and improves the code to
  copy an URL from Lynx -IZ
* remove arbitrary restrictions on the size of text to be pasted.  It also
  makes a quadratic algorithm into a linear one.  Also, it may remove many bugs
  when the text to paste contains non-printable chars.  Not tested with Unicode
  and on Win* -IZ
* implement an action NEXT_DOC, which undoes what PREV_DOC (usually on the
  Left-arrow key) does -IZ
  Possible enhancements:
  a) make HISTORY show the position on the (no more!) "stack".
  b) several places in the source use the value of nhist (they scan
     history?).  Make nhist_extra public, and check whether these
     places want nhist + nhist_extra instead.
  c) Currently LYpop() and (some) LYpush() erases "the tail" of the
     stack.  Maybe some callers would prefer a different semantic...
* correct some logic related to EXP_READPROGRESS -IZ
* change LYE_xxx symbols to an enum LYEditCodes -TD
* replace some WIN_EX ifdef's by CAN_CUT_AND_PASTE.  Enable cut and paste on
  OS/2 -IZ
  For example, in the keymap file:
    setkey "\200\4"		LAC:DO_NOTHING:PASTE	# S-insert
    setkey "^(kIC)"		LAC:DO_NOTHING:PASTE	# S-insert
* enable automatic switching of display charsets -IZ
  Currently, it is supported under OS/2 only.  A couple of lines should make it
  work in LINUX too:  express the semantic of _Switch_Display_Charset() in
  terms of the existing UCChangeTerminalCodepage.
  For example, in lynx.cfg:
    CHARSETS_DIRECTORY:I:/get/tfont10/dir1
    CHARSET_SWITCH_RULES: koi8-r ISO-8859-5 windows-1251 cp866u KOI8-U :cp866, iso-8859-1 windows-1252:cp850
  The first variable may be not needed outside of OS/2 (the directory which
  contains glyph tables, as generated/usable with tfont).  [Used for
  full-screen sessions only.] The second variables may go at the future, when
  Lynx knows how to auto-deduce it itself.  Format of CHARSET_SWITCH_RULES
    source1 source2 source3 : dest1, source4 source5 : dest2
* move a call for _scrsize() from LYSystem() to size_change(), to fix problem
  with OS/2 EMX related to screen-size changes -IZ
* correct a bug in TRSTable.c which left a pointer into a chunk which was
  reallocated elsewhere (report by Robert Mognet <rmgnt@surfree.com>) -TD
* make parse_restrictions() warn about keywords it does not recognize -TD
* rewrote restrictions_fun() in LYMain.c, making it use print_help_strings(),
  to show the actual restriction values, and listing restrictions that are not
  documented in the -restrictions message -TD
* if find-leaks if enabled, free the 'line' variable in HTReadProgress() -TD
* if find-leaks is enabled, undefine SAVE_TIME_NOT_SPACE in HTString.c to avoid
  seeing spurious leaks in HTSprintf/HTSprintf0 -TD
* add command-line option -trace-mask to specify optional traces.  Defined
  these: 2=color-style, 4=TRST -TD
* improve ifdef's for --disable-trace configure option, eliminating more unused
  code when NO_LYNX_TRACE is defined -TD
* make ifdef's for NCURSES and resizeterm consistent -TD
* add a call to wresize() after resizeterm() in case user resizes screen in
  ncurses pad configuration (report by IZ) -TD
* change entry for "bibp" restriction to "goto_bibp" for consistency with the
  other goto_xxx restrictions, and use CAN_ANONYMOUS_GOTO_BIBP (report by
  Robert Cameron) -TD
* add table entries for goto_xxx restrictions, which replace assignments
  overlooked in conversion to table in dev.18 (report by Robert Cameron) -TD

2001-02-12 (2.8.4dev.18)
* change LYLineEditors[] to unsigned char since values are out of range for
  signed chars on Solaris -TD
* correct a memory leak in HTStat() from mis-patch for Win32 -TD
* modify fancy_mouse() logic for ncurses to allow the user to quit a menu by
  clicking outside the menu -IZ
* allow a different approach to the problem:  how to enter a keyboard
  navigation command when you are in an editing mode.  A new EDIT-time action
  is introduced:  LYE_STOP.  Use it like this:
	KEYMAP:^[:INTERRUPT:STOP
  The action behaves as if -tna is temporarily switched on:  your edit is
  committed, and you go into the non-edit mode - until you press Enter on an
  edit field again (or switch to a different document), when this temporary
  switch to -tna is terminated.  If the "current" edit field has a different
  style than the "active" edit field, you get an additional feedback.  Anyway,
  the status line shows a correct info about the current mode.
  In -tna mode this behaves as the usual end-of-edit action -IZ
* make bindings for C-w and C-x C-w do not work for form input fields -IZ
* add etags target to top-level makefile.in -IZ
* add some traces to make color style code easier to debug -TD
* restore commented-out call to HText_cancelStbl() in HTML_TABLE case in
  HTML_start_element() from IZ's changes, which is needed for nested table
  alignment.  The colors shown in deja-news are incorrect however because color
  styles are not picking up the </tr> and </table> tags properly, and a few
  tables are misaligned relative to dev.16, more analysis needed -TD
* change LYHash.c to use const, eliminate redundant unsigned's and casts -TD
* add a limit check for rand()/etc., result in LYUtils.c, which worked for
  Linux lrand48() but was not portable (report by PG) -TD
* add missing definitions to make srand/rand code build for non-autoconf'd
  configurations such as win32 -TD
* ifdef'd the mkdir() for lynx_temp_space in LYMain.c to make it apply only to
  Unix, to avoid prototype conflict with non-POSIX compilers (report by Mike
  Bledig <mikegb@mweb.co.zw>) -TD
* adapt patch for FTP_PASSIVE from NetBSD CVS, to make it work with INET6 (from
  comp.unix.bsd.netbsd.misc newsgroup posting which stated that the patch had
  been forwarded to lynx-dev) -TD
* remove unused code of HTParseInet() for INET6 from HTTCP.c -TD
* updated some translations in fr.po and ru.po (report by JS) -TD

2001-02-08 (2.8.4dev.17)
* implement left/right scrolling and line-wrap toggle using '{', '}' and '|'
  characters, respectively.  This uses SVr4 curses/ncurses pads to make the
  whole screen treated as a viewport into a very wide screen -TD
* make do_check_goto_URL() table-driven to simplify it as well as combine the
  related messages into GOTO_XXXX_DISALLOWED -TD
* combine restrict_name[] and restrict_flag[] arrays to eliminate possibile
  ifdef mismatches, as well as to simplify the treatment of "default"
  restrictions -TD
* eliminate redundant symbols for color-style ifdefs (USE_HASH and
  LINKEDSTYLES), using only USE_COLOR_STYLE -TD
* simplify parse_style() by making most of it a table -TD
* correct logic in arg_eqs_parse() for OPTNAME_ALLOW_DASHES ifdef which made
  incorrect match for -display if -display-charset were given (report by IZ)
  -TD
* revert a commented-out call to HText_cancelStbl() in HTML_TABLE case in
  HTML_start_element() from IZ's changes, which had the effect of changing the
  article color in deja-news for color-style configuration -TD
* fix off-by-one error in the END key handling (an empty line was shown at the
  end) -IZ
* makes END key always show a full last page of the document.  That is, even if
  the last line is already shown, it is moved to become the last line of the
  screen, so that as much as possible of the document is on the screen -IZ
* add -display_chars cmdline option, and additionally allows autodetection of
  the charset on the system which allow it.  This provides a way to switch the
  display charset other than via obscure manipulation with 'O'ptions.  (.lynxrc
  is not viable if you have different charsets in different windows.) -IZ
  The logic:
  (1) first autodetect;
  (2) then read cfg file, and if it is not "AutoDetect ..." (as the saved
      version says), grant the cfg file charset;
  (3) then read the cmdline, if it is present, but not "auto", then
      grant it, otherwise switch back to the autodetected one.
* allow TRST code to handle table-in-table.  There are now two cases only
  (modulo bugs) when Lynx will not show a table in a table form no matter what
  is the screen width:  when TABLE is inside PRE, and when there is a TAB
  inside a TABLE.  Both look like deliberate decisions, so I did not change
  these places in HTML.c.  But one may need to reconsider this at some
  moment...  Example of usage:  to process (my old copy of) DejaNews Power
  Search form (which has TABLE-in-TABLE, and multiline cells) you need screen
  width of 112 chars -IZ
* enable <BR> and <P> in TRSTables.  The table still needs to fit into the
  screen width without line wrapping.  A tiny bit of additional work may be
  needed to allow tables-inside-tables too; then any table should be rendable
  as a table after an appropriate screen resizing.  This patch also should make
  around 70% of TRSTable.c unreachable.  A lot of simplification can be made,
  and most of the current convoluted hackery may be removed.  Since this
  algorithm tries to align *all* the display lines of the table, in some rare
  cases it may need larger screen width than the old algorithm (the old
  algorithm ignores all but one of the display lines corresponding to the given
  <TR></TR> - and in most cases just gives up for the whole table if a
  multiline cell is but of the simplest form) -IZ
* add several traces and comments to TRSTable.c -IZ
* enable interrupting LYNX by any char bound to INTERRUPT -IZ
* add configure check for srand()/rand() functions, or alternatives with
  similar interfaces.  These are used in the SSL and experimental temporary
  file options -TD
* allow binding ESC to perform some action (such as INTERRUPT:ABORT, or
  something else).  It is useful only if the curses (or similar) package remaps
  all the reasonable escape sequences, so Lynx internal escape-sequence
  processing is not needed -IZ
* enable showing the region between mark and point in the edit areas in a
  different style.  The style names are edit.active.marked and
  edit.prompt.marked -IZ
* add visible feedback for special case of unactive current text area which may
  exist with -tna.  The corresponding style is edit.current -IZ
* add FORW_RL and BACK_LL to edit bindings support to allow cursor forward and
  backward respectively to move to the next/previous link if done at the end of
  the edit-field -IZ
* update several configure script macros to smooth over incompatibilities
  in autoconf 2.49c (alpha).  In particular, this eliminates support for
  changequote(), and adds limited support for OS/2 -TD
* add google to list of search engines in lynx_help_main.html -LP
* minor formatting of help message -Michael Warner
* modify GetStdin() function in LYMain.c to allow -stdin option to read past
  a line consisting of "---" (reported by Michael Warner) -TD
* ifdef'd bibp: support, added configure option --disable-bibp-urls -TD
* add experimental support for bibp: URLs as described in
  http://www.ietf.org/internet-drafts/draft-cameron-tatu-bibp-02.txt
  (patch by Rob Cameron <cameron@cs.sfu.ca>).
* change sed delimiters in makefile.in to avoid using '@', which may appear
  in AFS pathnames (report by Martin Mokrejs <mmokrejs@natur.cuni.cz>) -TD
* fix missing call to LYCloseTempFP() in LYPrint.c, which caused attempt to
  mail a file from the PRINT menu to send an email with a blank body.  It looks
  like this would happen for any platform not using LYPipeToMailer() -DK
* change pointers for RFC's from ds.internic.net to rfc-editor.org, since
  the former appears outdated -Michael Warner
* add undef for HAVE_DELSCREEN to config.hin, so the delscreen() ifdef from
  dev.16 works as intended -PG
* workaround in CF_CURSES_FUNCS for overzealous compiler that optimized away
  the test code -TD
* change order of checks by CF_NETLIBS and CF_SSL macros in configure script,
  since SSL libraries depend on network libraries (reports by Martin McCormick
  <martin@dc.cis.okstate.edu>, IZ) -TD

2001-01-01 (2.8.4dev.16)
* add ja.po message file (overlooked in dev.15, reported by Atsuhito Kohda
  <kohda@nsx.pm.tokushima-u.ac.jp>)
* use C preprocessor at build-time to replace CF_EBCDIC configure macro -PG
* integrated SSL patch from http://www.moxienet.com/lynx/ as a configure
  option, --with-ssl -TD
* add configure check for delscreen(), which is not available in some older
  SVr3 curses libraries -TD
* add configure check for socks5p.h, to allow socks5 build to use function
  prototypes -TD
* updated config.sub, config.guess -TD
* modify some configure macros to use CF_PATHSEP, for path-separator which is
  usually colon on Unix, and semicolon on MSDOS, etc.  -TD
* modify several configure macros to use $CFLAGS consistently for compiler
  options and $CPPFLAGS for C preprocessor options -TD

2000-12-21 (2.8.4dev.15)
* add .po files to main distribution, remove stubs for files that were not
  implemented, use msgmerge to resync against the current lynx.pot
  (prompted by discussion with Morten Bo Johansen <mojo@image.dk>) -TD
* corrected dev.13 changes for EXP_READPROGRESS, to make the
  non-EXP_READPROGRESS configuration build and work with .lynxrc settings -DK
* use EXIT_SUCCESS/EXIT_FAILURE in exit() and exit_immediately() calls -TD
* improve check for lynx_temp_space by ensuring that the directory actually
  exists; attempt to create the directory if it does not, e.g., ~/tmp/, to
  resolve problem introduced by Mandrake's patch -TD
* modify SetOutputMode() to flush stdout to work around buffering problem with
  cygwin on error exit from Lynx (reported by Brad Town <btown@ceddec.com>) -TD
* change definitions for LYCharINTERRUPT1 and LYCharINTERRUPT2 to not use
  FROMASCII() in the EBCDIC configuration, since those symbols are used in case
  statements which otherwise would not compile -PG

2000-11-03 (2.8.4dev.14)
* restore initialization of LYlines, LYcols in setup() which was lost in dev.12
  changes (reported by DK).
* modify logic for -stdin option to redirect keyboard input to null device
  if lynx is not connected to a terminal, e.g., running under cron -TD
* check in DontCheck() if Lynx is reading from a command-script, to avoid
  using those characters to interrupt the application -TD
* add a cleanup handler for win32, since UNIX-style signal handlers do not
  work on that platform -TD

2000-10-25 (2.8.4dev.13)
* fix missing ifdef for EXP_READPROGRESS in LYOptions.c (reported by
  Atsuhito Kohda) -TD

2000-10-25 (2.8.4dev.12)
* add a configure check for video library on OS/2 EMX, needed to link with
  slang.  Arrow keys do not work -TD
* use macro UCH to fix gcc's char-used-as-subscript warnings, and to replace
  existing casts to unsigned char, making the code more readable -TD
* merge variants of HTReadProgress() -TD
* modify SHOW_KB_RATE in lynx.cfg to allow disabling logic that
  shows transfer rate during download.  If EXP_READPROGRESS is defined, make
  this alterable from the command line and options menu as well (from
  discussion by Karen Lewellen <klewellen@delphi.com>) -TD
* add the pathname that caused a problem to the error message in
  CF_PATH_SYNTAX, lest someone be confused when tilde is not expanded
  (addresses a problem reported by Lawrence Kwan <lawrence@interlog.com>) -TD
* remove redundant leading newlines in "lynx -version" output (reported by Sven
  Guckes) -TD
* add dependency in src/makefile.in for building chrtrans/makeuctb$x, used by
  UCdomap.o -IZ
* fix CF_PATH_SYNTAX square brackets for OS/2 EMX case, lost by not disabling
  m4's quotes for that line (report by IZ) -TD
* remove older/unused variant of code to set screen size in LYCurses.c by
  setting environment variables -PG
* one of the ".po" files is zipped as type binary rather than ASCII, so it does
  not unzip on OS/390 with the "-a" option.  The "-aa" works better since it
  forces text conversion regardless of the type of the archived file -PG
* change definitions of LYCharINTERRUPT1 and LYCharINTERRUPT2 to accommodate
  EBCDIC -PG
> the remainder (most of the functional changes in this patch) from IZ:
* add "typeless" notion to color style logic:
  a) reverts to the style "foo" (from "foo.classname") if the style
     "foo.classname" was not configured;
  b) For input elements of type=typename uses style
     "input.type.typename" if this style is configured (but
     "input.classname" is not!);
  c) Same for typeless elements, with typename="".
  This allows the following:
    input.type.submit:normal:blue:black
    # match "link":
    input:normal:green
    textarea:normal:white:cyan
    # type-less input is the same as type=text (similar to textarea)
    input.type.:normal:white:cyan
    input.type.text:normal:white:cyan
  If your "link" is configured as normal:green, then input elements of types
  other than typeless, text, or submit will be shown in the same style as link.
  The textareas and text input elements are shown in the same style (but
  different from "link" style), and submit "buttons" are shown yet in another
  style.
* implement styles in "dynamic areas" of documents.  Three flavors of them are
  active text-edit fields, non-active ones, and links/radiobuttons, etc.
  This patch is concerned with the first flavor only.  Two subflavors are
  document's text-edit areas, and Lynx's ones (such as where you input the URL
  after `g').  Each one of them has 3 elements:  scroll symbols ("arrows"),
  after-the-end padding, and the actual input string.
  The patch
    a) makes styles for these 2*3 elements customizable;
    b) uses ACS chars (if available) for the arrows (instead of `{'/`}').
  [It would be nice to make non-active text-areas to have customizable
   styles for padding, and have scroll arrows too...]
  Here is my customization for testing:
    edit.active:normal:red:cyan
    edit.prompt:normal:green:cyan
    edit.active.arrow:normal:yellow:cyan
    edit.prompt.arrow:normal:yellow:gray
    edit.active.pad:normal:gray:cyan
    edit.prompt.pad:normal:white:black
* modify LYSystem() to allow changing size of lynx window with OS/2 EMX
  at runtime.  Example:
    !mode 110,30;exit
* use new macros LYCharINTERRUPT1, LYCharINTERRUPT2 and LYCharIsINTERRUPT() to
  make it simpler to find uses of ^C and ^G
* modify key mappings so the keymap file overrides the terminfo/termcap
  description rather than the reverse
* make unrecognized keynames emit diagnostic when tracing (but ignores them the
  same way the older code did).  Trace info about each keycode received
* provide better tracing of style choices, both when styles are assigned into
  text-lines, and when lss directives are converted to "numeric colors"
* add similar tracing for links and contents of user-editable stuff
* slightly expand the cache of colors to better accomodate 16-color terminals,
  and fixes a misprint in handling background-color == maxcolor
* modify logic in color styles initialization using flag default_color_reset to
  override ncurses use_default_colors() logic if the "default" color style tag
  is found in lynx.lss

2000-10-18 (2.8.4dev.11)
* include LYLeaks.h in LYPrettySrc.c to allow leak-checking -TD
* modify configure script macro CF_RECHECK_FUNC to ensure that we add a given
  library only once to the resulting list.  This fixes a longstanding bug which
  caused the nsl library to be repeated on some platforms (reported by BL for
  one of the SCO configurations, and Urs JanBen <urs@tin.org> for SINIX-L 5.41
  (i386-sni-sysv4)) -TD
* modify "make install-doc" rule to first remove targets.  Otherwise "ln -s"
  and "cp" fail to create the targets when installing with normal user
  permissions (reported by LV) -TD
* fix for handle_LYK_DWIMEDIT() to ensure it does not dereference a null
  pointer, when trying to edit a text file with no links within it (report by
  Harri Tuominen) -DK
* add fallback definitions to accommodate renaming of UCX$xxx symbols to
  TCPIP$xxx in recent versions of OpenVMS UCX (reported by Horst Drechsel
  <ai05@sternwarte.uni-erlangen.de>) -TD
* add TRSTable.obj to src/descrip.mms objects -TD
* modify configure script to omit LYExtern.o and LYLocal.o if the corresponding
  options (externs and dired) are disabled -TD
* correct a typo that made configure script always define USE_EXTERNALS -TD
* interpret ftp server type for VMS if a URL is given with "/~name", as a
  Unix-style server.  This works for the following, at least:
    VMS V6.2 AlphaServer 2100 4/233 MadGoat System type.
  (reported by Rick Dyson <dyson@iowasp.physics.uiowa.edu>) -TD
* make configure check for getaddrinfo() less strict, needed with --enable-ipv6
  on IPv4-only system (patch by Munechika SUMIKAWA)

2000-09-21 (2.8.4dev.10)
* modified www_tcp.h and makefile.msc to allow compile with winsock2 if
  USE_WINSOCK2_H is defined -TD
* fix:  the recently added code to enable external programs to replace normal
  lynx handling of individual URL types was not refreshing the screen after the
  external program finished (EXTERNAL set TRUE:TRUE) -DK
* fixed two URLs in lynx_help_main.html -DK
* add symbol USE_VMS_MAILER, use to distinguish VMS mail ifdef's for test
  compiles -TD
* use new function LYSendMailFile() to consolidate details of non-VMS/non-piped
  email, e.g., DOS or Win32, and eliminate some minor inconsistencies in that
  area -TD
* correct order of ifdef's in send_file_to_mail() which could leave unsent
  email on some systems without popen/pclose -TD
* add some checks in LYhandlePopupList() to prevent popup of an empty list -TD
* change a few messages written to stderr to end lines with \r\n rather than
  \n, since Lynx may already be in screen mode when they are written -TD
* treat .Z, .gz and .bz2 suffixes more symmetrically using new function
  HTCompressFileType() for parsing them -TD
* change mime type for bzip2 files to bzip2, x-bzip2 -HN
* move IPV6 definitions in www_tcp.h to the end, to build on FreeBSD 4.1, since
  SIN6_LEN must not be checked before including netinet/in.h (patch by
  Munechika SUMIKAWA @ KAME Project <sumikawa@ebina.hitachi.co.jp>)
* make HTParseInet() private, simplify some ifdef's -TD
* change shell expression used to process stdin for mailcap to "(command)<file"
  form, which is a little more robust than "cat file|command" (suggested by PG)
  -TD
* update URLs in about_lynx.html -DK
* remove spurious 'FREE(leaf);' from LYLocalFileToURL() introduced in dev.5 -DK

2000-09-01 (2.8.4dev.9)
* improve ifdef's for endwin/newterm logic, making a fallback for LYscreen
  variable -PG
* modify CF_CURSES_LIBS to check if both initscr() and tgoto() are in the
  $LIBS list before deciding not to try to look for them -TD
* add %s substitution to mailcap_substitute(), overlooked when implementing
  the logic to read from stdin when %s is omitted (reported by IC) -TD
* restore endwin/newterm code for ncurses (as PG notes it really is needed).

2000-08-24 (2.8.4dev.8)
* refine CJK-related suppress of refresh() in statusline() to do this only
  when the status line does not contain CJK characters (Hataguchi Takeshi)
* add po/da.po placeholder (request by JS)
* implement %s, %t, %{charset} and %{encoding} substitutions for mailcap
  commands in HTFWriter.c (addresses Debian #21096) -TD
* use new function AnchorsOnThisLine() to obtain count of anchors on the
  current line for correct computation of length required to fix Debian #68542:
  Text entry field on http://lists.debian.org/ is hidden when "form fields are
  numbered" (reported by H.Nanosecond) -TD
* add OS/2 cases to config.guess, config.sub -TD
* modify CF_FUNC_GETADDRINFO to supply missing definitions for
  HAVE_GAI_STRERROR and HAVE_GETADDRINFO, needed to make IPV6 build (reported
  by Wesley Morgan) -TD
* reset recent_sizechange after reading KEY_RESIZE from ncurses to work around
  a case with Linux libc5 which would be treated as an EOF, causing an exit -TD
* suppress PG's endwin/newterm code for ncurses because it is not needed -TD
* modify start_curses() function to preset environment variables $LINES and
  $COLUMNS to make the curses library see the proper screen size.  After
  calling endwin(), delete the current SCREEN object, to force curses library
  to discard its cached values of LINES and COLS.  This requires using
  newterm(), which may not be present in all versions of curses, so we check
  for and ifdef accordingly.  Tested on os390 and Solaris -PG
* cleanup IPV6 ifdef's using SOCKETADDR_LEN macro -TD
* add error checks to LYCopyFile() and other places to report problems copying
  the downloaded file, using new functions LYCloseOutput(), LYCanWriteFile()
  (reported by H.Nanosecond <aldomel@ix.netcom.com> as Debian bug #63391) -TD
* correct logic used to check for "Too many tempfiles", which resulted in
  occasional misfires -TD
* add configure checks for touchline() and touchwin(), use this info to work
  with Ultrix V4.5 (report by Bernhard Simon <bs@bsws.zid.tuwien.ac.at>) -TD
* reorganized CF_SIZECHANGE macro to work with autoconf 2.49a -TD
* cleanup definitions for wait-status macros, moving them into www_wait.h -TD

2000-08-03 (2.8.4dev.7)
* add sample mailto-form.pl script to illustrate handling mailto URLs -KW
* modify HTTCP.c to build on AIX 4.3 using HAVE_TYPE_UNIONWAIT as in LYLocal.c
  (Georg Drenkhahn <georg@MPA-Garching.MPG.DE>)
* change $host_os special case for 'os390' to 'openedition' in configure.in,
  make corresponding changes for config.guess and config.sub -PG
* integrate KAME patch for IPV6 (Wesley Morgan <morganw@chemicals.tacorp.com>)
* add configure script macros for checking IPV6 from tin -TD
* small fixes for configure script macros CF_BUNDLED_INTL, CF_CURSES_LIBS,
  CF_UPPER, CF_X_ATHENA -TD
* fix for multibyte characters in status line (Hataguchi Takeshi
  <patakuti@t3.rim.or.jp>)
* align/merge logic in LYOptions.c and LYForms.c which handles navigation in a
  popup list, for reuse in name-completion -TD
* restore check for ^G to cancel in HTSaveToFile() lost in dev.4 changes -VH
* remove duplicate entries in sortedList() which are used for name-completion
  (Frederic L W Meunier) -TD
* fix compiler warning about const in LYpaddstr() using LYwaddnstr(), and
  fix a potential buffer overflow in the latter (report by PG) -TD
* correct logic in LYsubwindow(), which called delwin() with a null WINDOW
  pointer -PG, TD

2000-07-17 (2.8.4dev.6)
* move special case statement for os390 compiler before AC_PROG_CC macro in
  configure.in and regenerate configure script (reported by PG) -TD
* correct check for return values of check_color() in parse_color() for slang
  configuration, which prevented use of "default" color.  This applies to
  2.8.3rel.1 as well -TD
* correct draw_option() functions in LYForms.c and LYStrings.c for slang
  configuration broken in dev.5 by wrong cut/paste (report by IC) -TD

2000-07-16 (2.8.4dev.5)
* remove "*:OS/390:*:*" item from config.guess -PG
* add os390 item to $host_os case-statement in configure.in -PG
* move $host_os case-statement in configure.in before some configuration tests
  such as CF_BUNDLED_INTL which might perform compile-time tests -TD
* use LYLocalFileToURL() in handle_LYK_CHDIR() to ensure that DOSPATH is
  handled properly, inserting a '/' (reported by DK) -TD
* correct loop condition in HTSaveToFile(), from dev.4 changes for -cmd_script
  option which left it ignoring 'c' for cancel -TD
* speed up local directory access for DJGPP by setting _djstat_flags (Gisle
  Vanem)
* updates for makelynx.bat, and improved call on the blat mailer (note -f field
  not needed or wanted):  -Victor Schneider
* fix Debian bug #65151:  "<> in javascript causes premature </script>"
  (reported by H Nanosecond <aldomel@ix.netcom.com>) -KW
* replaced all occurences of 'black' with 'default' in /samples/mild-colors.lss
  to make it more reasonable on terminals with non-black background -VH
* modify color-style initialization to avoid passing -1's as attribute codes
  which would happen if the lynx.lss file was not found, or if not all styles
  were set in that file.  Also if lynx.lss is not found, initialize the
  predefined styles to match those in samples/lynx.lss -TD
* modify handling of empty values for radio and checkbox fields to avoid
  sending "on" as the value (reported by Janne Peltonen <jkhp@cc.hut.fi>) -KW
* don't double backslash characters in HTQuoteParameter(), since that changes
  the string a program invoked through system will see.  Note this assumes UNIX
  or POSIX interpretation of single-quoted strings by the shell -KW
* implement first draft of command-completion using popup menu for selection.
  Pressing tab twice in the prompt for command or URLs will display a sorted
  list of the choices -TD
* implement a simple parser for Lynx commands which are normally bound to keys
  using KEYMAP.  This is bound to ':', so you can for instance type ":quit" to
  exit.  The parser allows unique abbreviations, so ":q" is equivalent to
  ":quit" -TD
* consolidate/simplify logic for displaying popup menus -TD
* rewrote tab-completion to use an HTList -TD
* move related logic into LYSubwindow() to reduce clutter - TD
* make $(DESTDIR) variable work for po directory -TD
* update bundled intl directory to match gettext-0.10.35 (except for fixes to
  build scripts) -TD
* modify configure macro CF_CURSES_LIBS to use a different order for library
  checks if it has found ncurses header files (i.e., they are installed as
  /usr/include/curses.h).  This is done to fix an problem where there are two
  versions of the curses/ncurses libraries installed, and the "curses" library
  is not ncurses (from a report by Sergei Pokrovsky <pok@nbsp.nsk.su>) -TD
* fix for configure script from dialog:  If we really do not use included intl,
  suppress the command that would attempt to symlink the two copies of its
  header -TD
* updates for config.guess, config.sub from tin -TD

2000-06-23 (2.8.4dev.4)
* modify handling to EXTERNAL settings by adding a new field in lynx.cfg.  When
  TRUE, then activating (using arrow-right for example) the link with URL
  matching the one specified by 'prefix' field will be equal to pressing '.' on
  it -VH
* restore commented-out "clearok(curscr, TRUE)" in display_page() in GridText.c
  to workaround problem repainting multibyte characters (reported by Takuya
  ASADA <asada@isoternet.org>) -KW
* add HIDDEN_LINK_MARKER entry to lynx.cfg, allowing user to specify string to
  mark hidden links with (thus hidden links become non-hidden, thus they won't
  be listed as hidden in the 'l' page) - the name of the setting is
  hidden_link_marker.  If the string to mark with is empty, then old behaviour
  is restored -VH
* implement "change directory" command.  This is tested only on linux.  It's
  bound to 'C' in both modes (before this in normal modem COMMENT command was
  bound to 'c' and 'C' in normal mode, and CREATE was bound to 'c' and 'C' in
  dired mode).  The main purpose of this command is not to type the name of the
  directory when 'p'rinting to files and 'd'ownloading.  If this command is
  invoked in dired mode, the listing of destination directory will be
  automatically loaded.  Dired file operations menu lists this command too as
  the first item.  To disable it, comment the line
      #define SUPPORT_CHDIR
  in userdefs.h -VH
* add definitions to allow slang configuration to implement scrollbars.  This
  will not work for any termcap/terminfo-based systems, appears specific to
  MS-DOS (patch by Gisle Vanem)
* updates for config.guess, config.sub from tin -TD
* fix typo in CF_CHECK_ERRNO configure macro (reported by John Coyne
  <John.Coyne@ctbto.org>) -TD
* add <html> and </html> around generated HTML in HTGopher.c, LYKeymap.c,
  LYCookie.c and LYCgi.c to make them more-correct.  Did not modify
  LYBookmark.c because the logic there relies on appending to the bookmark file
  (report by Patrick Boylan <pboylan@island.net>) -TD
* make pretty_html() in LYKeymap.c quote ampersand and quote, simplified logic
  as well with LYKeycodeToString() implemented for command-logging -TD
* add command-line options -cmd_log and -cmd_script, to provide a simple
  command logging and scripting facility -TD
* minor correction to -stdin option, add newline at the end of each line
  copied -TD

2000-06-02 (2.8.4dev.3)
* initial support for SOURCE_CACHE_FOR_ABORTED -VH
* change default_keypad_mode_fun() to use config_enum() -TD
* modify config_enum() to check if the given name in lynx.cfg is ambiguous,
  matching more than one name -TD
* in passive ftp mode (FTP_PASSIVE:TRUE), use the IP address from the server's
  response for the data connection, rather than doing another lookup of the
  hostname -KW
* correct bug introduced in dev.2 for leading whitespace in mailcap (reported
  by Andrey Chernov) -VH, TD
* change server types in HTFTP.c to an enum -TD
* handle a "215 Windows2000" response from "SYST" command (Gisle Vanem)
* change return value of parse_arg() when processing non-option data to make
  URL in stdin (after '-') treated in the second pass, restoring behavior lost
  in cleanup (reported by Gisle Vanem) -TD
* allow blank as a separator in arg_eqs_parse() in addition to ':' and '=',
  to restore behavior lost in cleanup of argument parsing -TD
* make -stdin option a little more flexible by ifdef'ing primarily based on
  ttyname(), and adding fallback definitions for Win32 and VMS -TD
* for slang configurations past 1.3.6, call SLsmg_touch_screen() in
  start_curses to ensure that the screen is properly initialized for non-bce
  terminals (John Davis)
* move call on lynx_initialize_keymaps() for slang configuration into the
  start_curses() function, avoiding premature reference to $TERM, especially
  when Lynx is running in dump mode, e.g., via cron (report by Hamish Moffatt
  <hamish@rising.com.au>, analysis by KW) -TD
* correct logic for ^ and $ commands (FIRST_LINK and LAST_LINK) when the
  current line happens to be the first or last line on the screen (reported
  by KW) -TD
* remove unused fragments of backspace logic from print_crawl_to_fd() -TD
* modify print_wwwfile_to_fd() and print_crawl_to_fd() to refrain from emitting
  an offset for empty lines -TD
* modify print_wwwfile_to_fd() to refrain from emitting backspaces when
  the is_reply parameter is true -TD
* add traces for argument parsing, as well as an environment variable
  LYNX_TRACE which has the effect of the -trace option -TD
* add configure check for ttyname, used in ifdef's for -stdin option -TD

2000-05-21 (2.8.4dev.2)
* minor changes to HTInit.c to make it more tolerant of leading whitespace
  in mailcap entries (reported by Sven Guckes <guckes@math.fu-berlin.de>) -TD
* add option -stdin, which tells Lynx to read the startfile from standard
  input -TD
* simplify argument parsing in LYMain.c, moving the special cases into the
  table-driven logic by adding a flag that denotes the argument parsing phase
  that applies -TD
* correct duplicate description of JUMPFILE in lynx.cfg -TD
* refine cfg2html.pl changes to use command-line options to control the
  sorting and marking features, as well as make the script work properly if
  the markup data is not given -TD
* moved entry for lynx.cfg setting "viewer" according to the alphabet in
  LYReadCFG.c:Config_Table -VH
* modify cfg2html.pl to mark unavailable options, and to provide for sorting
  the options in body.html -VH
* update NLS configure script macros using CF_BUNDLED_INTL from tin, etc. -TD
* update utmp configure script macros from xterm -TD
* fix (from tin) to autoconf macro AM_WITH_NLS to fix a case where it would
  refuse to build with non-GNU gettext -TD
* modified autoconf macros CF_HEADER_PATH and CF_LIBRARY_PATH, to look in more
  places for the specified files, including $HOME -TD
* remove intl/libintl.h since it is overwritten by a symbolic link (reported
  by Atsuhito Kohda <kohda@pm.tokushima-u.ac.jp>) -TD
* correct a few tests in configure script which must allow inclusion of either
  ncurses.h or curses.h, otherwise color-style cannot be configured (reported
  by Frederick Bruckman <fb@enteract.com>) -TD
* move logic that makes subdirectory for more-secure temporary files into
  LYOpenTemp() where it can perform that action on demand rather than for all
  invocations of lynx.  Further refine this logic by ensuring that the umask is
  set to allow execution permissions on the subdirectory (fixes problems
  reported by Michael Abraham Shulman <mas@kurukshetra.cjb.net> and KW) -TD

2000-05-05 (2.8.4dev.1)
* use built-in LYCopyFile logic for CYGWIN rather than external cp program -DK
* minor refinement to  LYValidateFilename() to avoid prepending a drive
  letter when saving files via the PRINT command on DOS systems -DK
* update URLs in lynx_help_main.html (Frederic L W Meunier)
* update description in INSTALLATION dealing with passive ftp (report by
  Frederic L W Meunier) -TD
* correct ifdef'ing in LYtouchline() for VMS curses versus slang (report by
  Jerome Lauret)
* correct an overlooked change of ifdef's from
  CONV_JISX0201KANA_TO_JISX0208KANA to CONV_JISX0201KANA_JISX0208KANA -TH
* move include of LYClean.h in LYexit.c to ensure that cleanup_files() is
  prototyped on VMS (report by Jerome Lauret)
* move assignment of HadVMSInterrupt in cleanup_sig() to avoid interaction with
  logic in HTConfirmDefault() on VMS (reported/tested by Jerome Lauret) -KW
* minor fixes to lynx.man / lynx.hlp for descriptions of -get_data, -post_data,
  -short_url -KW
* avoid invalid memory access that can result from redirection messages
  that include a fragment in the new URL -KW
* change sed delimiter in makefile.in from '%' to '"', to work around SINIX
  v5.43 (SYSV4) sed which becomes confused by nested '%' in expression for
  htmlized cfg install (reported by Shishakov Vjacheslav"
  <shishako@avn.skiftel.ru>) -TD

2000-04-23 (2.8.3rel.1)
* replace LYNX_RELEASE variable in userdefs.h by functions LYVersionIsRelease()
  and LYVersionStatus() in LYShowInfo.c -TD
* remove symbol LYNX_RELEASE_DATE, use same format for both development and
  release dates -LP
* remove po/ChangeLog (noted by LP)

2000-04-22 (2.8.3pre.8)
* update option_help.html to describe the Visited Pages settings -TD
* correct order of body_attr[] and button_attr[] in HTMLDTD.c -TD
* correction for IMG attributes in HTMLDTD.c -KW
* tweak form-based options menu:  General Preferencies now has User Mode,
  Editor, Searching type and Cookies (suggested by PW).  Correct misspelled
  gettext'ed message, introduced in pre.7 -LP, DK
* note in configure --help and INSTALLATION that color-style is implemented
  for various curses libraries but not slang -TD
* add a note to INSTALLATION describing how to disable the telnet application
  when configuring Lynx -TD
2000-04-19 (2.8.3pre.7)
* move initialization of WATT-32 "sock_init()" code in LYMain.c so it precedes
  Lynx's code to setup SIGINT handler, since WATT-32 installs a SIGINT handler
  as well.  This makes Lynx's handler the default again -DK
* correct handling of CHARSET attributes on LINK and A.  Basically this reverts
  back to original 2.7.2ac logic -KW
* enable handling of CHARSET attributes on LINK - it was disabled, probably
  accidentally -KW
* prevent CHARSET attributes from modifying the charset assumption for the
  _current_ document -KW
* correct errors in HTML.c that could result in infinite loop (iteration
  counter was not incremented) -KW
* revert one strcpy -> StrAllocCopy change - see added comment in LYCgi.c -KW
* correct limit of formatted string in status_link() -KW
* change NO_FILE_REFERER default to TRUE (i.e., do not send local file name
  in the referer field unless explicitly specified by the user) -LP, KW
* implement a workaround for gettext'd ADVANCED_COOKIE_CONFIRMATION to make
  it consistent with HTConfirmDefault(), fixes Debian #62105 -TD
* clarify/expand notes in lynx.cfg dealing with USE_MOUSE (from comments by
  Morten Bo Johansen <mojo@image.dk>) -TD
* noted glibc 2.1.3 bug in PROBLEMS -TD
* reorganize forms-based options menu:  options are now grouped by sections in
  a more logical way (design by KW).  (BTW, it is now more aligned with
  htmlized-cfg cattoc.html).  Help files changed accordingly.  A few gettext'ed
  messages were changed -LP
* add ifdef's (USE_BLAT_MAILER and USE_ALT_BLAT_MAILER) and corresponding code
  for blat vs blatj mailer (request by Victor Schneider) -TD
* update Lynx FAQ locations -JS
2000-04-17 (2.8.3pre.6)
* change version number in remaining documentation to 2.8.3 -TD
* remove redundant defines for SUPPORT_MULTIBYTE_EDIT and COLOR_TABLE from
  DOS/Win32 makefiles -TD
* small change to configure test for REAL_UNIX_SYSTEM to accommodate linkers
  that allow assignment from a nonexistent extern.  Also, change a few UNIX
  symbols in LYCurses.c and LYUtils.c to REAL_UNIX_SYSTEM to build on platforms
  that do not define this symbol -TD
* update notes in LYMain.c and LYReadCFG.c regarding the options and config
  variable tables, which no longer need to be sorted -TD
* htmlized lynx.cfg: add .h2 RULESFILE, remove confusing .h1 header -LP
* define SUPPORT_MULTIBYTE_EDIT in userdefs.h -TH
2000-04-13 (2.8.3pre.5)
* fix printing of Last-Modified field in downloaded/printed source -LP
* update URL for RFC 1942 -LV, DK
* update Subir Grewal's Lynx links URL to the newest location
  http://www.trill-home.com/lynx.html -LV, TD
* move assignment to donelookup in LYGetHostByName() to avoid race with
  CreateThread() -Alexei Anatski
* modify LYexecv() in LYLocal.c for MINGW32 -HS, Victor Schneider
* re-correct logic for .h1 comments in cattoc.html by cfg2html.pl (reported
  by LP) -TD
* move call to cleanup_files() into LYexit(), to fix stray temporary directory
  left, e.g,. when doing "lynx -version" -TD
2000-04-11 (2.8.3pre.4)
* add to logic of --with-charsets configure option, checking for charset names
  that happen to be built-into UCdomap.c rather than defined via .tbl files
  in src/charsets (reported by HN) -TD
* correct missing extern in CF_SLANG_UNIX compile-test -TD
2000-04-06 (2.8.3pre.3)
* remove definitions for NCURSES and NCURSES_VERSION from top-level makefiles
  that really use PDCurses -TD
* add USE_MOUSE symbol: cleanup/simplify ifdef'ing of mouse code,
  replace USE_SLANG_MOUSE / NCURSES_MOUSE_VERSION / PDCURSES_MOUSE_VERSION
  with USE_MOUSE (and modifier when necessary) -LP
* windows makefiles: add new symbols SOURCE_CACHE and USE_PRETTYSRC,
  remove obsolete EXP_CHARTRANS and unused EXP_CHARTRANS_AUTOSWITCH -LP
* fixed a bug with psrcview on lss-enabled lynx. Code such as <a blah href=.>
  (i.e. unknown attribute and then some other attribute) was causing calls to
  PSRCSTOP(barattr) twice (and lynx was switched to "non-preformatted" mode
  losing all white spaces of the document after that piece of code) -VH
* add configure option --with-screen=pdcurses, mainly for checking ifdef
  conflicts between ncurses and pdcurses.  This builds/runs with the PDCurses
  X11 library, but is not recommended for general use -TD
* remove test-artifact in configure check for zlib.h -TD
* add CF_SLANG_UNIX configure macro, to allow slang configuration to build on
  AIX, etc., (reported by Jens Schleusener <Jens.Schleusener@dlr.de>) -TD
* update CF_CURSES_LIBS macro from CDK fixes, adds a special check for HPUX
  11.x -lcur_colr library -TD
2000-04-02 (2.8.3pre.2)
* fixed problem with charset handling for SOURCE_CACHE:MEMORY - if the charset
  was specified by Content-Type http header it won't be lost (as it was) when
  reparsing from source cache (applies to toggling DTD, switching to srcview,
  and other stuff like *,' etc) -VH
* add ifdef'd call for creat() for Borland C configuration in LYExecv(), as per
  JS report -TD
* remove definition of NCURSES_MOUSE_VERSION from makefile.bcb and
  makelynx.bat, which should fix compile problem reported by JS -TD
* move a small number of gettext definitions into LYMessages_en.h to allow
  removing the associated files from POTFILES.in, which must not be larger
  than 1023 for Solaris (reported by JS) -TD
* improve ifdef's for fallback definitions of getattrs(), getbegx(), getbegy()
  and getbkgd() in LYCurses.h since they may be functions rather than macros
  (reported by PG on os390) -TD
* further restrict tildeExpand() so it allows embedded "~" only if it follows
  a slash, or is the first character -TD
* add check for "~" as the path to be expanded in tildeExpand() (fixes problem
  reported by Frederic L W Meunier when TEMP_SPACE was defined to "~") -TD
2000-03-31 (2.8.3pre.1)
* remove annoying trailing period from two statusline messages ending with host
  name ("Looking up host.foo:81." and "Making HTTP connection to foo.bar.") -LP
* lynx.cfg: use two lines to separate options description in this
  configuration file (it looks more readable, for such a huge text) -LP
* lynx.cfg:  make a few corrections to reorganize .h1 sections to improve
  htmlized cattoc.html logic.  More corrections welcome -LP
* fix some compiler warnings for DECC dealing with time_t being unsigned in
  that environment (reported by Jerome Lauret) -TD
* suppress Multinet prototypes in socket.h, to work around some places where
  Multinet declares parameters a void* while DECC uses char* (patch by Jerome
  Lauret <JLAURET@mail.chem.sunysb.edu>).
* undo side-effect of config_enum() function in LYReadCFG.c from cleanup in
  dev.22 which made default_user_mode and source_cache values not set properly
  (reported by Alexei Anatski <alexei.anatski@srm.ru>) -TD
* correct ifdef's in LYStrings.c for NCURSES_MOUSE_VERSION versus PDCURSES
  adding new PDCURSES_MOUSE_VERSION to cover special case of DJGPP (reported by
  LP, DK) -TD
* add PRETTYSRC to lynx.cfg, supplementing -prettysrc commandline option -TD
* add call to LYStoreCookies() from HTFWriter.c to save cookies when -source is
  used (patch by KW)
* remove const from LYGetHostByName() parameter -TD
* modify makefile.in to ensure links within htmlized lynx.cfg are updated
  if gzip-help is configured (reported by Ari Moisio) -TD
* remove -DEXP_CHARTRANS from makefile.msc, makefile.bcb (reported by LP) -TD
* trim trailing path-separator from lynx_temp_space before removing that
  directory, on exit -TD
* ifdef'd IsOurFile() to perform only an ownership check on single-user DOS
  and OS/2 systems, so user can overwrite files -TD
* simplified some initialization in LYMain.c with tildeExpand() -TD
* change prototypes of HTSetPresentation(), HTSetSuffix5() to use double rather
  than float, since this is the default promotion, working better with some
  compilers -TD
* add comments to makefile.msc to show how to build color-style version -TD
* add fallback definition for getattrs(), move fallback definitions for
  getbegy() and getbegx() in LYCurses.h to allow building color-style version
  with PDCurses -TD
* correct a call on lib$find_file() in HTVMSUtils.c which broke by not
  supplying it with a fixed-size buffer, from dev.23 changes -TD
* correct an out-of-range indexing error in LYstatusline_messages_on_exit(),
  and add a check in to_stack() for a similar problem -TD
* add definitions and description of USE_TH_JP_AUTO_DETECT,
  CONV_JISX0201KANA_JISX0208KANA, and KANJI_CODE_OVERRIDE to userdefs.h, along
  with a new file README.jp -TH
2000-03-26 (2.8.3dev.23)
* make -nounderline option apply to overloading of colors 4 & 5 with
  underlines, in slang configuration -TD
* on initialization, check if the LYNX_TEMP_SPACE denotes a directory which
  we cannot easily determine if someone could alter our temp-files.  If so,
  make a subdirectory of that, with appropriate permissions -TD
* disable setuid on initialization -TD
* add a definition USE_MKSTEMP in userdefs.h which supersedes EXP_RAND_TEMPNAME
  for sys-admins who believe in mkstemp() -TD
* change logic for EXP_RAND_TEMPNAME to avoid allowing fmt_tempname() to return
  the same name during a session.  Define EXP_NAME_TEMPNAME in userdefs.h -TD
* add Last-Modified header into the printed/downloaded source, in addition to
  the Date header (it is there for years).  (Last-Modified field will not be
  printed if it is not present, or equal to the Date header or equal to
  "Thu, 01 Jan 1970 00:00:01 GMT", a common mistake in scripts) -LP
* defined DIRED_SUPPORT in makefile.msc -TD
* several small fixes in LYLocal.c for dired support, mostly win32-specific -TD
* modify PDCurses mouse logic to use BUTTON_PRESSED mask rather than
  BUTTON_CLICKED, since the latter appears to not work in PDCurses 2.4 -TD
* modify HTDirTitles() to fix a couple of cases for device-only pathnames,
  e.g., for DOS -TD
* modify HTDOS_name() to put a trailing '\' on the result if only a device
  is given.  Fix a memory leak in HTDOS_name() -TD
* simplify local_dired() using new function match_op(), adding DOSPATH
  and __EMX__ to special case of stripping a leading '/' from parameter so
  dired mode works properly on Win32 and OS/2 EMX -TD
* minor cleanup using new function LYformTitle() -TD
* modify LYUCPushAssumed to push original assume_charset insted of
  anchor_UCI->MIMEname when HTCJK is JAPANESE.  If this modification isn't
  done, Japanese strings may be mishandled when charset is not specified or
  assumed as Japanese charset.  On the other hand, if this modification IS
  done, the specified charset is ignored when HTCJK is JAPANESE.
  # I think it's long way to improve this completely. It rarely
  # causes small problem in source view mode for Japanese document.
  # I think it can be ignored -TH
* improve handling of Japanese titles in List Page, LYNXIMGMAP Page and
  ShowInfo Page -TH
* remove spurious backslashes in sed script for adjusting link to htmlized
  lynx.cfg -Michael Warner
* add -luser32 library for cygwin configuration, needed for WIN_EX ifdefs -DK
* correct some screen handling problems when built with SLang -DK
* updated the INSTALLATION file to reflect building under cygwin -DK
* define WIN_EX and _WINDOWS_NSL for cygwin configuration -DK
* use select_s() from WATT-32 for the DJGPP port, rather than select() from
  DJGPP (suggested by Gisle Vanem, to make it faster) -DK
* add a configure check CF_SET_ERRNO to check if we really can set errno,
  even if it has been #define'd -TD
* remove a redundant call to HTQuoteParameter() from LYExtern.c, which resulted
  in quoted-quotes (reported by Michael Warner) -TD
* add configure check for syslog.h, in case --enable-syslog is given for a
  machine that doesn't support it -TD
* add ASSUMED_COLOR variable to lynx.cfg, making the use of
  assume_default_colors() optional (addresses reports by LV, IC) -TD
* add a configure check for the compiler option needed to find zlib.h, e.g.,
  if it is in /usr/local/include and the compiler is not gcc -TD
* disentangle some of the PDCurses ifdef's from ncurses, including the mouse
  handling.  The symbol PDCURSES should be used for PDCurses, not NCURSES*
  or DOSPATH -TD
* remove unused getline.c, getpass.c, crypt.c and crypt_util.c -TD
* change ifdef's in LYisAbsPath() and LYisRootPath to make OS/2 EMX treated the
  same as DOSPATH -TD
* review use of strcat/strcpy, changing as needed to avoid buffer overflows -TD
2000-03-12 (2.8.3dev.22)
* modify Home_Dir() so that on DOS & Windows, if the $HOMEDRIVE variable is
  set, it may be used to specify the drive on which $HOME is located -TD
* add configure option --enable-htmlized-cfg to install the htmlized lynx.cfg
  in the help directory (request by LP) -TD
* suppress sleep's in crawl or traversal mode (request by LV) -TD
* cleanup LYReadCFG.c, LYrcFile.c a little, using new functions putBool,
  getBool, putEnum and getEnum -TD
* change default mode for visited-links-page to match original behavior, add
  visited_links to .lynxrc file (requests by KD, LP) -TD
* update documentation to reflect move from sol.slcc.edu to lynx.isc.org -PG
* remove obsolete files:  WWW/Copyright.txt (replaced by FreeOfCharge.html) and
  WWW/README.txt (recommended by DK) -TD
* clean up some of the loose ends, primarily in documentation.  A Russian user
  pointed out that the DOS binary was ignoring character 0xe0.  This turned out
  to be a bug in the PDCurses code for DOS.  I modified the INSTALLATION file
  to reflect the patch to PDCurses.  Also include the file for the public
  domain release of the CERN wwwlib code (FreeOfCharge.html).  Other changes
  fix dead links, Y2K changes, and reflect newer versions of other programs -DK
* comment-out/disable NO_ANONYMOUS_EMAIL definition in userdefs.h -DK
* change optimization level to -O1 in makefile.dos -DK
* use macro set_errno() to hide some of the clutter in HTTCP.c as well as make
  it simpler to build with threaded libraries -TD
* ifdef'd out a "QUIT" command sent to the FTP server immediately after opening
  a data connection in HTFTPLoad(), since this makes the ftp.wku.edu server
  close the connection prematurely -TD
* combine redundant HTMake_VMS_name() with HTVMS_name() -TD
* review use of "%s" in sprintf, to guard against buffer overflows, modified
  some to use HTSprintf0 or StrAllocCopy, others to use specific lengths
  (KW noted a related problem in HTTP.c) -TD
2000-02-25 (2.8.3dev.21)
* modify check for empty news-posting to warn but allow user to override if
  it contains nonspace characters -TD
* add FTP_PASSIVE option to lynx.cfg, allowing installer to defer decision
  of whether lynx uses passive ftp connection (adapted from patch by
  Bernhard Rosenkraenzer <bero@redhat.de>) -TD
* remove duplicate definitions of HT_NON_BREAK_SPACE, HT_EN_SPACE leaving them
  in HTFont.h -TD
* lynx.cfg option CONNECT_TIMEOUT and commandline option "connect_timeout" were
  added (not available for DOS port) -VH
* don't perform submission of the content of disabled form fields -VH
* add bindings for ^ and $ (like vi) to move the cursor to the first and last
  link on the current line (prompted by complaint by DH that < and > used to
  allow movement to the ends of a line) -TD
* remove --enable-kanji option (request by TH) -TD
* replace 3 CONV_JISX0201KANA_ISX0208KANA to CONV_JISX0201KANA_JISX0208KANA -TH
* enable the routines to change kanji code which is used for overriding,
  since my last change disabled this -TH
* remove redundant/conflicting definitions of ON/OFF from HTVMS_WaisUI.h -TD
* fixes for K&R build on SunOS -TD
2000-02-15 (2.8.3dev.20)
* ifdef fixes for CYGWIN, broken in dev.19 -TD
* add make-msc.bat script, and update src/chrtrans/makefile.msc to add rules
  for generating header files -TD
2000-02-14 (2.8.3dev.19)
* use HTAddParam/HTEndParam rather than HTSprintf0 for building external
  commands, protecting against badly-formatted string with more than one %s
  (reported by PW) -TD
* update placeholder po/nl.po -JS
* add configure option --enable-kanji for defining symbols related to TH's
  patch.
* improved handling of Japanese text (patch by Hataguchi Takeshi (TH)
  <patakuti@t3.rim.or.jp>):
  + if Japanese document's charset is specified explicitly by the MIME tag or
    HTTP responses, Lynx will assume the charset as that value.
  + change the Japanese charset detection strategy when charset is not
    specified explicitly.
  + wrap a long text which includes only CJK characters in source mode.
  + avoid writing CJK characters at the 80th column.
  + improve kanji code override routine
    # My change seems to have broken this
  + change the phrase "half width kana" to "JIS x0201 Kana" in comments.
    # The latter has been used originally.
  + enable assume_charset when display charset and assume charset
    are Japanese. assume_charset acts like charset by META tag
    only when charset isn't specified by META nor HTTP responses.
  + change the behavior of the option menu.
    For example, when display charset is Japanese (EUC-JP) and
    CJK mode is on, changing assume_charset from iso-8859-1 to
    shift_jis using the option menu,
        old behavior:
            assume_charset won't be changed.
            CJK mode will turn off.
        new behavior:
            assume_charset will be changed to shift_jis
            CJK mode won't be changed.
  + improve handling Japanese in Visited Links Page, History Page
    and pages with FORM.
  New macros are:
    USE_TH_JP_AUTO_DETECT
        enable (2)
    CONV_JISX0201KANA_JISX0208KANA
        convert JIS X0201 Kana to JIS X0208 Kana,
        i.e. convert half width kana to full width.
        I've not tested the case not to define this well.
    KANJI_CODE_OVERRIDE
        enable kanji code override routine.
        The code can be changed by ^L.
        More precisely, this enables us to change the assumption kanji
        code for the document. This assumption overrides the charaset
        by META tag and HTTP responses.
* ensure lynx_doc is writable when doing install, since it is not necessarily
  done as root -TD
* simplify/correct ifdef'ing in reply_by_mail() -TD
* add ifdef CANNOT_PIPE_MAIL to simplify ifdef'ing for systems having mailers
  that we can pipe to versus those that we cannot -TD
* add ifdef USE_BLAT_MAILER to simplify & make consistent ifdef'ing for
  blat mail program -TD
* correct ifdef'ing in mailform() for Unix (report by LV, analysis by KW) -TD
* tweak lynx.cfg for better cfg2html.pl output -LP
* fix DOS makefiles for recent renaming USE_PSRC -> USE_PRETTYSRC.
  Also, change optimization flag to -O1: having experience with slow
  386 machine I see no visible difference in speed at run time, but this
  makes compilation much faster and takes less memory. Tweak INSTALLATION
  file accordingly -LP
* ifdef'd feature for generating random temporary filenames with
  EXP_RAND_TEMPNAME -TD
* remove duplicate S_xxx definitions from LYLocal.h, already in www_tcp.h -TD
* add note about building with Visual C++ -TD
* ifdef'd reference to current_codepage in LYCurses.c with PDCURSES_EXP
  rather than PDCURSES, since this variable is not found in any release
  version of PDCurses -TD
* several small fixes/adjustments to reduce warnings from lint-like program
  'antic' -TD
* fixes to compile on VMS with UCX -TD
* change LYRemoveTemp() to return a value, needed for VMS -TD
* rename intl/po2tbl.sed.in to intl/po2tbl.sed_in, to allow unzip on VMS -TD
* correct HTSetSuffix/HTSetSuffix5 for VMS build (reported by Dan W. Olds
  <oldsdw@wofford.edu>) -TD
* resync autoconf macros, from tin -TD
2000-01-06 (2.8.3dev.18)
* correction to LYCookieSavefile so tilde expansion is done (reported by Larry
  Virden) -BJP
* now it's guaranteed that LY_SOFT_NEWLINE could be only 0th character in
  line->data (it could be preceded by LY_*_START_CHAR). Bug that caused
  empty lines to disappear when printing files was fixed -VH
* comments are now correctly converted to display charset in prettysrc mode -VH
* fix "Please see" array initialization in cfg2html.pl (reported by VH, LP) -TD
* small userdefs.h typo fixed -VH
* added lynx.cfg setting that controls justification - maximum value for
  ratio of 'spaces to spread'/'max width of a line' when justification can
  take place -VH
* change "PSRC" to "PRETTYSRC" in configuration (suggested by KW) -TD
* combine a dozen of HTMLSRC_ lynx.cfg settings into PSRCSPEC setting.  Old
  "HTMLSRC_foo:bar1:bar2" should be written as "PSRCSPEC:foo:bar1:bar2" -VH
* use assume_default_colors() extension from upcoming ncurses 5.1 and related
  support to provide more flexible coloring.  If the user's configuration files
  do not specify "default", the default-color support is suppressed, and the
  displayed colors default to white/black.  The original behavior matches
  SVr4 curses, which assumes the default colors of the screen but does not
  ensure that they match the assumption -TD
* modify LYsetXDisplay() to permit $DISPLAY to have an empty value, and reuse
  logic in forms-options from menu-options as validate_x_display() and
  summarize_x_display().  The forms-options will not display a warning since it
  exits too early, but at least one may now reset $DISPLAY to an empty string
  (reported by KW) -TD
* add note in INSTALLATION pointing to aclocal.m4 for details of regenerating
  configure script -TD
* add stub "po" gettext for Czech language, update other stubs -JS
* undo dev.16 change to print_wwwfile_to_fd() logic for LY_SOFT_NEWLINE which
  resulted in dropping blank lines from printed files -TD
* make off by one correction in HTDisplayPartial line counting (as discussed
  with LP) -KW
* one invalid memory free (only reached in some (rare?) error case), two
  memory leaks removed in LYLocal.c -KW
* date calculations for file times in FTP directory listings used cached values
  for the current day and year that never got reset.  This could cause wrong
  ordering when sorting by date, and possibly other errors, especially in
  long-running lynx sessions.  Now recalculate them for each new directory
  request if they are needed -KW
* be slightly more tolerant about FTP directory listing file times that appear
  to lie in the future:  allow today plus one day without assuming that it must
  mean a year ago, to account for possible timezone differences -KW
* add comment to reload_read_cfg() listing things that are/aren't done -LP
* minor lynx.cfg corections for better cfg2html.pl output -LP
* restore 'from_source_cache' PRIVATE to LYMainLoop.c, add comments -LP
* amend dev.16 feature for generating random temporary filenames to ensure that
  Lynx does not currently have the generated name open as a temporary file -TD
1999-12-15 (2.8.3dev.17)
* add a caution to jumpsUnix.html -PW
* ifdef LYEditKeyForAction() to compile when EXP_ALT_BINDINGS is not defined
  (reported by VH) -TD
* add 3-valued DEFAULT_KEYPAD_MODE to lynx.cfg -TD
* revert DEFAULT_KEYPAD_MODE to NUMBERS_AS_ARROWS (consensus) -TD
* add COOKIE_SAVE_FILE lynx.cfg and corresponding command-line option, default
  it to /dev/null, which is recognized on all systems -BJP
* correct typo in declaration of LYLeakSAVsprintf() -Michael Warner
* remove from_source_cache_p parameters in LYMainLoop.c (request by LP) -TD
* documentation updates covering the Options Menu & other changes omitted
  previously -PW
* small correction in TRSTable.c:  One of my previous changes for TRST broke
  inheritance of alignment for cell contents from TR elements -KW
* new functions for keeping track of temp files (and some other files) for user
  interface pages:  LYRegisterUIPage(), LYIsUIPage().  Most checks that look at
  the loaded document's title have been replaced by this mechanism.  This also
  replaces various mechanism that were implemented for some specific pages -KW
* also replaced some more checks that looked at the document's title by checks
  of the address, for pages that are always identified by a special URL scheme
  (LYNXCOOKIE:, LYNXKEYMAP:, LYNXMESSAGES:) -KW
* now check directly in postoptions() whether the loaded document is one from
  which submission of option changes can be accepted, using the new tracking
  mechanism.  Only the form-based Options Menu and Visited Links are allowed.
  Relying on a good random generator to prevent spoofing is not necessary.
  Kept the secure_string check, but it should be only regarded as an aid to the
  user, it prevents changing options from an instance of the form-based Options
  Menu that is not the most recent one (this can happen if an Options Menu page
  is pushed on the history stack and later returned to) -KW
* honor REUSE_TEMPFILES for some more user interface pages.
* prevent an obscure LYNXOPTIONS://MBM_MENU crash.
* other minor additions and corrections to checks for special pages -KW
* changed INSTALLATION text for --enable-internal-links -KW, HN
* changes to build dev16 with color styles on DJGPP/PDCurses 2.3
  (you must uncomment a line in makefiles to build lynx that way) -LP
* correct a missing check in HTML.c HTML_A case against force_empty_hrefless_a
  (reported by KW) -VH
* changed lines -> disp_lines, cols -> disp_cols in GridText.c -KW
* don't reparse with SOURCE_CACHE if screen size changed only
  vertically (disp_lines).  Also don't reparse unnecessarily in
  some cases of LYK_MINIMAL -KW
* don't append (HEAD) to title for INFO screen if already present -KW
* set newdoc.title to curdoc.title in LYMainLoop.c for SOURCE command.
  Otherwise INFO could show the wrong document's title -KW
* made global from_source_cache PRIVATE to mainloop -KW
* reset DIRED_MENU item list when lynx.cfg is reloaded -KW
* new lynx.cfg option AUTO_UNCACHE_DIRLISTS for Dired mode, see lynx.cfg -KW
* prevent file descriptor and inode leak in HTFWriter.c that occurred if
  the same resource is repeatedly downloaded (for 'd' or for passing to
  a viewer) -KW
* corrected logic for suppressing last HTDisplayPartial call at end of file,
  after discussion with LP -KW
* corrected line counting in HTDisplayPartial, taking into account offsets used
  for the various variables being compared -KW
* added confirmation prompt for reloading non-safe post_data documents in
  form-based Options Menu change handling.  Before this change, the prompt
  would be issued after returning to mainloop() instead, with different
  behavior if confirmation was denied:  The document would be popped instead of
  keeping the current instance -KW
* function confirm_post_resub made PUBLIC and moved to HTAlert.c.  New function
  srcmode_for_next_retrieval in LYGetFile.c.  Both used for the above and in
  LYMainLoop.c -KW
* fixed behavior for various post_data confirmation prompts in connection with
  SOURCE_CACHE in LYMainLoop.c.  Before this change, the user would be prompted
  to confirm reloading, yet on confirmation reparsing from the source cache
  would be attempted.  So prompts were unnecessary and misleading -KW
* try to handle some failures of errors in source cache reparsing better.  Try
  to make sure that unsafe post_data documents don't get reloaded accidentally
  without confirmation if source cache reparsing fails.  Treat partial data
  (i.e.  loading from source cache probably 'z'apped by user) as successful, as
  HTLoadDocument does.  (Various error conditions are currently only passed on
  to the caller by HTParseFile, not by HTParseMem.  I left this apparent design
  decision unchanged.) -KW
* source cache reparsing did not rewrite a previous cache copy when the
  document was reloaded from the net.  This means that e.g. NOCACHE or RELOAD
  would force reloading from the network, but then on the next non-forced
  loading of the document (e.g.  by toggling to SOURCE view) the old (and
  possibly stale) copy would again be used.  Now the newer copy replaces the
  old copy if loading is successful (and not interrupted or aborted with 'z').
  (Note that RELOAD while in source view, at least in the normal one without
  -preparsed or -prettysrc, does not have this effect since the document does
  not get pushed through the cache writer at all in that case.) -KW
* if a source cache copy for a document exists, we need a way to ensure that
  reparsing from that copy does not try to rewrite that same copy "under our
  feet" while still reading from it.  Previously that was done by just never
  rewriting an existing source cache.  After changing that (see previous item),
  a different approach is needed to prevent such collisions.  This is now
  solved in two ways:  (a) Base a temporary new file or memory chunk for
  writing, and only commit it to the doc's ParentAnchor object (replacing the
  previous copy) at the end of the incoming data stream.  This is done in
  CacheThru_free(), but not in CacheThru_abort(), meaning that an interrupted
  or otherwise aborted transmission will not replace an existing cached copy
  with a truncated now version - as long as such interruption gets detected and
  properly indicated, which is not the case for reading from the source cache
  with SOURCE_CACHE:MEMORY in effect, see above.  (b) Change the
  HTParentAnchor's protocol field to indicate a non-HTTP protocol, before
  starting to load from source cache in HTreparse_document().  Normally, as
  long as DEBUG_SOURCE_CACHE is not defined, this prevents the cache writer
  from (re)generating a cache copy.  Mechanism (b) isn't necessary (everything
  still works when DEBUG_SOURCE_CACHE is defined), it just avoids unnecessary
  work -KW
* source cache files and chunks were not always being removed when they should,
  probably since change of 1999-06-18.  A large number of cache copies could be
  kept around unnecessarily wasting disk or memory space.  Now make sure that
  the source cache copy gets removed when a document is removed from the cache
  of rendered docs.  They would never be reused anyway.  New function
  HTAnchor_clearSourceCache.  Note to other developers:  HTAnchor_delete()
  doesn't always remove the HTParentAnchor object, see its implementation -KW
* detect errors during appending to the cache copy.  Previously, memory
  allocation errors (for SOURCE_CACHE:MEMORY) would cause program exit, and
  file write errors (SOURCE_CACHE:FILE, e.g. if the temp disk space was full)
  would go undetected and leave the cache file corrupt or truncated.  Now allow
  the program to continue normally, just cancel the source cache generation for
  the current document (which may free up enough memory or disk space to remedy
  the immediate problem).  Produce an alert message.  In the case of a file
  error, produce the alert only once until a possibly re-reading of lynx.cfg,
  since Lynx should remain otherwise functional in the face of cache file
  writing errors -KW
* extended HTChunk: added a variant for which memory allocation errors
  are not fatal.  Used for changes described in previous item -KW
* don't write raw escape sequences to trace output for lynx-keymaps if
  not using trace log file -KW
* protect echo() in stop_curses, it could crash if stop_curses gets called
  without preceding start_curses -KW
* save size for regular files in anchor structure (we do the stat() anyway).
  It shows up on INFO page as Content-Length.  Also use it in partial display
  mode to prevent the last call to HTDisplayPartial from HTFileCopy, since a
  call to HText_pageDisplay will follow immediately.  (But note that nothing
  important depends on the correct size; should it be wrong, we lose at most
  one partial display screen update.  An equivalent suppression of the last
  partial update for network protocols is not recommended, since (a) the size
  is more unreliable and (b) the socket FIN may be delayed by the network.) -KW
* split HTMIME_put_character into three functions -KW
* made HTMIME.c handle folded header lines correctly (long-standing bug,
  reported in February by Devid Coles) -KW
  [ reference: http://www.flora.org/lynx-dev/html/month0299/msg00135.html ]
* changed how HTTP redirection messages are handled.  Don't read full message
  and parse buffer for some header fields in HTLoadHTTP.  Use common HTMIME.c
  header parsing instead.  Functions added/modified in HTMIME.c for storing
  away the Location URL (if requested and found) and for stopping after the
  headers.  New private MIME types "message/x-http-redirection" and "www/debug"
  to control this via HTStreamStack.  Basic approach taken from newer W3C
  libwww.  Benefits:
  - Removes actual bug that was reported: "Content-Location:" was falsely
    recognized as "Location:". (long-standing bug)
  [ reference: http://www.flora.org/lynx-dev/html/month1199/msg00370.html ]
  - Removes potential other bugs caused by inferior header parsing in HTTP.c
    (including Set-Cookie/Set-Cookie2).
  - Should more header fields be needed in the future (also) for redirection
    messages, we now get them automatically instead of having to add extra
    code.
  - Trace output now shows the same kind of info as for other responses.
    In particular, Set-Cookie/Set-Cookie2 header fields will normally be
    visible.
  - Statusline progress messages now actually show the HTTP response line
    as intended, and it is recorded for LYNXMESSAGES:. (Long-standing error,
    previously what was shown could be an empty string, or arbitrary parts
    of the response, including HTML markup from the message body.)
  - Adding redirection support for lynxcgi would now be simpler (although
    currently not done) -KW
* HTErrorStream(), similar to W3C libwww, used in some cases for the above -KW
* remove check in HTParse() dated 98/09/08 which prevented unescaping of 8-bit
  data (reported by KW)
* refresh screen for TRST changes in partial display mode as early as possible.
  This fixes a problem when the table finished below the screen bottom -LP
* remove global Newline_partial, use LYGetNewline() instead -LP
* adapt idea by VH as a Perl script cfg-html.pl which generates HTML form of
  the lynx.cfg documentation -TD
1999-11-30 (2.8.3dev.16)
* added -nozap command line option -KW
  - In its basic form, it disables all checks for 'z' or ^G or other
  "immediate" keys that otherwise happen while processing a request (for name
  lookups, before or during loading of a document).  Note that it also disables
  paging through an incompletely loaded document during "partial display".
  Normally, i.e. without this option, key input gets "swallowed" or "used up"
  by the quasi-asynchronous checks even if they are not 'z' etc.  or keys that
  have meaning during partial display (meaningless keys just get ignored).
  With this option, key input only gets read when lynx is ready to act on it.
  - This can be used (a) by people who like to always have predictable
  type-ahead (and don't care for 'z'apping and partial display scrolling), (b)
  to achieve predictable reaction to keys if lynx is used under some scripting
  environment that feeds it input like expect, and (c) for scripting a lynx
  session by feeding it keyboard-like character input via input redirection
  from a file or pipe (a simpler alternative to b, without the need for expect
  or similar).
  - Point (c) could be called "poor man's scripting".  Note that the input has
  to be provided in a raw form (as lynx would see it when it is actually sent
  by keys), including raw control characters and escape sequences if necessary.
  This patch does not change anything in the way such input is read and parsed,
  other that what is explicitly described here.  (This paragraph is only here
  to explain the context, it does not describe new features.) P.m.s.  will only
  work as expected if lynx, on a given platform and with the display library
  chosen, uses standard input for reading keyboard input.  This is the case
  with ncurses and possibly other curses implementations, but not with slang,
  on Unix-like platforms, and cannot work on platforms where lynx gets keyboard
  input in the form of platform- or implementation-specific keycodes (DOS,
  Windows - except with cygwin?) instead of as an octet stream.
  - The -nozap option takes an argument.  The basic functionality as already
  described gets invoked if the argument is not a specially recognized keyword
  (it is suggested that -nozap=full or -nozap=all be used).  The only
  recognized keyword is "initially".  With -nozap=initially, additional special
  behavior is invoked the first time (and *only* the first time) when lynx
  encounters an error or EOF when reading key input.  (Currently this will not
  get detected if slang with USE_KEYMAPS is used.) In this, case, -nozap
  reverts to the default state ('z' will be checked for again).  Under some
  conditions are true (key input was taken from stdin, and stdin was not
  connected to a terminal), lynx will then attempt to reopen stdin, connecting
  it to a terminal (stdout, stderr, and the process's controlling tty are
  tried, in that order - this is subject to change if something would be more
  reasonable).
  - The -nozap=initially special behavior will get triggered if input comes
  from a file or pipe (p.m.s.  above) when the provided characters are "used
  up".  Normally lynx should then just exit.  The special behavior hands
  control of the session to the interactive user instead at that point.  All
  code for -nozap is only compiled in if preprocessor symbol MISC_EXP is
  explicitly defined.
* ifdef'd some places for MINGW32 (diffs from Victor Schneider)
* remove 'host' variable in LYGetHostByName() that obscured module-level
  'host[]' array in HTTCP.c for _WINDOWS_NSL configuration (patch by HS,
  discussion by KW) -TD
* the Newline variable is now PRIVATE except the mouse code in LYStrings.c -LP
* modify HTDOS.c for Wattcp targets (Watt-32 and original wattcp).  When Lynx
  is sitting idle in getxkey() waiting for a keypress, no network functions are
  called.  Hence no sockets are processed, "ICMP Echo replies" is sent etc.
  This patch has been tested with SLang and '-DDJGPP_KEYHANDLER' I'm not sure
  how to hook into 'SLkp_getkey()' or keyboard polling in performed under raw
  PDCurses (Gisle Vanem <gvanem@eunet.no>)
* update docs for -tna instead of --sticky_inputs -KW
* document extended KEYMAP syntax in lynx.cfg -KW
* update Users Guide for KEYMAP changes, especially the TEXTAREA-related
  sections -KW
* move text on ^V a bit to better place, provide a couple links to it -KW
* add blurb about TRST to Users Guide.  Also mention external scripts for table
  handling -KW
* revise section in Supported URLs on internal schemes.  Toned down, provide
  rationale, give examples -KW
* fix a few typos in README.TRST -LP
* use 'rand()' in NewSecureValue() -TD
* use a random number rather than a counter to name temporary files -TD
* change LYReadCFG.c to accept any leading punctuation in lynx.cfg as a comment
  delimiter -TD
* eliminate some clutter with typecalloc/typecallocn macros -TD
* eliminate some clutter with new function LYBadHTML() -TD
* add checks for null pointers in CTRACE statements in HTML.c (based on report
  by LV) -TD
* change realloc calls in SAVE_TIME_NOT_SPACE ifdef in StrAllocVsprintf() to
  HTalloc, since older machines (e.g., SunOS 4.x) do not necessarily handle a
  null pointer parameter to realloc -TD
* correct ordering of command-line options in LYMain.c -TD
* updates for files in lynx_help & keystrokes -PW
* clarify `General Configuration Instructions (all ports)' in INSTALLATION -PW
* remove "your lynx.cfg"/"compiletime settings" from '='Info Page -LP
* add a note to Lynx_Users_Guide.html#lynx.cfg on "g lynxcfg:" -LP,HN
* change LYNXCOMPILEOPTS: to a link from LYNXCFG:  -LP
* slightly reorganize partial mode logic:  'display_partial' variable is now
  initialized directly in HText_new(), no need for specialized semaphore any
  more -LP
* Allow KEYMAP directives in lynx.cfg of extended form
  KEYMAP:lynxkey:lynxaction:editaction[:sel], where lynxkey and lynxaction are
  as before, editaction is a line-editor action like FORW, BACK, ERASE etc.
  and sel selects the line-editor style to be affected (as a number, starting
  with 1 for the Default Binding; or 0 for all styles (the default); or a
  negative number -n meaning "all line-editor styles except n").  See Line
  Editor Help pages for keywords to use as editaction.  This includes PASS
  (which was already implemented), for "passing" on the key when line-editing
  form fields so that the normal lynxaction will be invoked.
  (KEYMAP:lynxkey:lynxaction:DIRED is also still possible for defining a Dired
  mode binding).
  This is based on a patch from IZ which introduced combined definitions
  in a .lynx-keymaps file in the form:
     setkey "\200s" LAC:LEFT_LINK/BACKW     # C-left
     setkey "\200t" LAC:RIGHT_LINK/FORWW    # C-right
  Combined definitions in .lynx-keymaps are also supported in this patch, but
  the syntax was changed to use another ':' instead of '/' as separator.  Note
  that there is no need to support .lynx-keymaps (i.e., compile with
  USE_KEYMAPS defined) for using the extended KEYMAP lynx.cfg directive with
  this patch -KW
* avoid access to uninitialized members in TRSTable.c -KW
* limit span values accepted for TRST with TRST_MAXCOLSPAN and TRST_MAXROWSPAN,
  which can be changed in userdefs.h.  Without imposing a limit, attempts to
  trick lynx into allocating huge blocks of memory (which might cause thrashing
  without apparent reason) with something like ROWSPAN=10000000 are just too
  easy -KW
* moved definition of SAVE_TIME_NOT_SPACE to userdefs.h.  You may want to
  undefine it for a platform where running out of memory is a frequent problem
  (DOS?), although the effect won't be very pronounced.  Used in TRST code to
  affect size of some allocations (also used as before for HTSprintf0/HTSprinf)
  -KW
* implement COLSPAN=0 and ROWSPAN=0 according to HTML 4.01 (not HTML 4.0).  The
  span extends until the end of the current column group and row group (i.e.
  next THEAD/TFOOT/TBODY), respectively; or until the end of the row or table,
  respectively, if there is no containing group (thus acting as per HTML 4.0).
  Also cancel effect of all ROWSPANs at a THEAD/TFOOT/TBODY boundary (problem
  with other browser described and behavior proposed by G.  James Berigan in
  <http://www.war-of-the-worlds.org/html/span-vs-group.html>) -KW
* 'prev_target' is now PRIVATE to LYMainLoop.c [defined outside of mainloop()];
  this undoes some dev.15 changes.  -LP, KW
* replace HText_pageDisplay() calls from partial mode (LYUtils.c and
  HTFormat.c) with LYMainLoop_pageDisplay() function implemented in
  LYMainLoop.c, it simply calls HText_pageDisplay() but has access to
  LYMainLoop.c PRIVATE variables.  -LP, KW
* make ^X a prefix key in all Line Edit styles.  That means ^V should never be
  needed any more to invoke the special textarea commands (but it's still
  supported).  Updates to help files to reflect this change -KW
* don't produce a link from the KEYMAP page to a help file.  The one we used to
  use doesn't really help -KW
* correction in code executed after textarea external editing (that determines
  when to prompt for re-wrapping):  use start_anchor not anchor_ptr.  Without
  this correction, invalid memory access could occur.  (This was probably also
  responsible for producing the prompt when it shouldn't be produced in some
  cases, as has been reported.) -KW
* some tweaks of Novice mode help lines:  don't show wrong key "to delete all
  text in field" (FORM_NOVICELINE_TWO); replaced an occurrence of <delete> with
  <backspace>.  In some cases (e.g., disabled fields), prefer no info to wrong
  info -KW
* extended KEYMAP option:  additional field can specify DIRED to request
  mapping in the Dired mode key_override table rather than the normal keymap
  table.  Documented the DIRED field and default override mapping in lynx.cfg
  -KW
* corrected KEYMAP display for dired mode.  It could display the normal binding
  when that wouldn't actually be used, for example if a key is bound to
  DO_NOTHING for DIRED.  The logic deciding whether to show a separate line for
  uppercase letters was only looking at the normal keymap -KW
* reset the edit_mode flag (indication of Dired mode) in various places, so the
  flag doesn't stat TRUE after a new page has been loaded.  For example,
  invoking the forms based 'O'ptions page from a Dired directory view would
  leave the Dired key bindings enabled within the Options page -KW
* for LYNXMESSAGES:  page of recent statusline messages, removed setting of the
  LYforce_no_cache flag in getfile().  Set the flag in LYMainLoop.c instead,
  but only for following a link.  This makes the page act more like a normal
  no-cache document, for example returning to it via PREV_DOC does not cause an
  automatic update.  The special handling in LYMainLoop.c is necessary because
  the link to LYNXMESSAGES:  appears on the History Page, and following a link
  from the History Page (as well as some other generated user interface pages)
  normally implies overriding of no-cache behavior which we don't want in this
  case -KW
* in LYNXMESSAGES:  page, number recent statusline messages in historic order,
  starting with 1 for the oldest.  This should make it more obvious that they
  are listed latest-first.  Add "(No messages yet)" text if there are no
  messages.  Removed generation of invalid <pre> -KW
* use a temporary file instead of the normal .lynxrc file for saving and
  restoring current settings in reload_read_cfg().  This avoids unexpected side
  effects of lynx.cfg reloading (LYNXCFG://reload action), i.e.  silent
  modification or first-time generation of .lynxrc contents.  In principle this
  should make reloading of lynx.cfg usable for accounts that don't allow saving
  of personal settings (i.e.  option_save restriction, implied by -anonymous)
  if other restrictions don't forbid it; but currently the option_save
  restriction is still obeyed for saving to the temporary file (so that
  reloading of lynx.cfg is prevented) -KW
* tweaks for LYNXCFG:  and LYNXCOMPILEOPTS:  pages:  honor REUSE_TEMPFILES
  setting if pages need to be regenerated, and clean up the memory for holding
  the file URLs in free_lynx_cfg().  Recover if the tempfile has unexpectedly
  disappeared, by regenerating it.  Also regenerate tempfile if NOCACHE key
  ('x') is used.  Added extra checks before doing automatic uncaching of
  previous page in LYNXCFG://reload code, to test whether the previous page is
  really a LYNXCFG:  view -KW
* corrected problems with "show color" in forms Options page.  Omit "ON" choice
  if color is not possible (but saving allowed).  When option_save restriction
  was in effect, the ON/OFF initialization was wrong (resulting in unwanted
  toggling of color each time options were changed in an anonymous account) -KW
* tweaks of reload_read_cfg() for retaining "show color" setting and for
  updating display_lines (user_mode may have changed) -KW
* change for HTParse: if there is a hostname part, recognize a '?' as ending
  it if there are no further slash characters -KW
* tweaks in configure.in and INSTALLATION: describe correctly what
  --disable-dired-override does.  Rename --disable-dired-archive to
  --disable-dired-dearchive.  Clarified INSTALLATION text for
  --disable-full-paths.  Changed some "define" to "prevent defining" -KW
* don't try to put cursor in last screen position for hiding in
  show_main_statusline if -show_cursor/SHOW_CURSOR is on.  The show_cursor
  behavior may have been turned on to avoid problems with curses libs or
  terminal types that cannot deal with it correctly.  On pages with no links,
  for example SOURCE display, this may leave the cursor at the end of the
  statusline message if show_cursor is on.  This just restores previous
  versions' behavior in that case.  On pages with links, the movement is
  unnecessary anyway since the cursor will move again to the current link -KW
* removed a bug in automatic textarea growing.  Textarea would grow by
  one line unnecessarily if enter was used on the last input line on a
  screen (if that was not actually the last line in the textarea).  New
  function HText_TAHasMoreLines() to help with this -KW
* revision of "nonsticky" behavior / options.  Got rid of "sticky" terminology.
  Renamed the controlling option to TEXTFIELDS_NEED_ACTIVATION and command line
  flag -tna.
  Compiling in of this mode can be disabled, see in userdefs.h under
  TEXTFIELDS_MAY_NEED_ACTIVATION.  Two versions of "Textfields Need
  Activation" mode are provided.  The default mode (simpler yet better IMO)
  highlights an inactive selected text input fields like a current normal
  anchor.  The alternative variant (may go away later?) behaves like VH's
  previous implementation and gets used when compiling with
  -DINACTIVE_INPUT_STYLE_VH.
  Many bugs that would occur in somewhat unusual circumstances are fixed, for
  both variants.  (Action of various commands on TEXT_SUBMIT_TYPE fields,
  interaction with mouse selection, ...) Selecting an inactive input field with
  the mouse will activate it.  Various tweaks to make sure selecting a field in
  this way will put the editing cursor at the right position (even if the line
  had been scrolled / might be scrolled on entering the line editor), at least
  with NCURSES mouse support.  Also, -show_cursor now in general works as
  expected.  (In the INACTIVE_INPUT_STYLE_VH variant, cursor may sometimes end
  up on the statusline after error messages.) -KW
* treat input lines of the same textarea more like one entity, as far as
  "Textfields Need Activation" is concerned, as long as movement among those
  lines is with PREV_LINK/UP_LINK/LPOS_PREV_LINK/NEXT_LINK/DOWN_LINK/
  LPOS_NEXT_LINK or ACTIVATE keys (the last one only if TEXTAREA_AUTOGROW is
  defined, for consistency with line-appending behavior).  I.e.  moving among
  textarea lines with those keys automatically activates ('enters') the new
  field for line editing if the previous one was activated -KW
* modified statusline messages to be more appropriate and specific on non-
  activated form fields.  (The additional messages are not used or compiled
  in if TEXTFIELDS_MAY_NEED_ACTIVATION isn't defined.)  Avoid unnecessary
  repainting/refreshing of the physical statusline in many cases of moving
  among fields and links.  Make sure the additional lines shown in Novice
  mode are also appropriate -KW
* modified line editor behavior on "disabled" form text fields:  instead of
  disabling all non-terminating edit keys, allow those that never modify the
  field contents.  The user can now scroll through a long value in a disabled
  field with the arrow keys, rather than being stuck at the end -KW
* the ncurses mouse popup window would overlap the statusline in Novice mode.
  Limit the overlap to border area (so at least no significant text gets
  corrupted) -KW
* modified code for stickiness of the second kind (ex-STICKY_FIELDS) according
  to preliminary proposal from Vlad.  Named LEFTARROW_IN_TEXTFIELD_PROMPT.
  Does not depend on any conditional compilation symbols, and is now unrelated
  to the other kind of "stickiness" discussed above.  See lynx.cfg.  This isn't
  optimal yet (LAKABOFTIF discussion etc..), but better than leaving it as it
  was -KW
* made default width of textarea fields (if no COLS attribute given) depend on
  window or screen width, instead of using a fixed default of "60".  I.e.  for
  wider windows make better use of available space, and for narrows windows
  avoid wrapped textarea lines.  Take the usual left/right margins (depending
  on current block style) into account.  But for -dump don't make fields longer
  than 60 anyway (they will just show up as blocks of underscores anyway, not
  showing text content) -KW
* changes in code used to create new bookmark file after a bookmark has been
  'R'emoved.  Change should only affect Unix.  Basically, revert back to
  behavior used before 2.8.1dev.8 for "normal" files (no symlinks or extra
  hard links).  I.e. use rename / maybe try "mv" instead of "cp", then change
  permission bits explicitly.  Using "cp" means running the risk of losing or
  truncating the user's bookmark file if for example the disk became full
  (although these occasions should be rare - the scratch file we are trying
  to copy or rename was written just before without error, usually on the
  same filesystem).  Some more comments in LYBookmark.c.  Note: if you like
  your bookmark files, make backup copies of them anyway... -KW
* changed F1 key bindings so it always invokes DWIMHELP, also in the Line
  Editor (for all three Binding tables).  This means that pressing F1 (if you
  have it, and it is correctly mapped and recognized) while in a text form
  field will now bring up the Line Editor Help Page for the currently selected
  line edit style.  Other keys bound to HELP by default ('?', 'h') remain
  unchanged, they still always go to the main Help Page -KW
* don't let DWIMHELP show Line Editor help for a text input field that is
  disabled -KW
* don't mangle a -cookie_file like /home/user/.lynx_cookies.~1~, only interpret
  the '~' as reference to HOME if it's right at the beginning and followed by
  '/' and then some more.  There are probably other instances where '~' gets
  mistreated (in addition to the intentional dropping of "user" from something
  like "~user/" in file URLs etc.) -KW
* changed type of EXP_KEYBOARD_LAYOUT tables to LYKbLayout_t.  They hold
  Unicode values, any similarity to LYKeymap_t is just accidental -KW
* changed EXP_KEYBOARD_LAYOUT logic so that input characters that are
  unrepresentable in the current display character set (unless it is UTF-8) get
  transformed into '?' instead of some accidentally chosen 8-bit character.
  For UTF-8, convert to UTF-8 encoding instead.  Note the Line Editor isn't yet
  UTF-8 aware; with some care it is possible to enter UTF-8 text, but the
  display will be messed up, esp.  the cursor position will be shown wrong -KW
* some corrections for TPOS, YANK enhanced lineedit functions -KW
* added back in a block in LYmbcsstrlen that got lost somehow -KW
* fix an array boundary accident in GridText.c -JB
* reiterate that LYNXCGI_LINKS is set by the configure script -PW
* note that patches should be generated by "diff -u" -PG
* modify HTReadProgress so that setting SHOW_KB_RATE false will let the
  amount read be shown in bytes/sec -DK
* modify mkdirs.sh to ignore DOS-style device -IZ
* modify CF_PATH_SYNTAX configure macro to accept DOS-style path syntax, for
  use in OS/2 EMX port -IZ
* fix some memory leaks in visited-pages tree -IZ
* correct recent change to LYEditmap.c for EBCDIC -PG
* change 'elf32ppc' to 'elf32ppc*' in config.guess to work on MkLinux DR3
  (reported by Christopher Conrade Zseleghovski (kkz@MIMUW.EDU.PL>)
* add check to HTConfirmDefault() to ensure that NLS form of "yes" and "no"
  are distinct in the first character, revert to English if not -TD
* add configure test for wredrawln, and use CF_CURSES_FUNCS -TD
* improve CF_TERMCAP_LIBS configure test -TD
1999-11-17 (2.8.3dev.15)
* add popup in options menu to control alternate organizations of the
  visited links page -IZ
* reformatted src/makefile.dos and src/makefile.dsl to make them simpler to
  modify -TD
* add -DOK_OVERRIDE to DIRED_DEFS for djgpp -LP
* change the samples in "URL Schemes Supported in Lynx" so they would appear
  without //user:passw@ but //user@ with the explanation of yet another
  possibility added in words...  So user will not get a wrong impression if
  reading that document not so carefully (you know, samples are so easy
  remembered without details), -KW, LP
* ifdef bkgd() call in force_repaint that accommodated pre-ncurses 4.1 bugfix,
  from early 1997.  With current code, a ^L when a popup is displayed causes
  the screen colors to be reset (reported by KW) -TD
* undo recent no_color_video check for A_BOLD, A_UNDERLINE since this did not
  have the intended effect (reported by KW) -TD
* add note to lynx_url_support.html about lynxcgi -PW
* add user search in partial mode (while loading of the document is in
  progress).  Scrolling to the string in question is not working properly yet
  if you repeat 'n' next time.  More work required -LP
* improved makelynx.bat (<vtailor@gte.net>)
* fixed bug that corrupted memory (resulting in crashes) in situations when
  line ends with LY_SOFT_HYPHEN -VH
* correct comment in userdefs.h regarding renaming of
  LINKS_AND_FORM_FIELDS_ARE_NUMBERED to LINKS_AND_FIELDS_ARE_NUMBERED and
  change DEFAULT_KEYPAD_MODE to LINKS_AND_FIELDS_ARE_NUMBERED -PW
* fix bug that caused lss-enabled lynx to crash on growing textarea or
  inserting file into it -VH
* new lynx.cfg option REFERER_WITH_QUERY:[SEND|PARTIAL|DROP] -KW
* don't send Referer if we have to load a document again that we got
  from the history stack.  Lynx would send the URL of the current
  document (the one "later" in history) which could only accidentally
  be right -KW
* changed default for PERSISTENT_COOKIES from TRUE to FALSE, since
  persistent cookie support is now configured in by default -KW
* new functions (key_for_func_ext) to return a "best" key (or key pair) to
  invoke a given lynx  action, either in the Line Editor or in normal mode.
  Currently only used for a couple of statusline messages (those that had ^V
  hardcoded).  The statusline info while in a textarea now gives the right
  key(s) for invoking external editing, or omits the info if appropriate
  (no key bound, or no editor defined or allowed) -KW
* doc updates for TEXTAREA special functions -KW
* moved #defines for TEXTAREA_EXPAND_SIZE, AUTOGROW, AUTOEXTEDIT from
  LYMainLoop.h to userdefs.h, the latter two renamed to TEXTAREA_AUTOGROW
  and TEXTAREA_AUTOEXTEDIT, added description -KW
* minor tweaks: -accept_all_cookies help string, some formatting changes,
  minor text additions and corrections -KW
* set $(PROG_EXT) variable in makefiles for cygwin -TD
* define __CYGWIN__ if needed, e.g., for betas that define __CYGWIN32__ -TD
* workaround cygwin b19.1 problem generating cfg_defs.h because it did not
  properly export $PATH -TD
1999-11-03 (2.8.3dev.14)
* modify no_color_video check for A_UNDERLINE so it is active for any
  combination that uses underlining (reported by KW) -TD
* modified HTML.c so configure --enable-internal-links builds -TD
* improved 'lynx.patch' rule in makefile.in -PG
* add rough version of makelynx.bat for use with Khan's MingW32 (from Victor
  Schneider <vtailor@gte.net>)
* update dependencies in makefile.bcb for src/TRSTable.c -HS
* fix PDCurses ifdef's in LYCurses.c to work with WATT-32 -DK
* correct ifdef's in LYPrint.c so that send_file_to_mail() works with DJGPP -DK
* modify DOS makefiles for PDCURSES for watt-32 and some of the other recent
  changes to lynx.  Included some of the EXP_ defines that DOS users may want.
  Changed the -O3 back to -O2, since -O3 has no advantage under djgpp -DK
* remove a useless ';', use FREE() instead of free() - JB
* correct spelling lexem/lexeme (reported by KW) -TD
* split-out function check_history() in LYMainLoop.c -TD
* add configure check for vasprintf -TD
* add configure check for _GNU_SOURCE -TD
* minor fixes for configure script macros CF_TERMCAP_LIBS, CF_DISABLE_ECHO,
  CF_GCC_ATTRIBUTES, CF_GCC_WARNINGS -TD
* fixed bug in psrcmode code.  Now htmlsrc_tag encloses only tagname, not
  everything in generalized brackets <,>,</,/> (reported by KW) -VH
* fixed a bug with 'g' command (reported by KW) -VH
* default value for 'OPT' in SGML.c made '1', removed alternatives to code
  surrounded by #if OPT1
* notes (VH):
  + Seems that 'OPT' stuff doesn't contain errors. Let's enable it for several
    releases, and then remove alternative code.
  + Added comments about pools.
  + Docs updated to reflect new functionality of -dont-wrap-pre
* old psrcview bug fixed  - markup was unbalanced in some situations -VH
* content of SAMP tag made justifiable -VH
* implemented HTStyleChange pooling - sizeof(HTStyleChange) is 4 times smaller
  than before, and only necessary number of stylechanges is allocated now,
  instead of some constant (1024 by default) -VH
* functionality of dont-wrap-pre improved and extended. Now it's possible to
  avoid wrapping the document being dumped completely (size of the non-wrapped
  line before the patch was limited by MAX_LINE = 1024 by default). Specifying
  -dont-wrap-pre with interactive session enables wrapped lines (in PRE) to
  be marked as in source view - with '+' in normal view -VH
* functionality of -force-empty-hrefless-a was cleaned up,
  #ifndefs NO_EMPTY_HREFLESS_A and endif's were removed -VH
* colorstyle changes are not emitted in HTML_end_element if me->skip_stack was
  >0 on entry to this function. This caused some glitches if
  -force-empty-hrefless-a was enabled -VH
* LYPrettySrc.c was slightly cleaned up, added support for lynx.cfg reloading,
  memory deallocation -VH
* possible bug in print_wwwfile_to_fd fixed - when quoting the page, seems that
  several '>'s could be emitted on the long line formed by concatenating lines
  with LY_SOFT_NEWLINEs at the begining of them -VH
* general notes -VH:
  + users of lss-enabled lynx should consider on upgrading the lynx - at least
    those who use lynx for viewing huge files.  By default, each line on the
    screen took 1K for colorstyles (on x86).  With new approach colorstyle
    changes take 24 bytes (on x86) per line in average document.  Old lynx with
    900K html file loaded as startfile occupied 30M of virtual memory, lynx
    with patch applied occupied 5 Mb on the same file.  Old code is still
    accessible by defining OLD_STYLECHANGE.
  + I spent 4 hours debugging attempting to write/fix code that cleans up the
    memory allocated in LYPrettySrc.c, but Lynx.leaks shows that I didn't
    succeeded.  I fear that leak detection stuff is broken - I checked/traced
    the code very carefully several times.
> the remainder (most) of this patch from KW:
* for confirmation prompts (HTConfirm), also accept English letters 'Y', 'y',
  'N', 'n' as responses.  If characters different from those are derived from
  the first letters of the translation of "yes" and "no" in a localized lynx,
  the latter will still be the ones that appear in the prompt text and will
  have precedence.  Message translations using multibyte character sets should
  continue to *not* translate "yes" and "no".  Added a note to that effect.
* small update for some chartrans tables, minor comment changes.
* for Unix, use LYSystem instead of system for invoking telnet, rlogin,
  rtn3270 commands.
  [ For some non-Unix systems, LYSystem messes around with the passed command
    string in various ways, and does some other stuff for DJGPP.  So no change
    for those, since I assume it worked before.  For Unix the change prevents
    the following occurring with ncurses (at least if USE_SIGACTION is
    defined):
     - access some (valid) telnet://some.host URL.
     - within telnet client, escape to command level (usually '^]')
     - suspend (usually 'z' or ^Z)
     - resume (fg).  Lynx process gets woken up, redraws lynx screen,
       screen & tty state get messed up. ]
* another tweak for display refreshing when text previously displayed
  had UTF-8 (for ncurses) - a check in display_page was missing.
* corrected stupid problem in LYGetFileInfo - invalid memory access.
* corrected and extended handling for textarea INSERTFILE and EDITTEXTAREA
  (or DWIMEDIT), the previous patch wasn't quite right:
  - now really truncate very long lines as intended for INSERTFILE, instead of
    wrapping with loss of one character.
  - for EDITTEXTAREA (DWIMEDIT), implement wrapping instead of truncation
    (Rationale for the difference:  user's editing work shouldn't be lost if we
    can avoid it; it is only temporarily stored in a file which may be
    unrecoverable, different from the typical INSERTFILE case.) If, upon
    returning from the external editor, lines are encountered that don't fit in
    the displayed width of the textarea fields, the user may be given the
    option to wrap to that width.  (This prompt may not be given when the first
    such line has no suitable spaces for breaking - the file may be binary
    garbage after all, not worth fixing up too much.) Line breaking is
    attempted at spaces if possible (using isspace() for checking), but not if
    the only available spaces are close to the beginning of a line.  An attempt
    is made to join the wrapped part of a line (if not too long) with the next
    line if it is not indented, by suppressing the next line break (if not too
    far away).  Some other heuristics are used that work reasonably well for
    normal text paragraphs.
    If the above mechanisms fail, or the user did not confirm wrapping when
    prompted, very long lines will still be wrapped to fit into the buffer size
    (around 1024 chars).
  [ The wrapping works quite nicely in "normal" cases - please try it! ]
* mouse action in popups would lead to call of fancy_mouse() with wrong row
  number, which could lead to messed-up display as well as invalid memory
  access.
* The previous changes in link redrawing made things worse instead of better
  for UTF-8 display with ncurses (without color style).  This time (using
  wredrawln, not touchline) it should really get better...
  [ The UTF-8 related changes would need testing with non-ncurses curses libs,
    if anyone has one of those AND a working UTF-8 environment - late xterm
    betas(?) from Tom's site should do.  If the functions used for ncurses are
    available in other curses libs, the code should probably look the same as
    for ncurses.  ]
* SGML.c to compile without --enable-prettysrc (reported by HN) -KW
* fixes an invalid memory problem from previous patch
* adds alignment inheritance from COLGROUP / COL / THEAD / TFOOT / TBODY.
* remove some logic from LYmbcsstrlen() that gave an incorrect count for
  the number of cells displaying multibyte characters, resulting in too-few
  cells being highlighted (reported by HN, HS) -KW
* added support for ROWSPAN attribute of TD and TH to TRST.  This only
  reserves the appropriate amount of space in subsequent lines.
  [ Pages that show off ROWSPAN nicely:
    <http://www.iro.umontreal.ca/contrib/po/HTML/domain-hello.html>
    and related ones for other "domain"s.  (Verify that there really
    is a ROWSPAN= in the current version.)  View with a screen width
    of 100.  With 80 there is some kind of problem, compare both
    ^V settings... ]
* some corrections in TRST code.
* change initialization order of key escape sequence mappings for slang, so
  that terminfo/termcap information always overrides defaults that may
  conflict.
* minimal memory cleanup / leak prevention for EXP_FILE_UPLOAD error
  cases in GridText.c.
* in HText_SubmitForm, don't change the post_content_type of the
  passed in newdoc structure unless that is really wanted.
* tweaked UTF-8 prevention of display library wrapping/truncation to make
  better use of available width for centered text, and to not apply if dumping
  to stdout.
* for UTF-8 output with ncurses, do a clearok in display_page also if the page
  that was *previously* displayed had UTF-8 characters.  Without this there
  were still display glitches.
* made previous changes to SGML.c and HTMLDTD for handling OBJECT more generic.
* minor tweaks, cleanups, glitch removal in previous changes.
* better tracking of HTSprintf0/HTSprintf with --enable-find-leaks
  (-DLY_FIND_LEAKS).  This can be disabled in LYLeaks.h by removing the
  definition of LY_FIND_LEAKS_EXTENDED.
* added variant behavior in StrAllocVsprintf to make HTSprintf0/HTSprintf use
  less memory allocation calls and keep its temporary string buffers across
  calls.  The buffers then only grow and never get cleaned up.  This is enabled
  by defining SAVE_TIME_NOT_SPACE in HTString.c, disable the definition there
  in case of problems.
* added code so HTSprintf0/HTSprintf can use vasprintf() in some situations,
  which should be more efficient.  It also works with --enable-find-leaks
  (EXTENDED or not).  This only comes into play if USE_VASPRINTF is defined
  (not defined automatically anywhere).
  [ For me (some Debian glibc version), the prototype for this function
    is in stdio.h but only gets included with an explicit -D_GNU_SOURCE. ]
  [ Which of the four combinations with/without vasprintf, with/without
    SAVE_TIME_NOT_SPACE is better (if any) remains to be tested.  I have seen
    drastic differences under leak tracking, but that's just too much
    different from a normal situation to count for anything. ]
* Some minor leaks fixed. (LYMainLoop.c)

[ Had to make owner_address and ownerS_address file-wide PRIVATE's
 instead of auto to unleak them.  Could be taken out of more
 argument lists now. ]

* HTFile.c: correction in FormatNum (could duplicate fields for some
  LIST_FORMAT settings), avoid some HTSprintf0 calls in FormatStr.
* replaced calls to HTSprintf with calls to HTSprintf0 in various files.
* added missing include of LYLeaks.h in LYPrettySrc.c.  But disabled memory
  tracking there, too many allocations show up as leaks.
* allow digits in tagspec for -prettysrc.
* the 'fixit' change of 1999-05-16 didn't really let LYConvertToURL() revert to
  the right old behavior in the non-'g' use.  Now return a file URL for the
  nonexisting file in the relevant situation again, as before 1998-03-25,
  instead of an erroneous "file://localhost" which (on Unix-like systems at
  least) would result in access to the root directory.  This change (like the
  changes of 1999-05-16 and 1998-03-25) only matters for strings that aren't
  already in absolute URL form, don't start with a slash (or, for DOSPATH
  systems, other path separator) either, and don't get turned into remote URLs
  by successful 'guessing' and DNS lookup.  None of the changes affect VMS.
* protect INSERTFILE and EDITTEXTAREA from generating memory access violations
  if the inserted file has lines that are too long for the buffer used.  An
  alert message is issued and the long lines are truncated.  Also don't exit if
  memory allocation fails for the buffer to hold the whole file, since the only
  reason for the failure may be that the file is too huge when otherwise lynx
  has enough memory.
* improved handling of some invalid constructs in SGML, especially
  '<' followed by various characters; don't lose those characters from
  what gets displayed for -prettysrc.
* a pre-filled TEXTAREA text that needed charset translation could cause
  use of an invalid pointer when building the page, resulting in garbage
  data being displayed (or worse).  The problem was in HTML.c, not related
  to TEXTAREA editing or other related new functions.
  [ preceding three were partially already in previous patch ]
* recognize '<?' as introducing an SGML PI.  Within most elements' content (or
  outside of any elements) this makes no effective difference except for TRACE
  messages and -prettysrc, the input is still junked up to the next '>' as for
  a completely invalid tag.  Within PCDATA elements the PI is now also ignored
  instead of being treated as character data, this makes a difference for
  example in a TEXTAREA in SortaSGML mode.  (PI's aren't really expected to
  occur in the middle of HTML, but are used at the beginning of XHTML documents
  and other XML documents.)
* the earlier change of TEXTAREA handling (treating as SGML_PCDATA, SortaSGML
  only) created a problem, some lynx special characters were passed on as data
  characters in the field contents and would mess up line editing and possibly
  the submitted form data.  Actually the problem also existed before, but only
  for non break space, soft hyphen etc.  encoded directly as character data
  (not NCRs or entities).  Resolved by telling SGML.c not to generate lynx
  special chars for some element contents (currently only TEXTAREA), with new
  flag Tgf_nolyspcl.
* corrected some logic errors in LYUCFullyTranslateString.  Special attribute
  characters are now more often translated to real characters when 'Back' flag
  is set, and should now be translated to the *right* characters for the target
  charset.  (They were sometimes converted to ISO-8859-1 values when the 'to'
  charset was different.)
* added a missing significant cast in UCReverseTransChar.
* for scrollbar mouse clicking, use codes that work independent of current
  line-editor key bindings.
* better calculation of "subjective distance" from next anchor for mouse.
  Change of 1999-07-30 had various problems, it wasn't quite intuitive.  Use
  scaled numbers for finer granularity.  Don't make "basin of attraction" too
  wide, or it becomes hard to find a "background" spot to click on that doesn't
  affect a link if a page has a high density of links.
  [ For example with a pair of fields:
         Submit Reset
                xxx
  clicking in any of the positions marked 'x' on the next line would
  select the first field, not the second. That was not an improvement. ]
* functions LYmbcsstrlen, LYno_attr_mbcs_case_strstr, and LYno_attr_mbcs_strstr
  in LYStrings.c where unclear about the concept of 'printable' or 'physical'
  used for some returned values in the CJK case.  Callers expected number of
  display cells, implemented was number of 'characters' counting full-width
  characters as 1 instead of 2.  Now these functions take an additional
  argument 'count_gcells' that tells them how to count.
  This removes some long-standing, somewhat obscure problems with search target
  highlighting under CJK display character sets, as well as new (and less
  obscure) CJK problems introduces by the latest changes for highlighting.
  Also fixed some details in the *strstr functions.  The positioning of the
  highlighting in CJK mode should now be correct and work as expected (as for
  other display character sets) for anchors, search targets, and combinations
  of both.
* reorganized LYOpenTempRewrite.  It should finally make sense for systems
  without HAVE_TRUNCATE defined.
* corrected SNACat (was unused).
* changes for SUP and SUB:  Render SUP visibly as a '^' character if it needs
  to be separated from a preceding character in order to prevent
  misinterpretation.  The test currently used is isxdigit for the the preceding
  character.  Render <SUB> and </SUB> always as brackets '[' and ']'
  respectively.  SUB is mostly used in technical material while SUP occurs
  frequently in pages of general nature where it is not essential, therefore
  the different treatment.
1999-10-21 (2.8.3dev.13)
* revert a change from dev.4 which disabled getbkgd support in PDCurses -DK
* modify ifdef for USE_QUOTED_PARAMETER to include __CYGWIN__, else names such
  as "telnet.sh" are translated to "telnet" -DK
* improve/simplify scrollbar support -IZ
* implement LYNXMESSAGES:/ page using non-tempfile approach -LP
* correct an assignment to last_kcode, broken by restructuring of LYMainLoop.c
  in dev.11 -HS
* tweak LYExecv() to exclude SH_EX conditional (dired commands didn't work
  on non-Windows platforms when SH_EX defined) -LP
* fix a potential out-of-range pointer in HTParse - JB
* fix a small leak in the statusline history page - JB
* restore DELEL lineedit key binding in the Alternate map (which apparently was
  changed in -dev.4 to the DELNW function) to the ^K key -KED
* LYMainLoop.c:  remove a dozen of unnecessary `refresh_screen' flags from
  LYK_HISTORY, LYK_PRINT, LYK_LIST, LYK_ADDRLIST, LYK_VLINKS where a new html
  page is generated (any document update that may be displayed in "partial
  display" mode need not set `refresh_screen' flag) -LP
* correct some typos in cernrules.txt -VH
* move declaration of LastDisplayChar to make GridText.c compile with DJGPP -LP
> the remainder (most) of this patch from KW:
* HTFTP.c: (already sent w/o description - this is updated to dev.10)
  - interrupted_in_next_data_char was not being reset.  That could make all
    subsequent FTP directory listings fail (by showing an empty directory)
    after receipt of one directory listing had been interrupted.
  - be nice, send quit before closing at least in the normal (non-interrupted
    and successful) case.  Some servers (wu-ftpd at least) otherwise complain
    with "You could at least say goodbye" which in turn causes unnecessary RST
    packets.  To minimize round-trip delays, the QUIT is sent before we start
    reading the returned data (but after the initial response to our retrieval
    command).
  - always close data connection immediately after we are done reading from it,
    also for directory requests.  This was already the case for file requests.
    Some servers (including recent wu-ftpd beta) wait for indication that we
    closed before proceeding.
  - keep better track of closed sockets.  Some more trace messages.
    Some comments corrected.
* tabular representation for simple tables.  See included file README.TRST.
* made User-Agent warning more friendly, and more specific.  Tell the user what
  lynx expects in order to avoid the warning.  On the other hand, issue an
  equivalent warning when -useragent is used.  Change documentation
  accordingly.
* don't send User-Agent header at all if it somehow would be blank.
* indicate on forms 'O'ptions Screen which options are not saved to .lynxrc.
* disable the form fields in the 'O'ptions Screen if the screen is generated
  when FORMS_OPTIONS code is compiled in but not actually active.
* LYPrint.c: In subject_translate8bit (see OUTGOING_MAIL_CHARSET
  option), use higher level function to charset-translate mail Subject
  line, rather than low-level UCTransCharStr.
* UPPER8, UCForce8bitTOUPPER:  was severely broken for UTF-8 display, making
  WHEREIS search for strings containing non-ASCII characters impossible (and
  probably with other bad effects).  Now case mapping may still be wrong, but
  at least identical strings compare as equal.
* LYHistory.c:  Entification for saved statusline messages happened twice by
  mistake.
* HTFWriter.c:  Made code for automatic decompression of bzip2 files
  conditional on BZIP2_PATH.  Such files should be treated as normal binary
  files on systems without bzip2.  The configure seems to always define
  BZIP2_PATH, but it could be undefined manually.
* HTFWriter.c:  Use LYRemoveTemp instead of remove in some cases, to avoid
  keeping those files in the temp file list after they are long gone.
* HTTCP.c: Check whether port numbers in URLs are really numbers.
* HTPlain.c:
  - deal with backspace formatting as used in formatted man pages.
    (No highlighting, only avoid double output of characters)
  - pass on 0xAD (soft hyphen) character in more cases.
* HTNews.c:  Prevent some ways that could trick lynx into treating a regular
  "news:" or "nntp:" URL as something else, like snewspost.  Extra check in
  LYNews.c whether posing is allowed.  Return with an error message in some
  cases of URLs that are too long, instead of silently truncating.  Make HEAD
  work again on news articles.  Some memory leaks in error path removed.  A
  message tweak.
* HTFormat.c:  HTStreamStack:  avoid some unnecessary work, add a trace message
  to show what is returned.
* SGML.c:  some cleanup of ugly ifdefs, and of unnecessary abuse of global
  variables.  (still a lot left!)
* handle INCLUDE and CDDATA marked sections: output the contents.
* parse various elements differently that had/have special requirements or
  hacks.  Extend meaning of Tgf_strict for literal-like content modes.  Use
  SGML_CDATA in some cases (and treat it similar to SGML_LITTERAL), use
  SGML_PCDATA for literal-like parsing (but if modified by Tgf_strict it's
  more like regular SGML_MIXED).  A '<' that would start a tag gets displayed
  (since not element content is allowed that's just error recovery).  Comments
  now work in TEXTAREA instead of getting displayed as text (SortaSGML mode
  only).
* minor tweak of sorta SGML handling for invalid end tag if start tag could be
  validly omitted.
* more consistent and correct recognition of element names.  The characters
  "_-.:" don't end tag names.
* improved handling of '/' after element name in a tag:  "<foo/>" is treated as
  an empty element (as in XML).  If we recognize "foo" as an empty element, do
  nothing special; and if we recognize "foo" as a non-empty element; convert to
  "<foo></foo>".  "<foo/bar/" is treated as a shortref construct, by converting
  to "<foo>bar</foo>" (for non-empty and recognized "foo").  This is not
  general as it would have to be for or real SGML parser, in particular '/' is
  only treated this way if it directly follows the element name, and it may not
  even be quite right.  It is better than the recovery lynx previously did in
  these cases though.
* changed handling of include buffer which is used to pass back data
  from HTML.c to SGML.c.  Passing data upstream now works without strange
  reordering effects even when SGML_character was already parsing data from
  a previous include buffer.
  Character set translation would happen several times on data passed back
  to SGML_character in the include buffer for re-parsing.  This is now
  avoided.  Well at least in most cases, and for characters that *can* be
  translated, there are likely combinations of input and output character
  sets where the assumptions made are still wrong.
* the start_element and end_element methods of structured stream class now
  return a status code.  Currently only used for the OBJECT stuff below.
* mostly HTML.c, SGML.c: Changed handling of OBJECT and MAP.
  - avoid using the include buffer mechanism as much as possible.  This
    involves introducing some new special handling in SGML.c to change parsing
    mode for element contents, and a way for HTML_{start,end}_element to signal
    to SGML_character what it should do.  In most cases when the OBJECT element
    content should be parsed and displayed, SGML_character now only needs one
    pass through the data.
  - don't lose content when several OBJECTs are nested.
  - in HTML 4, an OBJECT with USEMAP attribute can refer to a MAP within the
    OBJECT's content, possibly within nested inner OBJECTs.  Lynx would fail to
    find the MAP in that case, now it doesn't.
  - in HTML 4, MAP can contain arbitrary block elements in addition to AREA.
    Lynx now shows such block content, even if it occurs within (possibly
    nested) OBJECTs with USEMAP whose contents we would otherwise skip.
    Sometimes we may show too much now, by generating a LYNXIMGMAP link as well
    as showing block content or by showing more of the OBJECT content than what
    is within a MAP, but that is preferable to losing data.
  - treat an A tag with COORDS attribute as equivalent to an AREA when it is
    within MAP, for the purpose of collecting links for LYNXIMGMAP.
  - as a fallback, internally redirect a LYNXIMGMAP request to the position of
    the MAP element in the normally rendered text of the document containing
    the MAP, if it is known that the MAP element exists and just doesn't
    contain any AREA (or equivalent A-with-COORDS) links.  It is assumed that
    in such a case there is some block content within the MAP that is rendered
    normally.
* HTFile.c: new function LYGetFileInfo.
* HTAnchor.c: new function HTAnchor_findSimpleAddress.
* new function HTStartAnchor5.
* modified the way link text is (re-)drawn by function highlight.  The bulk of
  processing now happens in new function LYMoveToLink.  The data of the
  containing line is now scanned from the beginning, using the same logic as in
  display_line to make sure that lynx and the display library have the same
  idea of where in the line the link starts.  In UTF-8 output mode, parts of
  the line preceding the link are also repainted if this is necessary.
  Refreshing of the physical line is forced if necessary in UTF-8 mode.  For
  anchors split across lines, the new approach is currently only used for the
  first line.
  This change is not in effect for lynx with color style.  In that case
  highlighting already is sometimes done in a similar similar, but not quite
  the same, separate function.
* modified WHEREIS target highlighting for hypertext links.  Now this is done
  in the same pass as drawing the normal link text, in LYMoveToLink.  This
  avoids problems in UTF-8 display mode.  It also avoids a lot of complicated
  and extremely hard to understand older code in highlight(), but that code is
  still there for use by lynx with color style and for other remaining cases
  (non-hypertext anchors, second line highlighting).
* modified WHEREIS target highlighting for general text.  Instead of first
  writing each line's characters in display_line, then scanning again through
  the line's data for portions to highlight and repainting those parts after in
  display_page, this is now done in one pass within display_line.  However,
  this isn't (yet?) done for lynx with color style which still uses the old
  code.
* these last three changes reduce problems that occur when using UTF-8 display
  character set (in an appropriate terminal environment that understands it, of
  course).  Most of them don't apply with color style lynx, so it continues to
  have more UTF-8 problems.  Pages with mostly ASCII characters should be more
  or less ok.  Problems that otherwise are not visible become apparent in
  search highlighting, and after ^Z / fg.
* GridText.c:  More changes to deal with problems caused by using UTF-8 output
  with a display library that isn't aware of it.  Break line with UTF-8 before
  curses does it.  This causes lines that are too short, effectively the
  rightmost part of a line cannot be used if there are UTF-8 encoded
  characters.  The alternative, letting curses wrap the line when it thinks it
  got too long, is worse, so do it in lynx code instead.
* avoid memory overrun for very long lines in UTF-8 mode.  Avoid splitting line
  in the middle of a multibyte UTF-8 character.
* test for SHOW_WHEREIS_TARGETS instead of 'defined(FANCY_CURSES) ||
  defined(USE_SLANG)'.
* initialize new textarea lines created by insert_new_textarea_anchor with
  current display character set for value_cs.  (The "cloned" value can be stale
  in some cases if the user changed the display character set after the
  document was last loaded - normally that should not happen).  For a file
  inserted into a textarea with INSERTFILE use new function LYGetFileInfo
  instead to determine the file content's charset.  Thus -assume_local_charset
  and conventions based on file suffix should be honored.
* for Unix, added more specific error message if calling external editor for
  textarea failed, based on the status returned by system().
* it is possible to require an additional prompt before Enter in
  an input field causes form submission: define TEXT_SUBMIT_CONFIRM_WANTED,
  explained in userdefs.h.
* some small changes to prevent overstepping string boundary (HTParse.c)
* extended SUFFIX option, added SUFFIX_ORDER option, see documentation in
  lynx.cfg.  The long list of built-in file suffix rules in HTInit.c can now be
  disabled, either at compile time - see userdefs.h - or at run time.  The
  equivalent functionality is now available in lynx.cfg for those who want it.
  Added comments, see HTFileInit in HTInit.c.
* various tweaks of built-in file suffix rules.
* allow XLOADIMAGE_COMMAND to be empty (in lynx.cfg) or NULL (in userdefs.h),
  just don't use a default X viewer for image types in that case.
* moved UCGetUniFromUtf8String from LYCharUtils.c to UCAux.c.
* renamed LYUCFullyTranslateString -> LYUCTranslateHTMLString, and
  LYUCFullyTranslateString_1 -> LYUCFullyTranslateString.
* tweaks for special chars in (what is now) LYUCFullyTranslateString, in
  obscure cases (input fields of type password prefilled with unusual content)
  lynx would pass text back to the server with special characters (soft hyphen
  or non-break space) expressed as lynx-internal code values.
* added some replacement characters or strings to various chartrans tables.
* experimental command line option -convert_to, only compiled in if new
  MISC_EXP symbol is defined.  This takes a string in the form of a MIME type,
  which can also be combined with an appended ";charset=" parameter.  (This
  needs shell quoting of course).  The charset value can be used to set the
  display character set from the command line.  The MIME type can be one of the
  non-official types used internally, for some interesting effects (crashing
  lynx not excluded).  Try www/download, www/source, www/dump, or some
  unrecognized string.
* fixed HTMainText_Get_UCLYhndl, it was returning the wrong kind of charset
  handle (a "UChndl", which is different from a "LYhndl" or "UCLYhndl" etc.,
  and shouldn't be directly accessed by arbitrary bits of lynx code - it should
  be regarded as private to the chartrans mechanism).
* protect various printf-like calls against crashes from strings with '%':
  LYSyslog.
* LYDownload.c: made parsing of LYNXDOWNLOAD: URL slightly more robust.
* disabled some broken pieces.
1999-10-14 (2.8.3dev.12)
* fixes for restructured LYMainLoop.c (reported by PG, LP) -TD
* minor fix for makeutcb, to compile with K&R C -TD
1999-10-13 (2.8.3dev.11)
* restructured LYMainLoop.c, so the main switch statement calls functions
  rather than doing everything inline.  This greatly reduces memory required
  to compile that module, as well as making the compile 3-4 times faster -TD
* tweak CJK_EX code for incorrect x-transparent charset handler - it now
  depends on --with-charsets= configure flag -LP
* tweak comments in UCDomap.c to be consistent with KW changes as of
  2.8.3dev7 -LP
* define DECL_ERRNO for Borland compiler, so errno will be declared (report
  by JS) -TD
* add definition for DJGPP so truncate() function is used there, needed for
  LYOpenTempRewrite() function -LP
* correct character set for lines added in an external editor (Marek Kubita
  <kubitovi@mbox.lantanet.cz>, KW, KED)
* remove a couple more duplicate includes -LP
* remove a couple of duplicate includes (JB - John Bley <jbley@cs.cmu.edu>)
* fix some missing ifdef's for win32 versus DOS, as well as change calls to
  strcasecomp() to strncasecmp() -Hiroyuki
* undo spurious change from win32 integration in dev.5 to HTSprint0() which
  causes a memory leak (reported by John Bley, analysis KW) -TD
* prevent embedded "%s" in generated messages from causing a core dump in
  exit_immediately_with_error_message by using fputs rather than fprintf/printf
  (reported by KW) -TD
* Changes in UCAuto.c for --enable-font-switch:  Support some more code pages
  if available.  Check return code from setfont invocation, and use it to
  determine whether font and/or translation map loading was successful.
  Warning, this is not based on any documented interface but on
  experimentation, so may not work for long or for anyone but me; it shouldn't
  be worse than before though.  Better logic for keeping track of state, some
  parts just didn't work right.  Workaround for wrong data in some distributed
  font files.  Minor memory leak removed -KW
* modify test/c1.html to use tabs for better formatting, added comments -KW
* modify HTFTP.c for better conformance with RFC959.  Among other things, one
  major purpose was ending the control conversation cleanly, at least in the
  normal case, to get rid of the "221 You could at least say goodbye.."
  responses from wu-ftpd servers and resulting RST traffic.  In response to the
  problem with ftp.wu-ftpd.org, made one small change to when the data_soc is
  closed.  This was done early for some specially code server types, apparently
  those that has caused the same type of problem in the past; just changed it
  to close data_soc at that point independent of server type -KW
* set CDPATH to . in the makefile.in's that use cd, in case user has set
  CDPATH without . at the beginning -TD
1999-09-29 (2.8.3dev.10)
* change CTRACE macro to double-parenthesis form, to allow ifdef'ing most
  trace statements -TD
* fix the creation of a new bookmark file and takes care that older bookmarks
  files do not fall into the same bug anymore by making sure the <ol> tag is in
  a line by itself.  This correction will only be activated when the first
  bookmark is attempted to be erased (patch by Eduardo Chappa L)
* change a trace/error message in HTInit.c to say "Lynx" rather than
  "metamail", to avoid confusion -HN
* change <tab> formatting in user's guide, etc., to <pre> sections, thereby
  appeasing Dave Raggett's "tidy" program -TD
1999-09-13 (2.8.3dev.9)
* add -nobold, -noreverse, -nounderline options to disable corresponding
  video attributes (based on a patch by John Hawkinson <jhawk@MIT.EDU>) -TD
* add STICKEY_FIELDS to lynx.cfg, which tells lynx whether to activate the
  previous document when an extra key-left is given -VH,TD
* minor cleanup of run_external(), use single return, HTSprintf0 -TD
* for WATT32 configuration, call _eth_release() and _eth_init() in HTTelnet.c
  to make telnet work properly -DK
* correct redefinition of u_long for WATT32 -LP
* modify syslog change to make it more specific, based on comments by KW -TD
* fix potential security problem with SYSLOG_REQUESTED_URLS, which would let
  syslog() send sensitive information as broadcast to any syslog daemon that
  care to listen.
  E.g. URLs with embedded passwords are sent to syslog:
    Sep 11 12:26:06 lynx[16177]: ftp://joe:password@host/~joe
  The patch masks the password by breaking up the URL and replacing
  the password with "******" (Gisle Vanem <giva@bryggen.bgnett.no>).
* fix mismatch of const's from call of map_string_to_keysym() in
  lkcstring_to_lkc() -TD
* supply trailing slash for protocol_proxy settings (whether environment
  variables or lynx.cfg) in HTAccess.c if the slash was omitted and if the
  content otherwise looks normal (starts with http, no superfluous slashes) -KW
* add links for "Free WWW E-mail services" to online help -PW
* add links in online help to FAQ-o-matic -JS
* more fixes to build with slang under cygwin32 - DK
* add/use LYwaddstr(), etc to fix more const-casts (reported by PG) -TD
* modify HTTCP.c to prevent telnet and similar applications from inadvertently
  using hostname tokens which look like command-line options -KW
* modify configure script's --with-charsets option so that if the option
  --without-charsets is selected, then it will use a 'minimal' set.  The
  keyword 'minimal' is recognized as the list us-ascii,iso-8859-1,utf-8
  (request by KW, HN) -TD
* ifdef'd recursive calls on UCGetLYhndl_byMIME() for charsets that may be not
  present (--with-charsets), and add getLYhndl_byCP() to cover a special case
  of recursion which was also a preexisting hole (reported by Frederic L W
  Meunier, analysis by KW) -TD
* replace fr.po with a placeholder.  Add placeholders for ru.po, pt_BR.po -JS
* review/modify HTNews.c to avoid potential buffer overflows, as well as reduce
  the number of embedded constants that make it difficult to adjust fixed
  buffer sizes -TD
1999-08-28 (2.8.3dev.8)
* correct ifdef's combining HAVE_POPEN and __CYGWIN__ in LYPrint.c, which would
  link popen() code when it was not available -TD
* correct order of ifdef's for __CYGWIN__ in LYGlobalDefs.h, which would result
  in a syntax error if the symbol __CYGWIN__ were undefined when __CYGWIN32__
  was defined -TD
* change hardcoded ifdef for <arpa/inet.h> include to autoconf'd form -TD
* modify makeuctb to add ifdef's allowing most charsets to be suppressed at
  compile time.  Use similar ifdef's in UCdomap.h to suppress registration
  of non-uctb charsets.  Add configure option --with-charsets to specify list
  of charsets which are not suppressed (def7_uni is always active) -TD
* change makeuctb to generate the name of the output file, simplifying all of
  the build scripts in chartrans -TD
* correct a syntax error in crypt_util.c from dev.7 and an ifdef in LYCurses.c
  that sets the codepath -SH
* use macro TABLESIZE throughout for consistency -TD
* revert use of TYPECAST for parameter of 'FREE()' macro, since that puts a
  cast on the parameter as an lvalue (reported by LV) -PG
* correct improperly-nested ifdef EXP_CHARSET_CHOICE in ifdef for USE_PSRC
  in LYReadCFG.c -TD
1999-08-26 (2.8.3dev.7)
* tweak ifdef'ing of `debug_delay' (only available with SH_EX _and_ WIN_EX) -LP
* tweak src/Xsystem.c (extern system_is_NT is now ifdef'ed with WIN_EX) so
  exec_command() can also be used with DJGPP when compiled with _WIN_CC symbol
  (though choice of _WIN_CC is questionable) -LP
* simplified ifdef'ing for resolv() vs LYGetHostByName() for DJGPP -TD
* DJGPP with WATT32 now does DNS lookup via LYGetHostByName()/gethostbyname()
  like other lynx ports so we get reasonable error recovery when DNS lookup
  fails.  (For example, we now avoid a hang when wattcp.cfg is not configured
  properly - a typical situation when playing with nullpkt.com).  Build with
  -DNSL_FORK (in both src and WWW makefiles) is recommended:  this will prevent
  unexpected 1 second curses delay when alerting a wrongly configured tcp.  (No
  real fork() in DJGPP, unfortunately:  this function always returns -1 and set
  'errno' to ENOMEM, as MS-DOS does not support multiple processes.  It exists
  only to assist in porting Unix programs) -LP
* alternative patch (replaces HN's) for UCdomap.c -KW
* modify initialization of lynx_temp_space in case the given name has
  embedded "~", ifdef'd for WIN_EX -SH
* fix a problem hanging caused by allowing some unknown entities in an ALT
  string.  The "hang" problem was caused by a combination of removing too much
  under 'case S_check_name' in 'LYUCFullyTranslateString_1', _and_ having
  having some Latin 1 character codes that are untranslatable to the display
  character set -KW
* added lynx.cfg setting PSRCVIEW_NO_ANCHOR_NUMBERING that inhibits link
  numbering when in psrc mode if set to TRUE (default is FALSE) -VH
* fixes for justification code (anchor position recalculation) and the
  GridText.c:*TrimHightext (it was not designed to support LY_SOFT_NEWLINES),
  correcting rendering of links on wrapped lines in psrc mode -VH
* fixes to www_tcp.h, LYUtils.c and UCdomap.c to build on BeOS 4.5 -TD
* fixes for CYGWIN with Slang, mainly due to platform differences in Slang -DK
* fixes for DJGPP, missing headers and declarations -DK
* let CJK charsets default to 7 Bit Approximations.  Needed to display entities
  in the decimal 160-255 range.  (Restore behavior before the changes made to
  declarations of charsets on 1999-03-04) -HN
* rename -number_links_forms to -number_fields -TD
* add the -number_links_forms command line option (John Hawkinson
  <jhawk@MIT.EDU>).
* modify configure script so --enable-change-exec sets default for
  the --enable-exec-links and --enable-exec-scripts options -TD
* modify ifdef's for ENABLE_OPTS_CHANGE_EXEC since one or both of EXEC_LINKS
  and EXEC_SCRIPTS must also be defined to make this effective (reported by
  KED).
* add explanations of the various choices for revealing/not images, to Users
  Guide, Options Help & lynx.cfg -PW
* fix LYgetstr() to disable saving of input text on LYE_ENTER state when the
  input is supposed to be hidden -KW
* add/use LYaddstr() to fix some const-casts -TD
* move dependency of "lynx$x" from "install" to
  "install-bin:" in top-level makefile.in -PG
* corrected display of SGML_LITTERAL content -VH
* now LY_SOFT_NEWLINE is used in psrc mode to denote wrapped lines (as in plain
  source mode) -VH
* add configure option --enable-scrollbar -TD
* make the charset-choice code lynx.cfg-reloading-safe -VH
* add experimental code to allow users to specify that a subset of the
  compiled-in charset definitions are available for selection for display
  (ifdef'd with EXP_CHARSET_CHOICE, added configure option
  --enable-charset-choice -TD) -VH
* add/use ANSI_PREPRO symbol to simplify ifdef's concerning preprocessor token
  substitution/concatenation -TD
* modify ifdef of code that shows current CJK code in the title area under
  SH_EX as well as CJK_EX -TD
* modify HTMLDTD.c to set canclose for <Hn> inside <PRE></PRE> -VH
* correct ifdef'ing of set_ws_title(), which should be applied only on win32
  (reported by Frederic L W Meunier) -LP, TD
* reduce compiler warnings from Borland C++Builder.  Most of these are casts,
  with boolean constructs dominating -JS
1999-08-13 (2.8.3dev.6)
* workarounds in LYMain.c and LYMainLoop.c for excessive compiler warnings due
  to defective design of glibc2 -TD
* modify logic for EXP_JUSTIFY_ELTS in GridText.c to change a raw
  LY_NONBREAK_SPACE to ' ', to work better for tables -VH
* add/clarify user's guide for command line option syntax -DK, KW
* add a new command line toggle for DOS to control debugging of packets under
  WATTCP and WATT-32.  Under WATT-32, once dbug_init is called, debugging
  cannot be turned off (although output can be sent to /dev/null).  This new
  option "-wdebug" controls whether debugging is active, is off by default -DK,
  Gisle Vanem
* allow ':' as a separator between the option and its value -DK
* corrected install rule using symbolic link for copyright files (reported by
  HN, KED) -TD
* reset "stalled for xxx" counter from IZ's ETA change in dev.5 between ftp
  requests -VH
* add support for scrollbars, ifdef'd with USE_SCROLLBAR.  Use command-line
  options -scrollbar and -scrollbar_arrow or corresponding lynx.cfg to enable
  it.  Requires ncurses; may be further tuned if color-style configuration
  is used -IZ
* LYCopyFile():  Thanks to Hiroyuki Senshu, DOS-based systems need no cp.exe
  binary any more.  The code was originally ifdef'ed with SH_EX; now defined
  with DOSPATH so is used automatically by any dos/windows port, not used for
  UNIXes (permissions?) -LP
* a few includes labeled with _WIN_CC now tweaked with WIN_EX as should be -LP
* adjustments to SH_EX, CJK_EX ifdef's in LYMainLoop.c and LYUtils.c to aid in
  porting -LP
* improved logic in status_link() for -short_url option (patches from
  <nsh@itjit.ne.jp> and Eduardo Chappa L)
* modify display_page() to not necessarily call lynx_force_repaint() to make
  highlighting work when displaying UTF-8 -Christian Weisgerber, KW
* add check in read_directory() if transfer was interrupted -KED
1999-07-30 (2.8.3dev.5)
* add/use LYHideCursor() macro to accommodate position in older curses -TD
* add configure option --enable-cjk to compile-in CJK_EX logic -TD
* add -short_url option and associated logic to elide middle of long urls
  (adapted from patch by Eduardo Chappa L <chappa@math.washington.edu>) -TD
* ifdef'd read-progress changes with EXP_READPROGRESS, add configure option
  --enable-read-eta to turn this on -TD
* enhanced read-progress logic (Ilya Zakharevich)
  a) makes size/transfer rate reports use format "8.3 KB" (instead
     of "8 KB") if numbers are below 10 KB and reports are in KB;
  b) makes transferred/expected/transfer-rate use bytes/KB independently
     so "236 bytes of 56 KB" is possible, as is
     "8.3 of 56 KB, 456 bytes/sec";
  c) adds "ETA 23 sec" info if available;
  d) adds " (stalled for 75 sec)" info if available (updated each 5
     sec or so);
  e) uses gettimeofday() if present (instead of current hacks) to get more
     frequent updates.
* fixes for OS/2 and ncurses from Ilya Zakharevich:
  a) Makes lynx ignore mouse events which are not clicks (filtering through
     ncurses does not work as expected).
  b) Makes mouse-clicks "basin of attraction" of a link wider (the area where
     clicks make the link a current link).  It was 2 units vertically and
     horizontally, make it 2 units vertically, and 6 units horizontally.  This
     leads to "more intuitive selection".
  c) Make processing of .lynx-keymap write messages to trace buffer;
  d) LAC-keybindings were not working;
  e) Allow .lss files include one another via INCLUDE:/file/name
  g) Allow a change of default color in .lss files (not the color of attributes
     text, but colors for a style if "default" is specified); This (together
     with "e") allows for a simple modification of a color scheme
     Here is an example of a .lss file with a changed default
     foreground/background and a handful of other declarations fine-tuned for
     this change.  (It implements "Commander" style).  "Overriding"
     declarations should be put before INCLUDE:, and the "default:" declaration
     should be the last one.
		status:reverse:yellow:black
		h1:bold:yellow:black
		em.a:reverse:black:blue
		em.b:reverse:white:black
		font.letter:normal:default:black
		link.blue:bold:white:brightblue
		link.blue.prev:bold:yellow:brightblue
		title:normal:magenta:black
		i:bold:white
		table:normal:white
		blockquote:normal:white
		li.blue:bold:blue:black
		link.blue.next:bold:blue:black
		normal:normal:default:default
		INCLUDE:F:/emx.add/lib/lynx.lss
		default:normal:brightcyan:blue
  h) Improve algorithm for allocation of color-pairs;
  i) Lynx was not recognizing HOME directory on EMX;
  j) UP_LINK and DOWN_LINK now actually move along a vertical line (as far as
     it is possible), including an arbitrary sequence of such keypresses.
* modify LYIsPathSep() macro to include '\' for OS/2 EMX -TD
* correct a problem with spurious cookie names when reloading lynx.cfg (Michael
  Warner & KW)
* add check for too-long line in HText_ExtEditForm(), splitting it if needed
  (reported by <yury.burkatovsky@telrad.co.il>) -TD
* move NO_GROUPS definitions from HTFile.c to HTFile.h to make them available
  for use in LYUtils.c on DOS -LP
* correct several minor problems with integration of HS's changes in
  GridText.h, HTAlert.c and LYPrint.c (reported by LP) -TD
* restore dev.3 interface to LYLowerCase and LYUpperCase and do casts
  internally to work on unsigned chars -PG
* corrected typos in some messages (reported by Dmitry Sivachenko
  <demon@gpad.ac.ru>).
* changes for win32 -SH
  + added ifdef's using _WIN_CC (for Borland C) to some places in prettysrc
    definitions which use the __STDC__ symbol.
  + renamed makefile.w32 to makefile.bcb
  + renamed src/chrtrans/makefile.w32 to src/chrtrans/makefile.bcb
* the DOS port compiled with WATT-32 now works in a DOS window under Windows
  3.11 and Windows for Workgroups 3.11.  It still needs its own packet driver
  and does not use any native winsocks and  has only been tested with Toni
  Lopez's DOSPPP.  This does fill a void for those running Win3.x, who
  previously had to close Windows and go back to plain DOS before they could
  run lynx.  Updated the help files, reflecting current platform support -DK
* corrected definitions in HTTP.c and HTDOS.h to build with old TCP library -LP
* When keypad_mode was changed from forms options menu
  set_numbers_as_arrows()/reset_numbers_as_arrows() was not reinitialized
  (reported by KED) - LP
* SOURCE_CACHE: add one more parse setting member (keypad_mode)
  to HText structure -LP
* SOURCE_CACHE:  fix updating the document when "display charset" was changed
  from Options Menu by user:  FREE(anchor->UCStages) call from
  HTuncache_current_document() now duplicated in HTreparse_document().
  (problem reported by KW) - LP.
* tweak trace message in scan_cookie_sublist():  limit trace output by trying
  LYstrstr() as a first approximation before host_matches() -LP
* open temp-file in LYNewsPost() in binary mode for DJGPP to avoid translation
  of \r\n vs \n -DK
* add note about potential conflicts with cookie files to description of
  --disable-persistent-cookies -BJP
* added status message to indicate state of text inputs -VH
* added ability to make text inputs non-sticky (i.e., user will have to
  activate them explicitly via an LYK_ACTIVATE action) - seems useful for
  people navigating with alphanumeric keys.  Default is 'sticky' - i.e., old
  behavior.  Behavior is controlled via command line option '--sticky-inputs'
  and STICKY_INPUTS in lynx.cfg -VH
* added conditionals to 'userdefs.h' that disable support for
  force-empty-hrefless-a mode if lynx is configured without lss (it's not
  useful for such setup) -VH
* minor change to prettysrc mode, writing comments one character at a time
  to avoid translation of \r\n to \n\n in HText_appendText() -VH
* correct rendering of DL in EXP_JUSTIFY_ELTS, will inhibit justification of
  DT's content -VH
* other modifications to EXP_JUSTIFY_ELTS logic, to use information associated
  with each element that indicates whether it can be justified -VH
* modify HTMLDTD.c so that "center" is not treated with EXP_JUSTIFY_ELTS -VH
* fix for core-dump in EXP_JUSTIFY_ELTS -VH
* modify signal handling in LYSystem to workaround competing SIGTSTP handlers
  when a subprocess is active.  This adds a new function LYToggleSigDfl(),
  using sigaction as an alternative to signal to save/restore as much of the
  signal state as possible -KW
* add configure option --enable-justify-elts (request by VH) -TD
* add configure test for sigaction function and related structs -TD
* restore hardcoded escape sequences on Unix in setup_vtXXX_keymap()
  inadvertently dropped in dev.4, to accommodate users of slang library who
  have their $TERM set incorrectly -TD
* correct ifdef's for resizeterm() call to allow Lynx to build with old
  versions of ncurses -TD
1999-07-14 (2.8.3dev.4)
* minor fixes to build with SunOS K&R compiler -TD
* cleanup unbalanced curly braces from other recent experimental options -TD
* rename internal definition for LINKS_AND_FORM_FIELDS_ARE_NUMBERED to
  LINKS_AND_FIELDS_ARE_NUMBERED to keep it shorter than 32 characters -TD
* change ifndef's for NO_JUSTIFY to ifdef EXP_JUSTIFY_ELTS since something in
  VH's recent code causes core dumps, by crosslinking the state of two parts of
  the parser -TD
* modify slang code to recognize F1 from terminfo/termcap on Unix (John Davis)
* changes to use the WATT-32 tcp library, making a DOS port that does http,
  ftp, news, mailto, and telnet -DK
  Remaining work includes:
  * This has been tested only with slang and the djgpp_keyhandler code.  There
    will probably need to be more changes to have this work properly with
    PDCurses.
  * There is at least one bug.  When set to use http_proxy, there seems to be a
    long wait between socket connect and write if the proxy is accessed too
    rapidly in succession.  It seems that if it is accessed more frequently
    than about 20 seconds, there is a timeout of up to about 85 seconds.
  * some problems with ctrl-break handling, will report to the watt-32 list.
* rename tcp.h to www_tcp.h -DK
* fix typo in manpage description of -color (Christian Hudon
  <chrish@debian.org>).
* add $(LDFLAGS) to chrtrans/makefile.in, for NetBSD -JS
* use symbolic link rather than hard link for installing copyright files -TD
* now dashes and underscores can be intermixed in commandline options, and in
  -restriction option, ifdef'd with OPTNAME_ALLOW_DASHES -VH
* added commandline switch '-dont_wrap_pre' that will inhibit line wrapping in
  <pre> when -dump'ing and -crawl'ing.  (But maximal length of line on output
  can't exceed MAX_LINE (1023 by default)) -VH
* lynx.man updated to reflect new option -dont_wrap_pre and to note that gnu
  style of options (with two dashes) is also supported -VH
* some small developer's docs tweaks -VH
* added text justification (controlled by commandline switch '-justify' and
  from lynx.cfg too), ifdef'd with NO_JUSTIFY -VH
* added support for emitting backspaces (a-la man) - commandline option is
  '-with-backspaces', ifdef'd with NO_DUMP_WITH_BACKSPACES -VH
* added support for forcing-empty-HREFless-As - ie A element that doesn't
  contain HREF will be closed after it was seen (without waiting for </a>) -
  this fixes rendering of documentation, produced by broken translators that
  don't emit balanced 'A's (eg RedHat docs produced by 'dlh', Sybase docs) -
  commandline option is --force-empty-hrefless-a, and force_empty_hrefless_a in
  lynx.cfg, ifdef'd with NO_EMPTY_HREFLESS_A -VH
* incorporate changes for win32 by Hiroyuki Senshu <senshu@shonai-cit.ac.jp>
  (SH) from
    ftp://crab.it.osha.sut.ac.jp/pub/Win32/develope/senshu/Lynx/
  based on his patch against 2.8.2pre.6
  Most changes are ifdef'd
    #define _WIN_CC=    .... for Windows C Compiler
    #define CJK_EX      .... CJK EXtension
    #define SH_EX       .... Senshu Hiroyuki EXtension
    #define WIN_EX      .... Windows EXtension
* add missing null-pointer check in MakeNewMapValue(), for verbose-images
  (from Debian bug report #39596) -TD
* test/build with gettext-0.10.35 -TD
* renamed uppercase makefiles and .bat files to lowercase, change the makefiles
  consistently to Unix-style format -TD
1999-06-29 (2.8.3dev.3)
* move HTAlert call so we don't get it each time we run the options menu -TD
* entify messages in LYshow_statusline_messages() -LP
* add -DNO_PORT to WWW/*/djgpp makefiles -DK
  This is to make ftp work with new version of the WATTCP library as revised by
  Igor Poretsky for building lynx with DJGPP.  The old version has been renamed
  to "tcplibdj-old.zip".  For the new package, go to:
    "http://www.rahul.net/dkaufman/tcplibdj.zip" or
    "ftp://ftp.rahul.net/pub/dkaufman/tcplibdj.zip"
* new option REUSE_TEMPFILES, see comments in lynx.cfg -KW
* use P instead of invalid TR for right-aligned "LYNXMESSAGES:" link in HISTORY
  page -KW
* better support for accessing FTP directory listings on Windows NT FTP
  servers:  try to switch MSDOS-like directory output off with SITE DIRSTYLE.
  The price to pay for this is one or (probably more often) two more command/
  response round trips -KW
* added support for accessing FTP directory listings in "dls" style sent by
  some OS/2 servers.  Only one server was known and used for testing, so the
  heuristics used may not be quite general enough.  File date/time is not shown
  since it doesn't seem to be part of the basic format -KW
* in lynx.man removed bogus "ID:" for -assume_charset,
  -assume_local_charset -KW
* in a list, render a <DIV> that doesn't have an ALIGN="center" or
  ALIGN="right" attribute like a <P> in that situation:  break the line if
  necessary but don't create an empty line, an keep list indentation.  This
  addresses Debian bug #21331 -KW
* other changes for DIV:  it's a block element, so make sure its contents
  doesn't get rendered inline, even for nested DIVs that don't change text
  alignment.  Try to avoid improperly kept change of DIV styles' alignment by a
  <P> or </P> in its content -KW
* make "treating H# in a list as an LH" work also for SortaSGML parsing,
  previously it only worked with TagSoup -KW
* removed special handling for empty last field from LYstrsep(), which made it
  act differently from (GNU) C library's strsep() -KW
* macro DEFAULT_INVCHECK_BV for default invalid cookie checking behavior, can
  be changed at top of LYCookie.c for those who really want that -KW
* reorganize code for invalid cookie checking / prompting somewhat, it is
  hopefully easier to follow now, and should result in more logical prompting
  (or not) if a cookie is invalid for more than one reason -KW
* change invalid cookie confirmation prompts to default to "no" answer.  This
  can prevent the impression that Lynx hangs because the prompt is not
  completely visible.  There should be a better way to ensure that all prompts
  are recognizable as such (at least with "normal" screen widths) -KW
* use more of the available statusline width for showing cookie name and value
  in normal cookie prompts -KW
* handle \" in quoted cookie values, so that the quote char doesn't end the
  value string -KW
* write quoted cookie values to cookie file with the quotes ('"' chars).  When
  the cookie file is read, assume that quoted strings are quoted cookie values.
  It would be better to have a separate flag stored, but we are limited by the
  choice of the Netscape-compatible file format.  This should resolve Debian
  bug #35523 -KW
* handle empty value strings like any other cookie values:  they can be kept in
  the cookie jar (in memory), and can be written to and read from the cookie
  file -KW
* more checking whether a line read from a cookie file is complete -KW
* write out second field in cookie file lines a TRUE or FALSE depending on
  whether the domain can be used for suffix matching or has to match
  completely.  This seems to be how Netscape uses it.  We don't actually use
  this field when reading a file (presence of a leading dot in the domain value
  tells us what we need to know), but this should improve behavior for people
  sharing a cookie file between Lynx and a Netscape browser (although such
  sharing shouldn't be recommended) -KW
* treat case as insignificant in cookie domains more consistently -KW
* remove remnants of FROM_FILE domain behavior, it was unused -KW
* add some clarifications in lynx.cfg regarding cookies -KW
* entify strings when adding them to LYNXMESSAGES: stack -KW
* save HTAlwaysAlert messages for LYNXMESSAGES: page -KW
* generate TRACE output for prompts that use HTConfirm() or HTConfirmDefault
  -KW
* make sure force_old_UCLYhndl_on_reload is initialized and reset properly -KW
* minor tweaks (LYCharUtils.c, LYMain.c, LYPrint.c) -KW
* flush Lynx.leaks file after writing each memory leak record but before
  freeing the memory block, to ensure the info is on disk if something goes
  seriously wrong (i.e., FREE causes a signal) -KW
* more general checking in postoptions - `lynx LYNXOPTIONS:foo' now doesn't
  crash -KW
* revived dired "install" functionality, more or less as it was (apparently)
  originally meant to be used, but with various checks added.  Compilation is
  now conditional on new symbol OK_INSTALL.  The "install" function is the
  closest we have to a "copy file" function, and could be used instead; the
  actual command executed depends on macros INSTALL_PATH and possibly
  INSTALL_ARGS, one can define INSTALL_PATH for example to "/bin/cp" before
  compilation to effectively get something like a dired "copy" function.  Note
  the the "install" function requires a special file in the home directory,
  which can be customized, see samples/installdirs.html -KW
* new function HTURLPath_toFile in HTFile.c.  Use it if we don't have a full
  URL where HTnameOfFile_WWW was used previously, this avoids misparsing of
  some unusual URL forms for files -KW
* other changes for dired support (KW):
  - various corrections with respect to URL-unescaping: don't escape
    too often or too little, dired operations could fail on filenames
    with special characters
  - avoid some unnecessary copying and allocation for filenames
  - avoid some more static buffers
  - add some buffer overflow checks
* make local directory display somewhat interruptible even without
  partial page display -KW
* make do_readme in HTFile.c 8-bit clean -KW
* tweak in HTTP.c to avoid doing strlen() on received data that are to be
  passed on raw; raw NUL bytes within the first block read could lead to data
  loss -KW
* change newly introduced CAN_ANONYMOUS_* at end of userdefs.h to be FALSE by
  default, to get behavior with -anonymous that is equivalent to 2.8.2 -KW
* handle some more common forms of mailcap $DISPLAY tests internally in
  HTInit.c -KW
* correct a problem which appears when the curses library causes FANCY_CURSES
  to be defined but not COLOR_CURSES:  the code can call attrset() twice for
  the same characters, thus replacing the original attribute with the new one.
  Fix by using attron() instead (patch by Julian Coleman
  <J.D.Coleman@newcastle.ac.uk>)
* modify LYonedot() so it does not change its parameter, avoiding corrupting
  the name to be zipped (reported by DK) -TD
* modify LYDownload.c to skip over delimiter for file://localhost to avoid
  treating it as part of the DOS filename -DK
* alter LYExecv() to only do an HTAlert if the return-code is zero, i.e., an
  error was reported.  This lets us reuse (and free) memory pointed to by
  tmpbuf (reported by DK) -TD
* remove redefinition of lstat() and change test of stat() function with DJGPP,
  which returns nonzero rather than negative on failure -DK
1999-06-18 (2.8.3dev.2)
* move some of the path-manipulation from the DJGPP dired change into new
  functions LYisAbsPath, LYisRootPath and LYLastPathSep -TD
* integrated patch adapted by DK from Igor B Poretsky <root@goga.energo.ru> for
  dired support with DJGPP.  (Some corrections/rework by TD also - must
  retest).  Some notes from DK:
  + since this is DJGPP based, it may be incompatible with a called program
    that uses a WATCOM DOS extender.  I think I had this problem with a
    precompiled binary for zip.  The current zip binary doesn't have this
    problem.
  + The key to making this work with DJGPP is the __sysflags = 0x501d in
    LYMain.c, since this lets the system() call handle multiple commands on one
    line and allows the cd command to work across disks.
  + I didn't look at Igor's changes to LYMainLoop.c as regards to the HTUncache
    calls.  He said he wasn't sure about this.
  + This was tested with Info-Zip's zip and unzip, GNU tar, gzip, comp430d,
    PKZIP, and PKUNZIP.  This was only tested when built with slang.  I don't
    see where PDCurses is likely to cause a problem, however.
  Problems:
  + To make this work, I made lynx_edit_mode = TRUE in LYMainLoop.c.  This does
    not seem to be the correct solution.  It seems that this should be handled
    by the code in HTAccess.c, but I don't understand how this works.  If
    lynx_edit_mode isn't true, the dired menu doesn't appear with the "f"
    invocation of LYK_DIRED_MENU.
  + I'll try to explain this briefly, but this bug is very reproducible.  If a
    program is invoked from the dired menu which needs to interact with the
    user, the system sometimes freezes and has to be rebooted.  For example, a
    call to unzip a zip archive where the files already exist has zip ask if
    the file should be overwritten.  If done initially after lynx is started,
    no keystrokes are accepted and the system always hangs.  If, however, any
    file has been moved or had its name changed via the dired menu, then the
    above problem doesn't occur.  I have tried to see what changes after the
    name change that fixes this problem, but I am stumped.  Gzip and unzip seem
    to have this problem, but PKUNZIP doesn't.
* correct most-recent LYNX_RELEASE_DATE (reported by KW) -TD
* change touchline() call in LYOptions.c to touchwin() in case anyone wants to
  compile with BSD 4.4 curses (reported by IC) -TD
* modified ifdef for DECL_ERRNO to allow for errno to be a macro -TD
* ifdef'd the extern declaration of h_errno in HTTCP.c in case that name is
  also a macro, e.g., for threaded code (reported by Mike Gravitz
  <ddavid@lamar.ColoState.EDU> on AIX 4.3.1.0) -TD
* rename ALLOW_USERS_TO_CHANGE_EXEC_WITHIN_OPTIONS to keep the names less than
  31 characters, and add configure option --enable-change-exec to set the
  ENABLE_OPTS_CHANGE_EXEC ifdef -TD
* correct syntax of popup_choices() within
  ALLOW_USERS_TO_CHANGE_EXEC_WITHIN_OPTIONS ifdef (reported by IC) -KW
* modified some message texts, mostly for consistency -KW
* correct display of local file times in INFO screen -KW
* add null-pointer checks for buf2 variable in
  exit_immediately_with_error_message().  Invalid memory access happens if
  access to startfile fails but first_file is not true -KW
* change all ifdef's except on for VAX Ultrix that use the presumed predefined
  symbol 'unix' to 'UNIX', which the configure script sets.  Not all Unix
  systems define this in their compiler -TD
  From compiler warning on NetBSD 1.4 (report by JS):
    deprecated symbol "unix" is no longer predefined
* add experimental file-upload, ifdef'd with EXP_FILE_UPLOAD and configured
  with --with-file-upload (adapted from patch by RP) -TD
* document use of '|' pipes in PRINTER commands in lynx.cfg -TD
* add shell script man2hlp.sh, used that to generate lynx.hlp from lynx.man -TD
* SOURCE_CACHE:  source_cache_file and source_cache_chunk are now members of
  HTParentAnchor (where they should belong, not HText nor mutable globals).
  Add one more parse setting member (verbose_img) to HText structure -LP
* correct spelling of ifdef for reload_read_cfg() (reported by KW) -LP
* minor docs tweaks -LP
* test/{sgml.html, unicode.html} files were badly broken for tagsoup mode
  (incorrect html: extra <pre>..</pre> were added inside PRE mode in dev26) -LP
* fix back-slashes conversion for DOSPATH systems when expanding ~ to local
  path (mostly affects information screen) -LP
* correct default value for --disable-persistent-cookies configure option
  (reported by HenSiong Tan <tan@stat.psu.edu>) -TD
* uncomment --with-libjs configure option -TD
1999-06-11 (2.8.3dev.1)
(This is KW's patch, with minor corrections)
* Key handling changes:
  - Extended lynxkeycodes:  a bit flag is used to indicate that the lower bits
    of the value already are a lynxactioncode and need not be looked up again.
    Reduces need for back and forth forward and reverse binding lookups;
    currently only used in some places.
  - Extended lynxkeycodes:  several (currently three) bit flags are used to
    indicate key modifiers.
  - Added some macros for manipulating and mapping of these codes, see
    especially LYKeymap.h, LKC_TO_LAC() etc.  Added some comments about the
    various kinds of codes.
  - Added several editaction codes and flags for setting key modifier on next
    key (i.e.  for declaring keys as prefix keys, for the purposes of line
    editing); for flagging a key for different action if same key is repeated;
    for exiting input field line editing and passing a specific lynxactioncode
    on; and for undoing 8-bit C1 -> 7-bit replacement transformation for some
    chars.  Added code to line-editor implementation to react to these new
    editactions.  Note that the mapping of lynxkeycode to lynxactioncode
    outside of line editing, i.e.  KEYMAP in lynx.cfg etc., ignores the
    modifiers.  The main loop just drops modifier flags or ignores the modified
    key; modifier flags cannot be used in lynx.cfg KEYMAP 'keystroke' values.
  - An ESC not recognized as part of an escape sequence can set the appropriate
    modifier flag in LYgetch(), except for SLANG which normally uses a
    different LYgetch() implementation.  Interpreting an ESC prefix as modifier
    is very useful for situations where a held-down Alt key (or some other key)
    is encoded this way:  linux console, kermit with emacs key mappings,
    possibly xterm with '*eightBitInput:  false'.  OTOH it doesn't work for all
    characters or in all situations.
  - Extended syntax recognized in .lynx-keymaps file (which is only used if
    compiling with USE_KEYMAPS defined, which in turn depends on slang and
    ncurses version):
    (a) Meta-foo can be used to map an escape sequence to a key + modifier.
    (b) LAC:foo can be used to map an escape sequence directly to a
        lynxactioncode (actually, to an extended lynxkeycode that
        encapsulates a lynxactioncode).
    See examples added to samples/lynx-keymaps.
  - Extended syntax of KEYMAP option, additional field can override line-editor
    behavior.  PASS documented in lynx.cfg.
  - Extended syntax that can be used for specifying key in KEYMAP, some of the
    forms allowed in .lynx-keymaps file are now additionally recognized, but
    only if compiling with USE_KEYMAPS defined.  Left undocumented in lynx.cfg
    (maybe subject to change).
  - New "Bash-like" Line Editor binding.  Adds several new emacs-like editing
    functions.  Adds tables for keys with modifiers (actually the same table is
    currently used for all modifiers, to save some space).  Most notably, ^X is
    a prefix key to set a modifier flag.  Keys with second function when
    pressed twice are ^E^E and ^K^K.  ESC is also recognized as setting a
    modifier flag, in case it gets through without been having been handled in
    LYgetch().  See new file keystrokes/bashlike_edit_help.html for more info.
    The Bash-like Line Editor Bindings are only compiled in if compiled with
    -DEXP_ALT_BINDINGS / configured with --enable-alt-bindings (but not subject
    to a new macro).  Implementation code for the new emacs-like functions
    additionally ifdef'd with ENHANCED_LINEEDIT.
  - Avoid dependency on DNARROW key binding when form field line-editing is
    ended with Enter or Return key.
  - Take setting of real_c/old_c into consideration after return from form
    field line-editing.  Previously there were some strange effects:
    statusline messages would sometimes not appear when they should, the KEYMAP
    command would sometimes not work when invoked with ^Vk while in a form
    field.
  - Make NOCACHE ('x') work for TEXT_SUBMIT_TYPE form fields (i.e.  forms with
    a single text input field where Enter automatically submits).  Of course
    'x' has to be typed as ^Vx while line-editing the field (or NOCACHE mapped
    to a different key).  Similarly allow DOWNLOAD, and HEAD to work for such
    fields.  Try to ensure that all permission checks that apply to other form
    submissions are also done for TEXT_SUBMIT_TYPE fields, this wasn't the case
    before.
  - New key actions LPOS_PREV_LINK and LPOS_NEXT_LINK.  They are like PREV_LINK
    and NEXT_LINK, with the difference that, when moving to a form input or
    textarea line, the last column position (relative to the field) is
    remembered.  They are not mapped by default, but mentioned in lynx.cfg.
  - New key action DWIMHELP.  It should give some context-sensitive help.
    Currently the appropriate Line Editor Binding help page is shown if a form
    input field is selected, otherwise it defaults to the main HELP page.
  - New key action DWIMEDIT.  Revert meaning of EDIT back to previous meaning:
    always edit document file, not textarea content.  DWIMEDIT acts like
    EDITTEXTAREA if the current link is a form textarea or input field and
    AUTOEXTEDIT was defined, and like EDIT otherwise.  Also added slightly
    different statusline message if form field external editing cannot be done
    because editing is disabled:  it shouldn't refer to "The 'e'dit command".
  - Summary of reasonable ways to invoke external texarea editing (assuming
    that it is desired to keep the action of 'e' to edit files at least outside
    of input fields):
    1) KEYMAP 'e' to DWIMEDIT, invoke ^Ve.  (if AUTOEXTEDIT is defined,
       which is the case by default.)
    1a) KEYMAP <some other key> to DWIMEDIT, invoke ^V<some other key>.
    1b) KEYMAP <some other key> to EDITTEXTAREA, invoke ^V<some other key>.
    2) KEYMAP a key (function or control, not printable!) to EDITTEXTAREA
       or DWIMEDIT, using PASS in the KEYMAP line.
    2a) Find some key whose LineEdit binding is already LYE_FORM_PASS, and
        KEYMAP it to EDITTEXTAREA or DWIMEDIT.
    3) compile with EXP_ALT_BINDINGS defined (--enable-alt-bindings),
       select Bash-like Bindings,
       invoke ^E^E or ^X^E (or ESC ^E aka M-C-e), or
       invoke ^Xe (or ESC e aka M-e), or
    3a) compile with EXP_ALT_BINDINGS defined (--enable-alt-bindings),
        and without selecting Bash-like Bindings
        (invoke ESC ^E aka M-C-e or ESC e aka M-e).
    Bindings in parentheses under 3/3a may not work with slang unless a
    tweaked .lynx-keymaps file is used.
* Other changes related to textarea handling:
  - More appropriate message statusline message if GROWTEXTAREA or INSERTFILE
    cannot be done because a textarea is not selected:  it shouldn't refer to
    "external editor".
  - Check whether an editor is defined before trying to use it for textarea
    editing.  Generate message if spawning of external textarea editor failed.
  - Allow INSERTFILE only if file access is not restricted.
  - Enforce dotfiles restriction and "show dot files" setting for INSERTFILE.
* Mouse handling changes, mostly only if mouse support comes via ncurses:
  - Re-enabled changing link by clicking in area *near* a link (but not on the
    link text), but limit max.  distance to 2 character positions.
  - Make mouse popup menu disappear when it should, by applying the right magic
    touchline() in popup_choice().
  - Lots of small tweaks to remove glitches in mouse handling, among them:  No
    left scrolling of long input fields on entering with mouse.  Try to ensure
    statusline is updated after mouse menu.  Make menu actions work as
    expected.  Avoid acting on mouse events, especially invoking mouse menu, in
    wrong context (e.g.  while at a prompt), at least in many places.
  - Clicking on left or right border of mouse menu now only moves selection.
  - At right end of top/bottom line, where single click causes HISTORY action,
    double click now causes VLINKS action.
  - Allow to distinguish between submitting and just positioning into a
    TEXT_SUBMIT_TYPE input field.  Single click positions, double click
    submits, 'activate' from menu also submits.
  - When initializing ncurses mouse, call mousemask() with only those bits set
    that we may actually be interested in.
* Changes relevant for handling window size changes:
  - For ncurses, changed the way how mainloop() notifies the curses library
    about a window size change.  The approach taken previously, and still used
    if we are not using ncurses, has more overhead, can unnecessarily switch
    out of the alternative screen buffer (and back) under xterm, and didn't
    really make ncurses update the WINDOW structures for the new size in time.
  - Other tweaks for size change:  make sure curdoc.link is valid after
    refresh.
  - Detection of size changes in more situations:  tolerate EOF from GetChar in
    the (non-SLANG) LYgetch_for() in more cases if errno is EINTR, if this
    happens check for a size change and generate trace output.  Recognize
    KEY_RESIZE from ncurses, check for a size change and generate trace output
    when it occurs.
  - Added NONRESTARTING_SIGWINCH lynx.cfg option and -nonrestarting_sigwinch
    flag.  If set, lynx *may* react more immediately to window size changes
    when running under xterm or similar.  Whether this actually has an effect
    depends on the implementation of sigaction() and on the behavior of the
    curses (or similar) library when a read() (or other system call) is
    interrupted by signals.
    Depends on '#if HAVE_SIGACTION', which currently has to be defined by hand,
    for example by 'make SITE_DEFS="-DHAVE_SIGACTION"'.  The command line flag
    is only available on systems with HAVE_SIGACTION and SIGWINCH.
  - Tweaks so that lynx in an xterm can survive when the window size is made
    (probably temporarily) very small, for example 1x1.  Avoid display_page's
    work if it wouldn't be displayable anyway.  Make display_title handle very
    small screen widths, at least to the degree that it doesn't crash.
* Except for VMS or when DOSPATH is defined, set restore_sigpipe_for_children.
  Fixes Debian bug #33853, maybe not really a bug but let's be nice.
* Changes in HTTCP.c:
  - Added a CTRACE_FLUSH before creation of NSL_FORK child process.
  - Block certain signals during creation of NSL_FORK child process, if
    sigprocmask() and friends are available.  This should prevent a rare
    problem where sometimes the child process could be killed before it has a
    chance to modify its signal handlers, resulting in screen corruption, a
    seemingly hanging lynx, and/or other problems.  It is assumed that
    sigprocmask() etc.  are available if HAVE_SIGACTION is true.  It currently
    has to be defined by hand, for example by 'make
    SITE_LYDEFS="-DHAVE_SIGACTION"'.
  - Generate diagnostic messages for some failures of forked lookup.  Depends
    on HAVE_H_ERRNO.  In particular, try to detect whether the child process
    failed because of memory problems, and also fake a 'z' in that case to
    short-circuit a URL guessing cycle.
  - For most systems, generate more trace output for connection attempts, close
    to the actual connect() and select() calls to prevent clobbering errno.
    See SOCKET_DEBUG_TRACE.  This should help diagnose some obscure
    system-dependent problems that have occasionally been reported.
* Added some missing stuff for color handling to forms Option Menu code.
* Printing to screen sometimes didn't show anything for short texts, if screen
  output was buffered (and ncurses makes stdout buffered).  Added another
  fflush(stdout) in send_file_to_screen().
* Some checks for specific URLs (helpfilepath, lynxlistfile, and lynxjumpfile)
  in LYGetFile.c were inappropriately case-insensitive for Unix.  The
  comparison is now case-sensitive except for VMS.  This may need tweaking for
  DOS and similar systems.
* Added additional LYNoRefererForThis check in getfile(), the one in mainloop()
  could be missed for TEXT_SUBMIT_TYPE form fields.  Also moved other check for
  whether to send Referer header earlier, and made it apply for URL types that
  might be proxied.
* LYAddVisitedLink tried to regard documents with the same address but a
  different title string as different documents, but this was coded wrong.
  Removed ineffective comparison, but keep old title string if new title string
  is empty.
* Correct long-standing logic error in MAIL_SYSTEM_ERROR_LOGGING handling.
  Apparently not many people are using it...
* Fix for traversal code to put the right address into the TRAVERSE_REJECT_FILE
  if a request fails after popping a document from the history stack (this can
  only occur if a previous request for the same document had succeeded).  Also
  don't try to send mail in such a case if MAIL_SYSTEM_ERROR_LOGGING is on.
  Also prevent possible history stack underflow if this occurs on return to the
  first document.
* According to lynx.cfg, error logging mail may be sent to ALERTMAIL if no
  document owner is known, but this was not implemented; now it is.  ALERTMAIL
  is used if it is defined non-empty in userdefs.h.  Of course normally it
  should be left undefined.
* Fix for traversal code to reject form fields a bit earlier.  This prevents
  unnecessary lookups as well as adding of an empty line to the
  TRAVERSE_REJECT_FILE for each form field encountered.
* Format -crawl output as was documented in CRAWL.announce:  with this switch,
  link numbering is always off by default (userdefs.h and lynx.cfg defaults und
  saved user preference are ignored) unless -number_links is given, and -crawl
  -traversal format is now consistent with -crawl -dump with respect to link
  numbering.  As a side effect, -crawl without either -traversal or -dump now
  also turns link numbering off unless -number_links is used (the meaning of
  -crawl without either of these was undocumented), so it then acts effectively
  as a (less powerful) negation of the -number_links switch.
* For -crawl -dump, the list of links was appended twice.  Fixed.
* Check URL as well as title before deciding that a document should not be
  pushed on the history stack because it looks like a generated special page.
* Made "Don't waste the cache" optimization in historytarget() subject to
  additional checks, to avoid uncaching of the wrong document in some cases.
* LYSafeGets() would drop the last line from a file if it was not terminated.
  Changed to return the unterminated line like fgets().
* Clarifications on restrictions.  "download" does not imply "disk_save" while
  "print" does, this doesn't seem to make much sense but has been the behavior
  for a long time.
* Restrictions inside_news, outside_news now apply to reading as well as
  posting.  The documentation (except for the corresponding comments in
  userdefs.h) said that they apply to posting, while in fact they were
  implemented for reading only.  [Does nobody read this stuff???] Also, the
  implementation only checked the flag for news:  URLs, but not for nntp:
  URLs, which doesn't make much sense given that the latter provide an
  alternative way for most (if not all) purposes of the first.  So now these
  restrictions apply to news:, nntp:, newspost:, and newsreply:  (but not to
  snews:, snewspost:, or snewsreply:).
* Document -restrictions=externals.
* Some of the restriction stuff not added to VMS lynx.hlp file, since I'm not
  quite sure whether the corresponding features work there at all.
* Changed restriction parsing so that "all" and "default" don't get ignored if
  they appear as one of several items in the same list.
* Implement listing of current restrictions to stdout with new -restrictions=?
  option.  This should appear as the last command line option, otherwise the
  effect of options appearing later may not be shown.  The '?' may require
  quoting.
* Made -restrictions= (without any option flags) act like -restrictions
  (without equal sign either) as implied by documentation, i.e.  list
  recognized restriction options.
* LYRestricted has been greatly abused.  Once upon a time it was a PRIVATE flag
  in LYMain.c (then called anon_restrictions_set), used only to get the
  precedence of various command line options right.  Recently it has been
  misused as a check (and as the only one) whether "anonymous restrictions" are
  in effect.  This undermines various assumptions:
  - that -anonymous is basically an aggregate set of restrictions which could
    be specified individually with -restrictions=.
  - that individually listed restrictions (-restrictions=...) act as expected,
    and can be used to restrict various aspects in a useful manner.
  - that -validate implies the strongest restrictions, except for what is
    explicitly exempted (i.e. 'g'oto for http/https URLs).
  Use specific restrictions instead:
  - new "compileopts_info" for LYNXCOMPILEOPTS:  - for anonymous default see
    userdefs.h
  - new "lynxcfg_info" for LYNXCFG: - for anonymous default see userdefs.h
  - new "lynxcfg_xinfo" for extended LYNXCFG: - for anonymous default see
    userdefs.h
  - new invisible "goto_configinfo" for LYNXCOMPILEOPTS: & LYNXCFG: for
    anonymous default, see userdefs.h
  - additionally check existing "option_save" for LYNXCFG://reload/ -
    always restricted by anonymous default
  ("invisible" means that this restriction cannot be explicitly listed in a
  -restrictions=...  list, but has a value derived from userdefs.h that is used
  with -anonymous and -restrictions=default.)
* Forms options menu can now be used with -validate.
* Allow following local help file links, even if "file_url" restriction is set,
  from LYNXKEYMAP, LYNXCOOKIES.  (Possibly more need to be added.)
* Apparently realm checking (with -realm option) is bypassed for URLs from
  (some) form submissions (it seems to be intentional, but why?).  Made sure
  this at least doesn't weaken -validate restrictions.
* Apply -localhost check in getfile for news URLs that include a hostname,
  i.e., that begin with with "news://".
* Add '&' to nonalphanumeric characters forbidden by exec_ok() for lynxexec and
  lynxprog URLs, but keep allowing it for lynxcgi.  There's not much point in
  excluding ';' and so on if '&' is acceptable!
* Tweaked LYNXMESSAGES:  handling slightly:  don't bypass normal getfile
  handling.
* Reset LYforce_no_cache flag in mainloop() after failed access, before popping
  the previous (or, actually, probably currently still displayed) document.
* Tweak for 'no data' handling:  it isn't always an error, but was sometimes
  treated as such.  It mostly doesn't make a difference, except for the message
  printed when the startfile cannot be accessed and for traversal and mail
  error logging.  This needs to be revised to apply for all protocols.
* Added new functionality for rules:  Redirect, UseProxy, various others.  See
  cernrules.txt in samples directory for details.
* Prevent crashes in HTNews.c with HEAD.
* Allow HEAD requests for proxied URLs (checking whether any applicable proxy
  begins with http:  or lynxcgi:), as far as this can be determined based on
  regular environment settings (i.e.  unaware of proxying by rules).
* Modified add_item_to_list() so that if the restriction flag is omitted from a
  DOWNLOADER/UPLOADER/EXTERNAL line in lynx.cfg, it is assumed FALSE.  This
  modifies the change of 1998-10-17 to be on the safer side, it is more
  consistent with how PRINTER lines or lines with the colon separator present
  but the flag value absent are handled, and it only makes a difference when a
  -restriction command line option or its equivalent is in effect anyway.
* Deal with unusual cases where telnet and similar protocols are proxied, or
  possibly changed to a different type of protocol by rules.  Normally such
  protocols should never be proxied, but there was no protection against it,
  and lynx could crash.  The approach now taken does not disallow it, but just
  tries to deal with the situation in a way that avoids crashing; it is
  conceivable that one may want to direct e.g.  telnet or rlogin URLs to a HTTP
  page that explains why theses types are not supported.  A similar problem
  that occurred when e.g.  telnet was forbidden by a rule is also dealt with.
* Protect start_curses calls in getfile against being executed if
  dump_output_immediately is in effect.  Maybe access to telnet, rlogin,
  lynxexec URLs should be completely disabled for this case; skipping the
  start_curses at least avoids being left with non-restored tty settings after
  the program exits, is someone attempts to use -dump or -source with such a
  URL (the -dump or -source flags is then effectively more or less ignored).
* Tweaks in fix_http_urls, renamed fix_httplike_urls.
* Moved LYStrerror from LYStrings.{h,c} to HTAlert.{h,c}, so that it can be
  used in HT*.c files without pulling in yet more LY*.h headers.
* Reset 'safe' flag in anchor on parsing "Safe: no" and "Safe: false" headers.
* The top makefile.in had some 'rm -rf' for whole directories $(helpdir) and
  $(docdir) in install targets that could potentially wipe out unrelated files;
  added checks to make sure the directories haven't been changed to something
  not lynx-specific (they are regarded as lynx-specific if the last component
  is lynx_help and lynx_doc, respectively).
* Various doc tweaks.
* Updated README.defines.  Other contributors should please add their stuff
  there, too.
* Additional non-option args (before the last one), i.e.  URLs or filenames,
  are made available for 'g'oto recall.  If unwanted, this can be disabled by
  changing EXTENDED_STARTFILE_RECALL in LYMain.c -KW
* In UCChangeTerminalCodepage() used for --enable-font-switch with linux:  use
  LYOpenTemp() etc.  instead of tempnam(), this avoids "Invalid pointer" with
  LY_FIND_LEAKS and avoids leaving old temporary files hanging around in some
  situations.  Also added some error checking -KW

1999-06-01 (2.8.2rel.1)
-----------------------
1999-06-01 (2.8.2pre.11)
* minor fixes from W3C HTML validation -TD
* update links to HTML'ized lynxcfg in users' guide -VH
1999-05-31 (2.8.2pre.10)
* add links to HTML'ized lynxcfg to users' guide -LP
* cleanup temporary files left by
     lynx -dump LYNXCFG:// > /dev/null
  (analysis by LP) -VH
* add comments to lynx.cfg describing effect of restricting configuration
  settings in nested includes -VH
* delineate URL's in README with "<URL:" and ">", with space in lynx.man -LV
* add some comments to lynx.lss -TD
* minor improvements to configure script:  use newer config.guess and
  config.sub from xterm, which adds case for HP 9000/800 (fix problem reported
  by Peter Jones <jones.peter@uqam.ca>) -TD
1999-05-29 (2.8.2pre.9)
* use StrAllocCopy rather than HTSprintf in LYstore_message() because no
  formatting is done there; the message may contain formatting controls such as
  %s (related to bug report by Frederic L W Meunier <fredlwm@urbi.com.br>) -TD
* add/use function LYRenamedTemp() to update our record of temporary filename
  when using external decompression program, so we will remove the decompressed
  file correctly on exit.  This is the usual case if we do not link with zlib
  (reported by HN) -TD
* modify LYValidateFilename() to derive original directory preferably from
  Current_Dir() rather than environment variable $PWD, since the $PWD directory
  may not be writable if Lynx is invoked from another application rather than
  directly from the command line -TD
* add/use function Current_Dir(), to check for failure in getcwd/getwd -TD
* change ALL_LINGUAS assignment in configure script to use the .po file which
  actually reside in the po directory, making it simpler to drop/add message
  files from a distribution of Lynx.  Also, make the assignment contigent on
  ALL_LINGUAS not being set externally, making it simple to override -TD
1999-05-28 (2.8.2pre.8)
* when reloading/reparsing the document with forms, issue a warning only when
  user input is detected (forms content is changed from its default so
  information will be lost).  New function HText_HaveUserChangedForms() is
  called from HTReparse_document() and HTuncache_current_document() -LP
* fix exit from postoptions() when need_reload is set but no source_cache,
  was broken in dev23 -LP
* remove unneeded float from integer calculations -LP
* move comment for 'const' off the definition line, to simplify debugging
  configure problem on HPUX for David Eaton -TD
* move LYGetYX() out of conditional expression, just in case it cannot be
  evaluated as a function, i.e., return a value (from bug report by David
  Eaton) -TD
* make install for COPYHEADER and COPYING work when the build directory is not
  the top source directory -PG
* add check to FastTrimColorClass() to avoid updating stylename and pointer
  into it when the tag to be trimmed is not found (fixes a core dump reported
  by VH) -TD
1999-05-25 (2.8.2pre.7)
* update illustration of forms options menu in Lynx User Guide according to
  current lynx output -LP
* old-style options menu:  hot key for "local e(X)ecution links" is now
  displayed in bold (call addlbl() instead of addstr() like the other options
  do), adapted from Hiroyuki diffs -LP
* fix handling of incorrect html in psrc mode.  If a piece of html matched the
  pattern "<known_tag_name unknown_attr_name any_attr_name>", then styles of
  internal markup were unbalanced - resulted in cluttered colors -VH
* comment-out (for release) configure option --enable-libjs -TD
* change configure script defaults for --enable-persistent-cookies and
  --enable-alt-bindings to 'yes' -TD
* add DESTDIR variable to top-level makefile to facilitate packaging releases
  with compiled-in pathnames -TD
* further correction to VMS pathname in HFTPLoad.c, to translate /vms/fileserv/
  to [vms.fileserv], for example.  The wku fileserver gives back a Unix-style
  listing rather than VMS-style when given a Unix-style CWD, which confuses
  Lynx into discarding the listing (reported by Andy Harper) -TD
* modify LYCookies.c to append new items to the end of the list rather than
  at the start, so cookies will be written and read from .lynx_cookies in
  consistent order (reported by KED) -TD
1999-05-24 (2.8.2pre.6)
* fix for problem reported by LP -VH
  Load an html file with META charset and switch "\" to source mode.  Now press
  ^R to reload:
  (1) In -prettysrc case you got a broken document (charset will be assumed by
    lynx from assume_charset or assume_local_charset, not from a META charset
    which was previously pushed with LYPushAssumed() so you get a problem with
    8bit documents when assume_charset != META charset).
  (2) Without -prettysrc you got a document handled properly via META charset
    assumption.  Now if you press ^R again you will get a broken document.
* LYK_SOURCE & HTreparse_document():  when using SOURCE_CACHE_MEMORY fix tiny
  charset problem when switching to the source mode and the original document
  have its charset specified.  Now aligned with SOURCE_CACHE_NONE and
  SOURCE_CACHE_FILE.  More LYK_SOURCE fixes that might affect next coming
  document in come cases (mainly Info page and Options menu, which now show
  correct charset information) -LP
* add CTRACE_FLUSH call before fork() in NSL_FORK logic so child's messages
  will not mess parent ones -LP
* add a few trace messages -LP
* HTReadProgress message now display statusline properly in TRACE mode
  (was always broken since early HTReadProgress days) -LP
* install COPYING and COPYRIGHT for install-help rule as well as install-doc,
  so we can refer to local copies of those files -TD
* tweak HTParse trace message -LP
* minor formatting change for Lynx_users_guide.html -Hiroyuki
* correct a few mismatches between variable declarations (char vs BOOLEAN)
  (from win32 version by Hiroyuki Senshu <senshu@shonai-cit.ac.jp>).
1999-05-20 (2.8.2pre.5)
* correct links to COPYHEADER and COPYING in about_lynx.html, by pointing to
  author's URLs, rather than to files which are not installed anyway -PG
* shorten a couple of identifiers to keep with 31-character limit:
  hash_code_aggregate_lower_on_fly -> hash_code_aggregate_lower_str
  LYprint_statusline_messages_on_exit -> LYstatusline_messages_on_exit
  (reported by Andy Harper) -TD
* correct VMS pathname in HTFTPLoad(), allowing connect to
  ftp://ftp.wku.edu/vms/fileserv (reported by Andy Harper) -TD
* chartrans:  cpXXXX Microsoft codepages verified against ftp.unicode.org -
  apparently cp1256 (Arabic) was updated recently.  Although Arabic letters are
  hardly useful for lynx (no right-to-left support) this codepage is supported
  under chrtrans.  So update, just for fun -LP
* fix core dump when starting "lynx LYNXOPTIONS:" command.  All phases of forms
  options logic now handled by postoptions():  LYNXOPTIONS:/ without post_data
  create a page (gen_options() now PRIVATE), LYNXOPTIONS:/ with post_data do
  proccess changes as before.  Also LYK_ADD_BOOKMARK fixed:  forms options page
  will not be added to bookmarks file -LP
* modify HTGetRelLinkNum(), removing increment of HText_getTopOfScreen() value
  so checks for line number begin at the very top of the screen, fixing a
  problem reported when processing the 123[g][+-] command -LE
* minor change to LYReadCFG.c to combine similar gettext'd strings -HN
1999-05-16 (2.8.2pre.4)
* add 'fixit' parameter to LYEnsureAbsoluteURL() to suppress logic in
  LYConvertToURL() that was changed in 2.8.1dev.4, to re-offer the original
  string after an invalid URL is entered at a 'g' prompt.  The calls to support
  'g' are unmodified; other calls revert to the older behavior (recommended by
  KW) -TD
* add/use string functions that make EBCDIC comparisons sort in the ASCII
  collating sequence, eliminating some special ifdef's in HTMLDTD.c -PG
* when STARTFILE cannot not be loaded, lynx now exits with more understandable
  status messages:  all important statusline messages are now printed to
  stderr/stdout -LP
* add definition for _DECC_V4_SOURCE for VMS SOCKETSHR_TCP configuration to
  top-level and ./src build*.com files (reported by Andy Harper) -TD
* change UNKNOWN_URL_TYPE to 1, to keep it distinct from NOT_A_URL_TYPE, fixes
  an error introduced when changing UrlTypes to an enum (reported by KW) -TD
1999-05-12 (2.8.2pre.3)
* add DEBUG_SOURCE_CACHE makefile flag so all documents will be cached in
  SOURCE_CACHE mode, including local files.  Normally undef'ed so only http
  served documents cached with sources -LP
* in LYK_HISTORY, set newdoc.link = 1 so position at link #2 bypassing "recent
  statusline messages" link -LP
* comment out "partial_thres=" option in .lynxrc (it was coded so the changes
  from lynx.cfg file could not be activated) -LP
* add a sanity check to LYCurses.h to point out problems with the FANCY_CURSES
  configure checks -TD
* fix uninitialized pointer used in decoding of -term switch (patch by Sergey
  Svishchev)
* define _DECC_V4_SOURCE for VMS SOCKETSHR_TCP configuration, to fix conflict
  with unistd.h versus non-POSIX prototypes in the other headers (report by
  Andy Harper) -TD
* ifdef'd includes for HTUtils.h to limit size of preprocessor listings with
  DEC C; verify that all header files include definitions needed for their
  contents -TD
* add docs/OS-390.announce (Paul Gilmartin <pg@sweng.stortek.com>)
* add fallback extern declaration for h_errno to HTTCP.c for systems that have
  that variable but do not declare it (reported by Jean-Pierre Radley
  <jpr@jpr.com> for SCO OpenServer 5.0.5) -BL
* correct SortaSGML element info: SPAN can contain SPAN -KW
* fix several small memory leaks (John Bley):
  + minor (~ 7 bytes) leak in LYCookie.c
  + leak in the warning message about invalid cookies
  + obvious leak in do_readme
  + small leak in dired_options (LYLocal.c)
  + leak with -selective option in HTFile.c
  + a few leaks and a minor cleanup in local_dired
1999-05-08 (2.8.2pre.2)
* substitute a few more free()s with FREE()s in files HTString.c and
  LYReadCFG.c (John Bley)
* fix buffer problems with long filenames and custom DOWNLOADERs (John Bley)
* fix typical alloc-fail-return-error-without-free leakage in
  save_bookmark_link (LYBookmark.c) (John Bley)
* modify generated WWW/*/makefile and src/chrtrans/makefile to omit include
  from intl directory if it is not used (report by LP) -TD
* add configure test for h_errno, by splitting CF_ERRNO macro and reusing
  test for external data.  Noticed that DECL_ERRNO was not defined/used,
  added that as well.  The h_errno symbol is provided in some network
  libraries, e.g., on SCO and Linux, but may/may not be declared (report
  by BL) -TD
* fix some serious lossage in lookup_reject (LYTraversal.c): memory and
  logic errors.  This (replaced) line is one for the record books:
      frag = strlen(buffer) - 1; /* real length, minus trailing null */
  Previously, this code caused a read before an array boundary as well as
  failing to compare the right number of characters in a pattern (John Bley)
* fix some minor leakage in the cookie jar (John Bley)
* fix up some casts and mode_t types in HTAAProt.c, HTFile.c, LYLocal.c,
  LYUtils.c (John Bley)
1999-05-05 (2.8.2dev.26 - 2.8.2pre.1)
* remove some weird cruft from HTAAUtil.h (yeah, "/home2/luotonen" is a good
  default path) (John Bley)
* correct a buffer overflow in LYDownload.c (reported by John Bley) -TD
* 8bit attribute values are now translated in psrc view (reported by LP) -VH
* trailing ';' now is shown after HTML entities (reported by LP) -VH
* split-up/correct typo in text at top of generated bookmark file -JS, -TD
* allow anchors as input for commands 'g','G','E' -VH
* correct off-by-one error in pointer to filename in DOSPATH configuration for
  LYPathLeaf() -DK
* fix infinite recursion bug in lynx.cfg includes, from dev.25 integration
  (reported by LP) -VH
* implement the following separators in lynx.cfg "include" commands:
  ":" on Unix
  " for " on all OS's -VH
* fixes for LYList.c,  adding title info to the (mostly unused) HTLinkType -KW
* change remaining <banner>'s to <blockquote> in other html files, fix
  a few escapes that tidy (15-apr-99) reports.  Leaving <tab>'s alone for the
  moment because there appears to be no standard equivalent -TD
* change <banner> in lynx-dev.html to <blockquote> since the latter is
  standard, correct IEFT version and supply <p>'s as needed (Karl Eichwalder)
* correct a couple of two documentation inconsistencies in the sources for
  USE_PSRC and -prettysrc (Karl Eichwalder <ke@gnu.franken.de>)
* register free_messages_stack with atexit to fix some statusline leakage,
  explicitly fill out a struct initializer (John Bley)
* fix a few html nits in the docs (John Bley)
* cleanup some gcc -Wundef warnings -TD
* add logic to free_lynx_cfg() to unset environment variables (requested by
  LP) -TD
* modify SafeHTUnEscape() to work with EBCDIC (pg@sweng.stortek.com)
* remove dangling comma in UrlTypes enum (reported by pg@sweng.stortek.com) -TD
* make description of STARTFILE in userdefs.h agree with lynx.cfg -TD
* fix:  newline position when we come from the history stack and cached HText
  is used (say, return from 'p'rint menu), was broken in dev23 -LP
* remove numerous HTMLSetCharacterHandling() calls from getfile(), use single
  call in mainloop instead -LP
* #define PUTS() in LYCookie.c and LYMap.c to make code more readable -LP
* fix:  LYmouse_menu() in LYStrings.c calls popup_choice(), which is #ifdef'd
  out when --disable-menu-options is used (patch by Sergey Svishchev)
* modify generated src/makefile to omit include from intl directory if it is
  not used.  This in turn required fixing a redefinition of gettext on Solaris
  when using cc, since the locale.h file includes Sun's libintl.h file which
  prototypes gettext.  Successfully built/ran using Sun's msgfmt utility, (had
  to manually add -lintl to src/makefile) though the generated message objects
  are incompatible, resulting in a core dump if not reinstalled (unnecessary
  include reported by LP) -TD
* change VMS WWW descrip.mms file to use prefix=all rather than prefix=ansi, so
  that POSIX functions such as 'read()' are linked properly (reported by Andy
  Harper) this is a detail I overlooked in dev.18 -TD
* fixes to compile with SunOS K&R cc -TD
1999-04-27 (2.8.2dev.25)
* updates to INSTALLATION -HN
* undo some redundant dev23 changes, in particular PSRC_TEST in HText_new
  was responsible for a wrong line breaking in -prettysrc mode
  (try "lynx .  -prettysrc" and press "\" to see wrapping with altered
  define).  Also fix Visited Links for internal pages -LP
* restore links in lynx-dev.html to original form, to make redirection work
  properly -TD
* add to MAKEFILE.W32 (untested - suggested by LP) -TD
  * definitions for DISP_PARTIAL;SOURCE_CACHE;USE_PSRC
  * lypretty.obj to the list of objects.
* remove CF_MAKE_INCLUDE from configure script, since it is not needed -TD
* merge WWW/Library/Implementation/CommonMakefile into WWW/.../makefile.in -TD
* corrections/simplification of LYSafeGets(), and remove sizeof(buf) from
  related code in LYCookie.c (analysis by KW) -TD
1999-04-23 (2.8.2dev.24)
* added overlooked WWW/Library/Implementation/makefile.in -TD
1999-04-23 (2.8.2dev.23)
* add/use new function LYSafeGets to replace reads into fixed-size buffers -TD
* change xxxx_URL_TYPE definitions in LYUtils.h to a enum -TD
* use HTSprintf0 in LYCurses.c, LYReadCFG.c -TD
* implement restrictions on options that can be set via the lynx.cfg "include"
  directive -VH
  For example, admins may specify
    include:~/.lynx/colors:COLOR
    include:~/.lynx/keymap:KEYMAP
    include:~/.lynx/viewers:VIEWER
  safely - and be sure that no critical options were altered by those files.
  The syntax is
    include:<filename>[:[<OPTNAME>* ] ]
  More samples:
    include:~/.lynx/rc:COLOR KEYMAP VIEWER SUFFIX
    include:/usr/local/lib/lynx-cfg.part: #all settings can be changed
  The patch does this:
  * It prints warnings to stderr about unknown options specified in the list of
    allowed options in include command.  When 'o'->'lynx.cfg'->'RELOAD THE
    CHANGES' is activated, these warnings are also printed on stderr - so the
    screen will be corrupted if lynx.cfg and included are incorrect.
  * Only options, allowed for a given file are printed in
    'o'->'lynx.cfg'->'RELOAD THE CHANGES'.
  * Fully backward compatible - lines of the form
	include:filename
    will work as they did(i.e., if the list of allowed options is not
    specified, then the included file can use the same set of options, as the
    file that contained that 'include' command).
  * If you wish to allow an included file to
    include others, you must specify 'include' in the list of allowed options.
    Sample:
	  include:~/.lynx/suffixes:INCLUDE SUFFIX
    so that users will be able to use 'include' command in '~/.lynx/suffixes'
    (otherwise included file will be unable to include anything).
  * Option sets are ANDed. If file lynx.cfg contains:
  	  include:/usr/lib/lynx.cfg.0:COLOR SUFFIX VIEWER INCLUDE
    and /usr/lib/lynx.cfg.0 contains
        include:/usr/lib/lynx.cfg.1:SUFFIX VIEWER INCLUDE STARTFILE HELPFILE
    then /usr/lib/lynx.cfg.1 can use the following options:
	SUFFIX VIEWER INCLUDE
* change the STARTFILE description in lynx.cfg to offer the user's home
  directory as an alternative to lynx.browser.org (amended this to reflect
  consensus that l.b.o should be the default) -TD
* move a big chunk of code into print_status_message() -LP
* also add numerous HTProgress messages to LYNXMESSAGES:/ page (but not
  HTReadProgress) -LP
* HTAlert, HTUserMsg and HTInfoMsg statusline messages are now stored in a
  cycled buffer and accessible from the History Page as LYNXMESSAGES:/ link.
  This allows us to decrease the messages delay in lynx.cfg when we feel
  messages too annoying, but have a nice history list for diagnostic purposes.
  Uses a 40-line buffer (suggested by Bela Lubkin) -LP
* fix reloading with HTreparse_document() for LYK_MINIMAL, LYK_HISTORICAL,
  LYK_SOFT_DQUOTES, LYK_SWITCH_DTD mainloop events (hope we work around replies
  from POST properly) -LP
* elaborate description in Lynx_users_guide.html for "comments" (Michael
  Sobolev <mss@transas.com>)
* fix --disable-trace (by making the ifdef's directly depend on NO_LYNX_TRACE
  rather than DEBUG), chop more unneeded #includes (John Bley)
* combine WWW/Library/unix and WWW/Library/Implementation to simplify make
  dependencies, drop Makefile.old -TD
* fixes for DOS port - DK
  (a) When exiting with interrupt, the message was printed in binary mode,
      leaving the cursor in the middle of the screen
  (b) In the PDCurses build, the keypad enter key only worked when LYK_ACTIVATE
      was utilized, but not in GOTOLINK or GOTOPAGE.  This maps the keypad
      enter to '\n', so it works in all situations, but keypad enter will no
      longer be able to be mapped separately.  CTRL-PADENTER and ALT-PADENTER
      can still be separately mapped.
* various changes to userdefs.h and lynx.cfg explanatory text -KW
* corrected placement of "partial_thres" code in LYrcFile.c, removed an unused
  prototype in LYUtils.h -KW
* add a note about LYNX_SAVE_SPACE to INSTALLATION -JS
* remove docs/*.old (request by HN) -TD
* update INSTALLATION notes for DJGPP with PDCurses; a suggested patch is
  no longer applicable -DK
* fixes for control/C and control/BREAK handling on DJGPP -DK
* tweak in HTML_start_element case HTML_DT:  prevent generation of empty line
  between multiple simple DT elements without intervening DD elements (Debian
  bug #3846) -KW
* add list of downloaders to lynx_help_main.html -PW
* add attributes for {bq,blockquote}.cite,{frame,iframe,img}.longdesc,
  {table,td}.background, td.{height,width} -VH
* define DISP_PARTIAL for VMS (request by Andy Harper) -TD
* include <unistd.h> for DEC C, to prototype sleep() and alarm().  Ifdef'd
  include of HTString.h by HTUtils.h, but keep include as general rule for
  making headers standalone (report by Andy Harper) -TD
* modified LYrcFile.c to avoid putting '#' characters at the beginning of
  lines, since that confuses VAX C (report by Tony Bolton) -TD
* fix redefinition of h_errno (report by Tony Bolton) -TD
* ifdef'd print_local_dir in HTFile.c since this function does not compile on
  VMS (report by Andy Harper, Tony Bolton) -TD
* fix reload_read_cfg() to avoid persistent cookies mode changing at run time;
  reload printers list, downloaders list, environments - as expected - LP
* fixes for SOURCE_CACHE!=NONE mode, trying to accommodate HTreparse_document()
  for mainloop() events:
  - add/use flag "from_source_cache" for better mainloop maintenance
  - add partial display mode for HTreparse_document() operations
  - add warning when the reparsed document may lose its forms content
  - fix options menu stuff to use HTreparse_document() when possible - LP
* fix exit from postoptions() when the reloaded document was in source mode -LP
* update flags to correct behavior with SOURCE_CACHE!=NONE:  the length of the
  re-rendered text may vary so the scrolling down is broken (especially nice
  when switching to source).  ("more" updated, "lines_in_file" inlined) -LP
* use configure script macro CF_CHECK_CACHE to compile-in Unix SYSTEM_NAME,
  for info screen (request by LP) -TD
* minor fixes for uncaching document, other items missed in dev.22 -LP
* merge the two versions of start_curses() function -LP
* add -DSOURCE_CACHE and -DUSE_PSRC to djgpp makefiles -LP
* add a few words for CHANGES and INSTALLATION -LP
* add a configure option for prettysrc -TD
* separate ifdef's for prettysrc from color-style -LP
* fix for -prettysrc:  when pressing '\' on non-local files, the prettysrc view
  is shown, but there is no way out of this mode -VH
* change all PUTS() with a string of length 1 to PUTC(), fix a uid_t/int
  assumption in LYLocal.c, remove some unneeded #includes, remove some spurious
  semicolons.  (John Bley)
* fix typo in configure --help for --disable-direct (reported by LV) -TD
* update user's guide and lynx.cfg descriptions of jumps files - PW
* fixes for related bugs tweaked by going to an internal page while viewing
  source, and a few blurbs in the documentation -DSB
* fixes to separate RAW_MODE from internal variable LYRawMode by adding new
  variable LYUseDefaultRawMode -LP
* add a missing null-pointer check in expand_tiname() (from report by KW) -TD
1999-04-13 (2.8.2dev.22)
* correct a missing include for LYLeaks.h in UCAuto.c -TD
* implement HTML source caching.  In this implementation, each document kept in
  cache has associated with it a temporary file containing the HTML source for
  the document (well, not all of them -- only those using the HTTP protocol, on
  the premise that file:// documents are probably local and ftp:// documents
  are probably not HTML).  The temporary file is deleted when the document is
  uncached.  For certain operations, instead of reloading the document via
  HTLoad<mumble>(), the source file is reparsed with HTParseFile().  The cached
  document also remembers certain parser settings (screen size, historical vs.
  minimal vs.  valid comment parsing, and the like), and is regenerated from
  source if it is fetched out of cache under different settings.  This behavior
  is selectable by a configure option --enable-source-cache and by a lynx.cfg
  option SOURCE_CACHE; I didn't add a command-line argument or an options menu
  entry, as this didn't seem to be the sort of thing one would want to change
  You had to challenge me, didn't you?  ;) Okay, after some pfutzing around
  with HTChunks, I think I've got a working version of memory caching of
  source.  The SOURCE_CACHE option now has settings FILE, MEMORY and NONE, with
  the obvious meanings, defaulting to NONE.  (DSB - Scott Bigham
  <dsb@cs.duke.edu>)
* amend HTConfirmDefault() logic so that a second character will cause the
  default response to be returned, e.g,. so that pressing "qq" will make
  Lynx exit (reported by John Bley) - TD
* change the PUTS("\n") calls in HTFile.c to PUTC('\n') since that would be
  a little more efficient (noted by KW) - TD
* minor cleanup: remove obsolete parameters from command-line parsing functions
  in LYMain.c, add newlines in HTFile.c for readability of html - LP
* change default STARTFILE to the current directory, "." - PW
* revised lynx-dev.html - PW
* lynx.cfg and further included cfg files can be edited from LYNXCFG:/ page
  with the default editor and changes can be activated for the same lynx
  session.  NOT allowed for restricted users (LYRestricted) and occasionally
  for user mode other than ADVANCED.  This is an *experimental* code
  (reload_read_cfg() in LYMain.c - more work required):  currently command-line
  switches may be lost when overridden by lynx.cfg changes, file paths like
  lynx_save_space and LYCookieFile should not be changed (unwanted results) -LP
* retest PARSE_DEBUG ifdef's (LYMain.c, LYReadCFG.c), minor corrections
  but found no specific reason for LP's problem with tables, except possibly
  different effect from "&(value)" versus "(&value)" - TD
* fix the problem of reading included lynx.cfg files by changing LYReadCFG.c
  table signature (now it is more close to one in LYMain.c).  The problem was
  the ignoring of *some* values got from the included cfg file (at least for
  DJGPP2.02/gcc2.8.1 build).  Probably we calculate the addresses of variables
  on a later stage now.  - LP
* DOSPATH changes: local directory style now configurable from lynx.cfg
  (LONG_LIST defined).  Unlike UNIX it is not "ls -l" by default
  but a more compact form (date and size present, from lynx.cfg example) - LP
* cookies:  domains now match case insensitively (reported by Paul Wagner
  <paul.wagner@mci.com>) - LP
* correct an ifdef in LYGetFile.c for config-page - LP
* reading of long local directories now benefits from partial mode and fully
  interruptible.  Split out print_local_dir() function from HTLoadFile() - LP
* behave sanely if NSL_FORK fork() fails -BL
* NSL_FORK try for dns_patience *seconds*, not dns_patience select() calls,
  which might have been shortened by keyboard input  -BL
* fix some screwy comment indentation -BL
* add section on editing TEXTAREA to user's guide - PW
* add a null-pointer check in LYCookie.c (Bill Nottingham <notting@redhat.com>)
* revise changes ifdef'ing LY_FIND_LEAKS by making atexit a no-op function
  since the DOS port depends on atexit to keep the DOS BREAK function properly
  set on exit.  Put back atexit, and ifdef's each place where atexit isn't
  needed except when finding leaks - DK
* modify LYMain.c on DOS, fixing the determination of BREAK status to be
  independent of SLANG or PDCurses - DK
* spawn a new function, www_user_search_internals, to begin canceling the
  effects of cut-n-paste coding in www_user_search.  The body of
  www_user_search_internals used to be duplicated at two points in
  www_user_search.  See comment in GridText.c for more details.  (John Bley)
* big pile of unneeded #includes removed (John Bley)
* remove obsolete files from the distribution (John Bley)
  WWW/Library/Implementation/HTWriter.*
* one malloc check, fix --disable-ftp (John Bley)
* fixes for compiler warnings when building for OpenVMS 6.2 using DEC C and the
  SOCKETSHR library (reported by Andy Harper) - TD
* add cpp -H option for HPUX bundled C compiler, which otherwise does not
  have enough symbol table space (reported by JS).  Also, modify ifdef's
  for <stdarg.h> vs <varargs.h> to avoid including the former when ANSI_VARARGS
  is not defined since HPUX had a broken <stdarg.h> - TD
* changed OMIT_SCN_KEEPING ifdef to 0 (inactive) in LYCurses.c and in HTML.c,
  still enabling the Style_className:HTML.c keeping and making lynx with lss
  slightly slower than it could be (though faster then dev21).  If somebody
  wishes to fix a bug, here is a description:  If contents of some tag that has
  corresponding color style occupies more than 2 screens, after navigating to
  the page, on which the content of that block starts, and then pressing PGDN
  PGDN PGUP, the effect (color style) of that tag will be lost.  The same
  (loosing style) happens when jumping to the anchor that is in such block and
  is located not on the 1st page.  IMO this is something with style stack.  If
  this will be fixed, then keeping of Style_className:HTML.c can be omitted
  again -VH
* fixed the bug in lynx with lss support -when displaying html pieces such as
  <b> A <b> B </b> C </b>, only 'AB' was drawn in style corresponding to <b>
  -VH
* added HTML source syntax highlighting (when option -prettysrc that is added
  is given to lynx). It's available for lynx compiled with and without lss
  support (it can be much more beautiful when compiled with lss support - read
  lynx.cfg for description). The code is ifdef'ed with USE_PSRC.
  This functionality coexists with old source view and with -preparsed logic
  (ie different commandline options make source view logic different) -VH
* HTChunkPutc was inlined in SGML.c for better performance -VH
* keeping of Style_className was omitted in HTML.c to increase performance of
  lynx compiled with lss support -VH
* performance of lynx compiled with lss support is increased ~ by 15-20% for
  normal documents, and by up to 50% for documents with a lot of tags VH
* fixed bug in lynx compiled with lss support  that caused it to load local CSS
  stylesheets - lynx didn't understand their syntax so it was exiting VH
* added type information for attributes in HTMLDTD.c (it's used in source
  syntax highlighting mode) VH
* sample .lss files are updated to support source syntax highlighting VH
1999-03-30 (2.8.2dev.21)
* disable LYatexit if memory-leak testing is not configured.
* fixes for unhighlighting problems with color-style support (Vlad Harchev)
* remove '(default: on)' and '(default: off)' strings from configure script
  help message (much lynx-dev discussion) - TD
* remove outdated link to the WebTechs HTML Validation Service from help menu
  and change link to more suitable location for rfc1945 - PW
* correct logic of --disable-full-paths configure option (reported by Georg
  Schwarz) - TD
* fix problems building on OpenVMS with DECC 6.2 (reported by Andy Harper
  <Andy.Harper@kcl.ac.uk>)
  + remove 'DEBUG' definition from build scripts since it is defined in
    the source code.
  + turn off code that tries to use getpwuid(), by defining NOUSERS, since
    those functions are not present on VMS.
  + provide a dummy location for h_errno for systems without that symbol.
  + correct string syntax in VMSexit function
  + ifdef'd use of lynx_version_putenv_command in LYMain.c
  + correct spurious parenthesis in mailform function
  + correct missing COPY_PATH definition for LYUtils.c
* check for 'z' user interrupt in HTLoadHTTP before setting up the output
  stream.  This avoids doing unnecessary work, including possible creation of a
  new HText structure that most likely is never displayed but still pushes
  another document out of the.  cache.  Most commonly this occurs when a HTTP
  error response is received and the user presses 'z' while the resulting alert
  message is shown - KW
* fix of HTUnEscapeSome in HTParse.c for non-ASCII - KW, PG
* tidy up around ed_offset initialization in GridText.c - KED
  (the patch as given did not compile on a non-ANSI compiler because it used
  aggregate initialization - TD)
* add samples/mild-colors.lss (Vlad Harchev)
* add samples/blue-background.lss (from Sergey Svishchev <svs@ropnet.ru>)
* documentation updates for INSTALLATION and PROBLEMS - PW
* use HTConfirm and HTConfirmDefault to gettext'ify CONFIRM_BOOKMARK_DELETE,
  CONFIRM_COMMENT, CONFIRM_LONG_PAGE_PRINT, CONFIRM_LONG_SCREEN_PRINT,
  CONFIRM_MAIL_SOURCE_PREPARSED, CONFIRM_MAIN_SCREEN, FILE_EXISTS_HPROMPT,
  FILE_EXISTS_OPROMPT, NO_OWNER_USE, PREV_DOC_QUERY, REALLY_EXIT_N,
  REALLY_EXIT_Y, REALLY_QUIT_N, REALLY_QUIT_Y (based on report by LP) - TD
* at LYNXCFG:/ page, add links for every included configuration file so we can
  read and edit them (no, currently the changes will be active the next session
  only.  Minor reorganization of LYMain.c done, more required) - LP
* correct test/spaces.html - it should not be in a <PRE> mode by default - LP
* undo recent &emsp; changes so it is a single space as before (suggested by
  KW) - LP
* add ETag anchor element (currently not used, only for information) - LP
* assign LYNXCFG:/ and LYNXCOMPILEOPTS:/ for internal pages of parsed lynx.cfg
  and compile-time info.  Now we will not see a temp file link name in a
  statusline in advanced mode, also kill overhead since pages created only when
  really accessed - LP
* form-based options menu:  the bug described in 1999-03-17 changes now finally
  fixed - LP
* fix expanding entities for x-transparent display charset
  (was broken from 1999-03-04 changes) - LP
* trimmed trailing blanks from *.tbl, fixed chrtrans/def7_uni.tbl and
  chrtrans/viscii_uni.tbl, ensure that it produces correct result - TD
* chrtrans/def7_uni.tbl - entries with trailing spaces now explicitly enclosed
  in quotes to avoid problems with integrating the patches sent by e-mail,
  more comments added - LP
* attempt to implement --disable-ftp (John Bley)
* fix tiny memory leak in HTAAUtil.c (John Bley)
* chop useless #includes from LYHash.c, LYExtern.c, LYCurses.h (John Bley)
* --disable-news was also disabling ftp, --disable-finger without
  --disable-gopher wasn't right (John Bley)
* remove a duplicate #include from HTFTP.c (John Bley)
* remove several obsolete files from the source distribution (John Bley)
  WWW/Library/Implementation/HTAAServ.*
  WWW/Library/Implementation/HTAAFile.*
  WWW/Library/Implementation/HTAuth.*
  WWW/Library/Implementation/HTACL.*
  WWW/Library/Implementation/HTPasswd.*
  WWW/Library/Implementation/HTHistory.*
* --disable-partial wasn't compiling because of a suppressed #include, replace
  one more free() with FREE() (John Bley)
* correct typo LIsListpageTitle vs LYIsListpageTitle
  (reported by Artur Frysiak <wiget@usa.net> and KED)
* don't append sed expression to help_files.sed if the $(COMPRESS_EXT)
  variable is empty - TD
1999-03-17 (2.8.2dev.20)
* protect a couple of spaces with quotes in def7_uni.tbl (suggested by KW) - TD
* add ifdef's for NO_RULES to HTAAServ.c - HN
* add configure --disable-news option - JS
* add configure --disable-finger option - JS
* add malloc checks, remove some #includes that don't need to exist, and
  cleanup where somebody decided to waste instructions setting fields to 0 when
  he already memset()ed the whole struct to 0 (John Bley).
* remove obsolete/unmaintained SHORT_NAMES ifdef's (John Bley).
* add/use LYTrimStartfile function (suggested by LP) - TD
* correct missing null-pointer check in add_printer_to_list function (forwarded
  by BJP from Debian bug-reports) - TD
* add notes about $CC variable to INSTALLATION and PROBLEMS - JS, PW
* tweak for TABLE formatting: break line at </TR> end tag (don't wait
  for next <TR> start tag), effective in SortaSGML mode only - KW
* lots of color style changes, only effective if compiled with USE_COLOR_STYLE;
  together they seem to make color styles act much more reliably and
  consistently - KW
  - Moved some extern definitions and declarations.
  - Made extra handling for LINK REL (or TITLE) attributes consistent
    with example lynx.lss file.
  - More complete (and hopefully more consistent) setting of "normal"
    attributes, especially background color, on screen refresh and after
    statusline messages.  Set normal attributes for statusline prompts.
  - Various other small tweaks, mostly to not lose color changes in a
    document and to avoid color leaking.
  - Attributes for highlighting WHEREIS search targets can be controlled
    by setting style for "whereis" in lynx.lss.
  - Allow mono attribute field in lynx.lss to be a combination of several
    attributes separated by '+' characters.
  - Changes of example lynx.lss file: more logical ordering, added some
    comments, document new stuff.  Changed a few styles for demonstration
    purposes or because text was really hard to read.
* apply color styles to HTML source display, using the same methods as
  for displaying the rendered version.  This is done if and only if
  the -preparsed flag is used (and lynx is compiled with -DUSE_COLOR_STYLE,
  of course).  Please remember that the source displayed with -preparsed
  is *not* the same as the original text/html document, it has been
  mangled by lynx (as the name implies) and may itself not be a valid
  HTML document even if the original was - KW
* changed some slightly suspicious casts in HText_endAnchor's casting hell:
  prefer to cast a line's size element to (int), rather than various int
  variables to (unsigned) - KW
* remove some unnecessary use of dynamic buffers where there is no apparent
  benefit for using them, for the sake of performance or to avoid a minor
  memory leak - KW
* stuffed small memory leak (MultipartContentType) - KW
* absorb 'len' parameter into logic of argncmp, so it still achieves its
  purpose of comparing prefixes of options without undue maintenance effort -TD
* retain logic that uses final URL on command-line (request by KW) - TD
* add/use new functions argcmp and argncmp to allow the use of '--' prefix as
  well as '-' for commandline options.  This means that '-localhost' and
  '--localhost' mean the same thing for lynx.  If EXTENDED_OPTION_LOGIC is
  defined then the extended commandline option logic will be used.  It means
  that '--' will be accepted and will be treated as an end of options.
  Anything after it will be treated as URL even if begins with '-' or '--'
  (Vlad Harchev)
* correct some typos in docs and in scripts (Vlad Harchev <hvv@hippo.ru>)
* modify generated sed script to handle special case of alt_edit_help.html,
  which was being rendered in --enable-gzip-help as alt_edit_help.html.gz.gz
  (reported by KED) - TD
* modify lynx_help/help_files.txt to update links to gzip'd versions of
  alt_edit_help.html, environments.html, test_display.html - KED
* tweak for SGML_LITTERAL (sic) parsing, so that the first nonmatching
  character after the beginning of a putative end tag goes through character
  translation - KW
* add some more pieces of info (if available) to '=' page in advanced user
  mode.  Also show mode as "source" instead of "normal" if viewing SOURCE, in
  all user modes - KW
* minor FASTBACKW_LINK / FASTFORW_LINK tweaks - KW
* removed documentation for nonimplemented chargen URLs - KW
* remove num_n256 hack introduced in dev18 UCDomap.* - LP
* forms-based options menu: fix reloading of previous document *only* when
  necessary (was always, since early forms-based options menu days).  Still
  have a bug - while submitting the options menu lynx reload menu again, but
  this is much faster to load small local file twice than fetch previous
  (possible large) document over the net.  - LP
* &mdash; (&#x2014) now display as "--" (popular requests) - LP
* &emsp; are now displayed as two &ensp; (popular requests),
  previous definition of HT_EM_SPACE now renamed to HT_EN_SPACE - LP
* minor tweaks in postoptions(), new flag added - LP
* minor changes to make this build with SunOS K&R cc - TD
* entities.h:  clean HTML4.0 entities table added, it is #ifdef'ed with
  ENTITIES_HTML40_ONLY (may be useful for page validation), file entities.h
  moved to src/chrtrans directory - LP
* save few KB of static memory by storing unicodes as 'u16' (was 'long') - LP
* trace log toggle now really interruptible - LP
* move entities.h to src/chrtrans - LP
* fix display of -help output: (on/off) info was wrong for UNSET_ARG case - LP
* ifdef'd recent changes to LYPrint.c to build with djgpp - LP
* remove redundant -DDEBUG from djgpp makefiles - LP
* remove nonstandard ISO-9945-2 - LP
* eliminate a duplicate --enable-included-msgs in configure --help, (reported
  by LV) - TD
* redefine LY_BOLD_START_CHAR for EBCDIC platforms to avoid conflict, adjust
  IsSpecialAttrChar() to take this into account - PG
* rewrite LYKeymapCodes with leading commas to avoid accidental/illegal
  use of trailing comma in an enum list - PG
* modify UCdomap.h to avoid gcc-specific construct using cast to struct of
  data aggregate - PG
* modify makefiles to allow .c.i rule to work with --srcdir - PG
* add a rule to makefile.in to generate patches - PG
* correction to LYCookie.c, to get it to eat all cookies (reported by LV) - BJP
* corrections/updates to entities.h (Jacob Poon):
  HTML 4.0 compliance:
  - Added support for Euro currency symbol.
  - Fixed duplicated &loz; definitions.
  Fixes:
  - Fixed some typos in the old references. (fixed: b.delta)
* update follow_help.html for LE's 123g changes - PW
* further correction to 123g logic - LE
1999-03-04 (2.8.2dev.19)
* forgot to update PRCS when renaming src/chrtrans/iso9945uni.tbl - TD
1999-03-04 (2.8.2dev.18)
* modify configure script to recover if the intl and po directories are
  missing, allow experimentation with --enable-nls --disable-included-msgs
  --without-included-gettext options (request by HN) - TD
* add sanity-check for EBCDIC FixCharacters() in LYMain.c - PG
* ifdef'd the ADDRLIST code with EXP_ADDRLIST_PAGE, making this available as
  a configure script option --enable-addrlist-page - TD
* create a new command called ADDRLIST, which behaves exactly the same as LIST,
  but which *should* always show only the URL's.  Rather than make it a config
  option (which would have taken me quite a bit longer to do), I've bound it to
  the "A" key (that's a capital "A").  Why not "L" you ask?  Because of the "vi
  keys" option, whereby "l" is used for cursor movement, and "L" stays reserved
  for L(ist) - KED
* change the LYK_xxx keymap definitions to an enum, to simplify ifdef's - TD
* add configure options --disable-gopher, to remove GOPHER code, and
  --disable-trace to remove TRACE code - JS
* modify trace log header to always inform us if anonymous restrictions are
  set - LP
* chartrans: old-style declarations of charsets which do not have Unicode
  tables (CJK, x-transparent, also UTF-8) now moved from LYCharSets.c to
  UCdomap.h and now included with UCInit() in UCdomap.c in a standard way - LP
  (Please re-test CJK and UTF-8)
* add configure --enable-libjs option (Lalo Martins <lalo@webcom.com>)
* add checks for some more LINK tags as listed in "6.12 Link types" of the HTML
  4.0 Specification (Masayasu Ishikawa <mimasa@isoternet.org>)
* changed the effect of some LINK tags with REL attribute of a very relative
  character (Up, Next, Prev, ...) on titles as they appear e.g.  on the LIST
  page:  the title of the target HTParentAnchor isn't being set when such a
  LINK tag is parsed, but the relation is now stored as a property of the
  link itself rather than its destination.  The LIST page shows the relation
  as additional info, not superseding a URL or title string obtained
  otherwise - KW
* move commands in top-level makefile.in which clean *.rej and *.orig from
  'distclean' rule to 'maintainer-clean', make distinct from the @SRCDIR_CLEAN@
  substitution which is intended for use with the configure --srcdir option
  (from reports by Glenn E.  Thobe <thobe@lafn.org> and BL) - TD
* correct LYRemoveTemp() to close file before attempting to remove it; else
  the remove fails on some platforms, e.g., DOS/Windows (report by KW) - TD
* improved documentation for the new cookie options, e.g,.
  COOKIE_ACCEPT_DOMAINS, in lynx.cfg - BJP
* fix some memory leaks in LYCookie.c - BJP
* modify 123g (and similar movement) commands to allow for relative links,
  e.g., by using a '+' or '-' after the 'g' - LE
* modify help_files.sed to include '$', making regular expressions work for
  HP-UX (Jens Schmalzing <jens@stat.physik.uni-muenchen.de>)
* add a comment to aclocal.m4 to show where patches for autoconf, needed for
  this configure script, can be found - JS
* add toggling trace log on/off in partial mode, when the downloading is still
  in progress - LP
* more consistent docs for debugging of invalidly nested HTML:  important trace
  messages from actions on invalid tags now have '***' prefix such as "SGML:
  ...  ***ignored" (well:  illegal, forced, assumed, etc.), -preparsed mode now
  better documented - LP
* minor code cleanup: remove redundant includes, fill in 0's for some static
  data initialization (John Bley).
* add 'joe' editor, and variants, to list of those editors that are assumed to
  position the file to a given line number using the "+line" command-line
  option - IC
* remove redundant "(y/n)" substrings from LYMessages_en.h - LV
* add new command named GROWTEXTAREA which adds 5 new blank lines to the bottom
  of a TEXTAREA when executed.  It does not have a default binding, so you need
  to add a KEYMAP for it in your lynx.cfg.  The number of lines added is fixed
  by a #define, but 5 seems to be a "reasonable" increment to use - KED
* add new command named INSERTFILE, which (obviously) inserts a file's contents
  into a TEXTAREA, just above the line the cursor is on when invoked (which
  means you cannot insert a file *below* the final existing TEXTAREA line ...
  but see 1) and 3) for easy ways to over- come this limitation).  It too, has
  no default binding, so a KEYMAP entry is also needed for it - KED
* by default, when the cursor is on the last line of a TEXTAREA, if you hit the
  ENTER key, a new line will be added to the TEXTAREA, with the cursor
  positioned on it.  If that should happen at the bottom of the screen, a
  DOWN_HALF scroll operation is (effectively) performed - KED
* ifdef'd this feature (since at least one person objected to this automatic
  behavior when it was discussed awhile back - BL?), for easy disabling (and to
  make adding a ./configure option easier).  The symbol is AUTOGROW is
  #define'd in LYMainLoop.h - KED
* added an ifdef for the code that causes the external editor to be
  invoked "automatically" on the TEXTAREA contents when ^Ve (or whatever
  the EDIT binding is), rather than attempting to invoke it on the .html
  source file.  This should allow adding a ./configure option to control
  this behavior, until we come up with a different binding/mechanism to
  do the job, that we can all agree on.  The symbol AUTOEXTEDIT is also
  #define'd in LYMainLoop.h.   The command EDITTEXTAREA is still available
  for separate KEYMAP binding, per KW's suggestion - KED
* check the range of chars between 0x80 and LYlowest_eightbit[current_char_set]
  for validity against the charset in use.  If such chars are detected in
  edited or inserted data, a "." char is substituted for them, as with normal
  control chars.  (Suggested by LP) - KED
* added KW's LYCloseTempFP bugfix - KED
* add/use function GetFileName(), e.g., by INSERTFILE.  It is fairly general
  purpose, and can be used whenever the name of an existing file needs to be
  input.  It uses the same mechanism for filename expansion and "history" as
  does the PRINT function - KED
* reorganized a lot of the code into subroutines to provide for 1) and 2);
  still need to do a bit more cleanup of some other (nearly) common code - KED
* rename iso9945_uni.tbl to iso9945uni.tbl to accommodate 'make' programs on
  old systems (such as CLIX 3.1) whose suffix rules fail for filenames longer
  than 14 characters - TD
* change VMS WWW build-script to use prefix=all rather than prefix=ansi,
  so that POSIX functions such as 'stat()' are linked properly (reported by
  Morris D Cox <coxmd@appstate.edu>) - TD
* modify configure macro CF_EBCDIC to avoid using #error, since that is not
  recognized by all compilers - TD
* include <sys/types.h> in CF_INET_ADDR macro, to accommodate systems which
  require that to compile test program with the socket.h, other network
  headers - TD
* removed a cast in free_lynx_cfg, on FREE's argument, which caused some
  compilers to report that an rvalue was being modified (reported by PW) - TD
1999-02-16 (2.8.2dev.17)
* modify LYReadCFG.c to avoid duplicating data for cookies - BJP
* modify HTConfirm to use gettext values for yes/no.  Use HTConfirm in a few
  more places, though completing this will require more work - TD
* add note about resolv library to PROBLEMS - PW
* minor clarification about DOS/Windows binaries in README - PW
* modify ./makefile.in so that portions which are commented-out will be done
  without a leading tab, since that confuses the make program on Digital Unix
  3.2 - TD
* Unix: Don't accept HOME variable as valid if it does not begin with
  a slash - KW
* changed HTGetCharacter to be 8-bit clean, it could not distinguish between a
  character value 255 and EOF.  Changes affect several protocols:  nntp,
  gopher, finger, ftp.  Most notably, news articles containing byte value 255
  could not be completely read - KW
* removed a memory leak in HTFTP.c for some directory data, added a few gettext
  calls - KW
* added ability to show file type description in local Unix directory listings:
  new format codes for use in LIST_FORMAT %t, %T, they are not used by default
  - KW
* modify "clean" makefile rule to allow for FreeBSD, which generates core
  files such as lynx.core - KED, TD
* correct sign-extension when converting characters after edit of TEXTAREA
  (upper-128 characters were being translated to dots, reported by IC) - KED
* worked with some pathological/boundary-case pages, and fixed some some edges
  that could fail (eg, last line of document is also last line of a TEXTAREA,
  and lines are being added; page containing *only* a one-line TEXTAREA field;
  etc).  While it was unlikely one would run into such beasts in real life,
  they all work correctly now.  Thanks to Greg Marr and Serge Munhov for
  providing some very basic pages that I was able to easily modify for various
  test cases - KED
* added a few flags to the TextAnchor and HTLine struct's, to indicate an
  expansion line.  These were added to allow for line deletion when a TEXTAREA
  is "reset" or shrinks (when we get around to tackling those tasks) - KED
* the editor's cursor is now positioned on the same line in the edit file, as
  it was on when the editor was invoked (relative to the beginning of the
  TEXTAREA).  At least for those editors that lynx knows support initial
  positioning (emacs, vi, pico, jove, and jed for non-VMS platforms; sedt for
  VMS) - KED
* cleaned up and corrected a few comments; simplified a few small bits of
  code - KED
* added cookie_domain_flags enum to LYCookie.h, usage should be apparent with
  patch applied - BJP
* updated free_lynx_globals() for cookie variables - BJP
* replaced cookie_add_acceptlist, cookie_add_rejectlist and
  cookie_set_invcheck functions with cookie_domain_flag_set - BJP
* saved a bit of memory by dropping useless pointer memory initialization
  (exactly WHAT was I thinking?)  - BJP
* changed LYrcFile.c, LYReadCFG.c to call cookie_domain_flag_set  - BJP
* new lynxkeycode BACKTAB_KEY with value 0x10F.  DO_NOTHING is and shall remain
  0x10E, as documented in lynx.cfg.  Moved MOUSE_KEY out of the way - does it
  need to be in the tables at all?  BACKTAB_KEY will be recognized if the
  (n)curses keypad() input handling returns KEY_BTAB, which happens if the
  terminal description has the right kB or kcbt capability string and the
  terminal actually generates that string (often "^[[Z", generated for
  shift+tab).  May also work with lynx-keymaps mechanism.  Not tested with
  slang, maybe this has to be added to some more of the various tables in
  LYStrings.c - KW
* new user-visible key commands FASTFORW_LINK and FASTBACKW_LINK, with
  lynxactionscodes LYK_FASTFORW_LINK and LYK_FASTBACKW_LINK.  By default mapped
  from <tab> key (^I) and new BACKTAB_KEY, respectively.  Previously <tab> was
  mapped from NEXT_LINK, which has some special handling if the invoking key
  was <tab> (and if FASTTAB was defined in LYMainLoop.c, which was the case by
  default).  The old behavior of <tab> is still available if it is mapped with
  KEYMAP to NEXT_LINK in lynx.cfg - KW
* these commands always go to a previous (or next) link if there is one,
  and skip multiple lines that are part of the same textarea - KW
* recognize the new key actions also during partial file display, for some
  roughly corresponding movement - KW
* new lynxeditactioncode LYE_FORM_PASS, to allow any lynxkeycode to end the
  editing of a form field and be passed up to the caller - it will then
  normally be mapped to a lynxactioncode.  LYE_FORM_PASS keys are generally
  ignored in non-forms line editing.  This is used for BACKTAB_KEY, as well as
  several other keys that were previously handled specially in form_getstr - KW
* extended the maps in LYEditmap.c to cover the same range of lynxkeycodes as
  the LYKeymap.c tables.  Yes, this uses more space, but the tables need to be
  consistent - KW
* map lynxkeycode 0x00 to LYK_DO_NOTHING, as lynx.cfg said all the time - KW
* some tweaks of displayed strings in 'K'ey Map page.  Don't show CHANGE_LINK
  binding if mouse not enabled (it may not be useful even when -use_mouse is
  on) - KW
* function expand_substring used with NCURSES for user-defined mapping keysyms
  to byte sequences was parsing the "^(...)" construct wrong - KW
* other small tweaks in key handling code - KW
* changes to lynx.cfg to better reflect reality - KW
* terminology note:  lynxkeycode = what's between the colons in lynx.cfg
  KEYMAP:...:..., lynxactioncode = LYK_* code for what's right of the second
  colon, lynxeditactioncode = what's assigned in LYEditmap.c (and which may
  differ between lineedit_mode Default Binding and alternative bindings) - KW
* formatting tweak in HTML.c for <DD> not preceded by <DT>:  Don't use wrong
  indentation in that case - KW
* changes from DK for DOS up to 1999-02-14 - KW
* minor documentation tweaks - LP
* replace most uses of free with FREE (John Bley).
* correct HTEndParam so that if fewer command-parameters are given than
  expected, we still terminate the command properly (reported by
  Michael Warner) - TD
1999-02-08 (2.8.2dev.16)
* minor documentation tweaks for EDITTEXTAREA - LP
* correct uninitialized buffer variable in send_file_to_mail() which caused
  core dump (reported by LV) - KW
* recognize Subject and Message-Id in embedded comments in HTML documents, in
  the form generated by MHonArc for mailing list archives (including lynx-dev).
  Use these to generate a default Subject and an In-Reply-To header (currently
  not for VMS) when replying by mail (sending a 'C'omment, or following a
  mailto link) from such a page.  The old methods to get a title other than the
  fallback (the URL) still are there and have precedence, by in reality seem to
  apply very rarely.  If no suitable comment strings are found or they are
  regarded as invalid (bad characters, not exactly right format) they are not
  used, and the fallback (URL as Subject, no In-Reply-To) applies - KW
* use the Message-Id of a news article to generate a References header when
  posting a reply.  Lynx's new article listing doesn't understand threading,
  but this is nicer for other newsreader that do.  The References header of the
  referenced article is not used, so there will be only one message-id in the
  generated References header, but this is better than nothing.  The article's
  message-id is appended as a parameter to the URL of the generated newsreply
  link, in the form ";ref=...", so this extends the syntax of Lynx's newsreply:
  URL scheme.  Nothing should have changed for snews:  and other s-versions of
  the various URL schemes for news access - KW
* Message-Id and Subject of a news article are also made available for replying
  by mail - KW
* LYNews.c: Don't post a message that is empty or has only '>'-quoted text - KW
* HTNews.c:  got rid of some suspicious fixed length buffers.  Fixed minor
  memory leaks.  Added abort of the target stream which was missing in some
  cases.  Create mailto:  hrefs in URL-escaped form if necessary, they will be
  unescaped in LYMail.c.  (News URLs still don't use escaping the right way,
  especially for message-ids.) Recognize special meaning of "Followup-to:
  poster" (don't treat "poster" as a newsgroup name).  Other small tweaks - KW
* add samples/cernrules.txt - KW
* except for DJGPP, move lookup code for domain names (not dotted-quad IP
  addresses) from HTParseInet into a new function:  LYGetHostByName acts like
  the normal gethostbyname, but includes the NSL_FORK logic.  Interruption is
  indicated in global variable lynx_nsl_status - KW
* use LYGetHostByName instead of HTParseInet for URL guessing - KW
* select on tty file descriptor in NSL_FORK loop also if compiled with slang.
  This should make 'z' during lookup more responsive - KW
* don't compile in the rules implementation code if NO_RULES is defined
  (suggested by BL) - KW
* fix special case of EDITTEXTAREA where the returned file is empty - BJP
* write to .lynxrc values for COOKIE_ACCEPT_DOMAINS and COOKIE_REJECT_DOMAIN
  when options screen is used - BJP
* add lynx.cfg and .lynxrc support for a few new options:
    COOKIE_STRICT_INVALID_DOMAINS,
    COOKIE_LOOSE_INVALID_DOMAINS,
    COOKIE_QUERY_INVALID_DOMAINS
  They're the same sort as COOKIE_ACCEPT_DOMAINS, comma-delimited lists - BJP
* modify LYOpenTemp() to report unusual errors, i.e., other than if the
  temporary file could not be created because it already exists - PG
* more fixes to CF_INET_ADDR - TD
* modify README to indicate where win32 binaries are found - JS
* add chrtrans tables for Ukrainian Cyrillic: koi8-u, cp866u, iso-9945-2
  (patch by Serhii Hlodin <hlodin@lutsk.bank.gov.ua>)
* patch for TEXTAREA edit feature - KED
  1. Handles the renumbering of link number tags [nnn], when the tag itself is
     split across two lines (see below).
  2. Scrolling down, going to the bottom of the document, etc, now work
     properly, when the TEXTAREA is expanded beyond the bottom of the
     (original) screen display.
  3. Hitting the reset button is now handled properly WRT the "old" text in
     expansion lines (now *always* empty).
  4. Attempting to edit (^Ve) a TEXT field (not a TEXTAREA), is now blocked,
     with the user getting an error msg.
  5. The function call now returns the number of lines that the cursor should
     be moved from its current position, to end up on the first blank line of
     any trailing empty lines in the TEXTAREA (there will always be one).
* bug fixes for TEXTAREA edit feature - KED
  1. Thanks to a suggestion by Bela, your regular EDIT keybinding ("e" by
     default), will now bring up the editor within a TEXTAREA, so there's no
     need to "waste" a separate keybinding (though you can still additionally
     bind the function separately, if desired).
  2. Converts any tab chars in the edited file, to spaces in the TEXTAREA
     anchor line.  The tabstop is currently #define'd to the quasi-standard
     value of 8.  (If anyone thinks that needs to be user configurable, feel
     free to add that to the o(ptions) form/menu,
     cmd-line-arg/lynx.cfg/.lynxrc/userdefs.h, whatever ...
     I recommend against doing so though, as tabstops that are not set at 8,
     are a PITA to deal with, generally speaking.  I dunno if tab chars in a
     TEXTAREA form are prohibited "by spec", or if it is just a "lynxism" that
     they cause rendering problems (as well as downstream problems with
     submit/etc, I think), but I felt I needed to do something to make lynx
     behave rationally if they are present in the edited data (quite possibly
     from an arbitrary file that one pulled into the editor).  Filtering them
     to spaces, seemed the most reasonable thing to do.
  3. Replaces any embedded control chars with something printable (I chose a
     "." char, since it is less "intrusive" than some other choices, like "*",
     "+", "#", etc).  As with tabs, when some of these chars *are* rendered
     into the TEXTAREA, strange things may happen.  This shouldn't be much of a
     limitation, since many of these chars perform line-editing or
     system/job-control functions, when entered directly while one is in the
     TEXTAREA.  They currently cannot be "escaped" and entered as actual text
     chars, so far as I can tell.  Anyway ...  I don't know of any "legitimate"
     reason for them to be used as TEXTAREA data, so for now, you get "dots" in
     their place.
  4. Cleans up a few comments, and such.
* update some linked in lynx_help_main.html (Heikki Kantola <hezu@iki.fi>)
* add checks for null return from malloc to HTInit.c, LYMain.c, LYReadCFG.c,
  LYUtils.c (patch by John Bley)
* add telnet, tn3270 and rlogin program paths to configure script
  (patch by George.Lindholm@ubc.ca).
1999-01-28 (2.8.2dev.15)
* correct calls to HTAddParam() in LYDownLoad.c to handle optional second
  parameter (reported by KW) - TD
* change HTAddXpand() to assume its parameter (an environment variable) is
  already expanded and simply is not quoted (reported by Ryan Hung
  <rhung@vcn.bc.ca>) - TD
* add configure --disable-included-msgs option to allow suppressing of bundled
  ./po directory for the NLS message library contents.  If no ./po directory
  is found, the configure script assumes it is preinstalled anyway (request
  by HN) - TD
* add pattern to script which customizes pathnames in lynx.cfg to support
    GLOBAL_MAILCAP:/PATH_TO/lynx_doc/samples/mailcap
  (request by PG) - TD
* export $PATH when calling cfg_defs.sh - PG
* add a simple test to check if the temporary directory is actually writable
  if we cannot create a temporary file in LYOpenTemp (reported by PG) - TD
* miscellaneous DOS/DJGPP compile/build fixes - LP
* enabled CERN-style rules, there are two new lynx.cfg options, RULESFILE and
  RULE.  No example file or documentation yet beyond comments in lynx.cfg.  The
  rules mechanism itself is unchanged from what was present for a long time
  (but never used), except for some memory cleanup.  Use -DNO_RULES at compile
  time to disable - KW
* add changes to invoke external editor on textarea, can be invoked by adding a
  KEYMAP entry for EDITTEXTAREA area to lynx.cfg (originally from
  aldomel@ix.netcom.com, but much rework) - KED
* use HTSprintf0 in HTTCP.c - TD
* added PARSE_STRICTPATH and PARSE_QUERY to interface of HTParse(), for
  requesting only the relevant part of what is returned for PARSE_PATH.  This
  isn't yet used anywhere - KW
* changes to StrAllocVsprintf() to take width and precision in most format
  specifications into account, and to correct the memory allocation logic.
  This was tested by setting GROW_SIZE to a small value of 8, so far no
  crashes, but it is certainly not right for all possible formats, especially
  involving floating point conversions - KW
* changed HTSprintf0() to pass a string already existing in its output buffer
  on, this should save a few realloc's in StrAllocVsprintf() - KW
* changes to code handling LIST_FORMAT to avoid some unnecessary reallocations,
  to recognize some more format flags, and to treat invalid formats somewhat
  better - KW
* corrected recent HTFile.c change for systems without S_ISVTX - KW
* added memory cleanup for uid/gid cache functions in HTAAProt.c - KW
* increased ATEXITSIZE to 40 - KW
* added TRACE output to HTAnchor.c's free_adult_table.  If this shows anything
  at program exit (if TRACE is on then), it means that HTAnchor structures have
  been missed by the normal automatic cleanup (walking the history list and
  following links) - KW
* changed more status codes in HTUtils.h to libwww5-like values - KW
* added new function to check for a valid Internet hostname - KW
  Use it before actually trying to resolve an address, it should
  a. avoid the overhead of NSL_FORK if it would fail anyway,
  b. prevent DNS queries for invalid names, which may unnecessarily
     consume time, bandwidth, and DNS server cache memory, and
     may confuse some resolver libraries and servers,
  c. speed up address guessing sometimes if something was mistyped,
  d. thwart some attempts to crash Lynx with invalid URLs.
* this time really make "Alert" statusline prefix localizable - KW
* new function HTAlwaysAlert(), which can be called even when LYCursesON isn't
  true and should always produce a visible message - KW
* use new valid_hostname to also check telnet, tn3270, and rlogin hostnames
  before calling the external program (after most invalid character have
  already been stripped).  Added a fflush(stdout) to make sure messages are
  visible before external program is called - KW
* made changes equivalent to the 1998-12-31 HTSACopy and HTSACat modification
  to the LY_FIND_LEAKS versions of those functions.  Having source and target
  string for StrAllocCopy or StrAllocCat overlap (or being equal) should be
  considered a programming error, but at least one place in LYEdit.c currently
  seems to do it and rely on the new behavior.  (Editing current file sometimes
  didn't work with LY_FIND_LEAKS) - KW
* closed memory leaks in LYKeymap.c, provided for memory cleanup at exit of
  LYCgi.c environment strings - KW
* explicitly put HTTP_ACCEPT_LANGUAGE and HTTP_ACCEPT_CHARSET strings into
  lynxcgi environment only if they are non-empty, i.e., set to something in
  lynx.cfg or the personal configuration or Options screen.  This makes the
  environment a lynxcgi scripts sees resemble more closely that of a remote CGI
  script handling a request from Lynx with the same configuration - HTTP.c also
  only sends Accept-{Language,Charset} headers if preferred language and
  preferred charset (respectively) have been set to non-empty strings.
  (Strictly speaking, an empty Accept-* header has a different meaning from a
  non-existing one, but it doesn't make much sense to generate empty Accept-*
  headers, since they mean "nothing is accepted".) There are other differences
  in the lynxcgi environment (e.g.  HTTP_ACCEPT isn't set, ",iso-8859-1;q=0.01"
  etc.  isn't appended to HTTP_ACCEPT_CHARSET, apart from missing
  redirections), but apparently nobody has needed a more exact CGI emulation
  for real scripts - KW
* removed sending of "Negotiate: trans" in HTTP.c since it violates transparent
  content negotiation specs, added comments - KW
* correct error handling in CF_INET_ADDR, which did not restore $LIBS when no
  applicable library was found for inet_addr (reported by IC) - TD
* correction to CF_TERMCAP_LIBS, which used inconsistent spelling for the cache
  variable, so predefined termcap/terminfo library was not necessarily
  detected - TD
* resolved autoconf 2.13 problem, resync configure script with patched
  autoconf 2.13 - TD
1999-01-18 (2.8.2dev.14)
* use HTSprint0 in LYCurses.c, LYForms.c, LYGetFile.c, LYJump.c - TD
* modify LYCheckMail so it does not continue to report new mail when the mail
  file's modification time differs from its access time (reported by LV) - TD
* add check for inet_addr function, and (preferred) inet_aton.  The first
  function is reported to be sometimes in -lresolv, or -lbind when it is not
  present in the conventional network libraries (from report by
  mattack@area.com and comments by HN) - TD
* resync config.sub, config.guess with autoconf 2.13.19990117 (not yet
  configure, since autoconf 2.13 contains some new bugs) - TD
* modified handling of untranslatable charsets, after noticing that a page
  with charset=ISO-2022-JP produced an alert message with a truncated
  "iso-2022-j".  Looking more closely, the code could also result in memory
  corruption in some cases.  Compared with older versions, then changed the
  code to something somewhat like what was intended there.  But we don't have
  an "Other ISO Latin" display character set any more; maybe those `else'
  blocks should just have disappeared completely - KW
* minor changes to SortaSGML DTD for PARAM, THEAD - KW
* make "Alert" statusline prefix localizable - KW
* extend fixtext.sh to also change continued lines - KW
* changed LYCheckForProxyURL to act more like it appears to have been indented,
  and clarify comment.  Minor change in is_url - KW
* prevent removal of hidden link number from bookmark document in a very
  obscure case of a bookmarked ISMAP link - KW
* HText_SubmitForm:  make sure query is always allocated, even if the set of
  form fields to be sent turned out to be empty - KW
* some comments corrected in HTML.c, LYCharSets.c - KW
* tweak in curses_w_style for display without color - KW
* remove minor memory leak in LYDownload.c - KW
* changed error handling in LYTraversal.c to make sure terminal gets restored
  to sane mode before showing error message and exiting - KW
* increased VALUE_SIZE for buffer in HTMIME.c from 1024 to 5120.  Someone
  needed increase for long Set-Cookie headers - KW
* two new functions in HTList.c to reverse and to combine lists - KW
* Lynx was using the wrong precedence for entries within a mailcap (relative to
  other entries from the same file):  RFC 1524 says "The configuration
  information will be obtained from the FIRST matching entry in a mailcap
  file[...]", but Lynx effectively gave precedence to the last match.  Recent
  Debian packages of lynx have had a patch applied to change this, but that
  patch also seems to affect the precedence order relative to viewers defined
  in other places, i.e., lynx.cfg and HTInit.c.  The patch here instead changes
  the precedence of mailcap entries form the same files to RFC-like behavior,
  by reordering the list generated from a mailcap file after we have finished
  reading it in.  It leaves the order relative to viewers from other sources
  unchanged.  Maybe it should be made configurable whether Lynx's traditional
  precedence or the new one is used; currently there is just a #define in
  HTInit.c which could be changed to revert to traditional behavior - KW
* add checks for null return from malloc to LYCurses.c, LYStrings.c,
  (patch by John Bley)
* add support for HP Roman8 as a display character set.  HP Roman8 is used by
  Hewlett-Packard terminals and hpterm, HP's version of xterm.  The character
  repertoire is largely similar to ISO Latin 1 but the code points are all
  mixed up (patch by Christian Weisgerber)
* modify WWW/Library/Implementation/HTAAUtil.c::HTAA_setupReader():  to use
  malloc'd buffer rather than static buffer, to avoid overflow (patch by Thomas
  Braun <Thomas.Braun@link-up.de>)
* modifications to allow building the DOS lynx port with support of gettext for
  producing messages in various languages.  The DOS port of the gettext package
  still needs minor tweaking to get it to function properly, but this shouldn't
  be a problem for most people trying to compile lynx for DOS themselves.
  Rather than put yet more DOS-specific makefiles in the distribution, I put
  the changes to the makefiles within comments, which can easily be removed to
  enable the changes - DK
* add a comment about LYUCcharset struct "UChndl" field.  Tweak trace
  messages - LP
* fix parsing of ALT=value attribute when the value is not quoted.  When the
  first character is not us-ascii it was corrupted by chartrans in all versions
  of lynx.  Fix case S_equals in SGML_character() - LP
* chartrans:  ignore RAW_TOGGLE key and do not change LYUseDefaultRawMode if
  current document's charset specified explicitly, add status message.  (Let
  user switch toggle only when necessary, to avoid future problems :-) - LP
* chartrans: change the default value of PREPEND_CHARSET_TO_SOURCE in lynx.cfg
  from FALSE to TRUE (better safe than sorry) - LP
* reorder forms-based options menu (cosmetic):  rename "HTML error tolerance"
  to "HTML error recovery", reorganize "Character Set Options" section -
  "Display character set" went to "Personal preferences" section, "Assume
  character set" and "Raw 8-bit or CJK mode" went to "Document Layout" section;
  "Execution Links" went to "File management" section.  (Hope this helps to
  reduce confusion) - LP
* remove "environment variables" section from INSTALLATION, change references
  to Lynx User Guide in all docs.  Minor tweaks on help files - LP
* add a comment to mime.types and lynx.cfg on SUFFIX definition:  "This has an
  effect for ftp and local files only, http server does specify MIME type in
  the Content-Type header" - LP
1999-01-13 (2.8.2dev.13)
* correct a missing trailing newline in caselower.h (this may be a problem
  patching since 'diff' does not like that) - TD
* fix off-by-one alignment download options (reported by LV) - IC
* use HTSprintf/HTSprintf0 in UCAuto.c - TD
* remove stop/start curses calls around UCChangeTerminalCodepage() in
  GridText.c, since they are not necessary, and are a little distracting
  when running Lynx in xterm - TD
* correct handling in getfile() of ~/ expansion - KW
* modify NSL_FORK logic to prevent child process from running any signal
  handlers the parent may have installed - KW
* the logic added to display_page for avoiding unnecessary screen redraw with
  partial display (see 1998-12-03) is now disabled if enable_scrollback is set.
  Otherwise displayed pages could appear as empty (or with only the current
  link drawn) - KW
* modify conditions under which screen style cache is reset (only relevant for
  color style in combination with partial display) - KW
* update the INSTALLATION file, reflecting the changes between the two DJGPP
  versions of GCC in use.  Also, change optimization to -O2 in the other two
  DOS makefiles - DK
* add support for ISO 8859-15, i.e., "Latin 9", make corrections to DEC
  Multinational character translations (patch by (Christian Weisgerber
  <naddy@mips.rhein-neckar.de>)
* modify po/makefile.inn to use mkdirs.sh rather than mkinstalldirs script
  (reported by LV) - TD
* modify print_help_and_exit() to print values for the simple options, i.e.,
  toggle, integer and string, as part of "lynx -help" (request by
  mattack@area.com) - TD
* correct sense shown for Old_DTD variable in LYOptions.c (reported by DK).
* correct order of params for non-Unix use of HTAddParam in LYBookmark.c
  (reported by DK)
1998-12-31
* delete unused 'PREVAIL' color-style code from HTML.c, merge a couple of
  sections of logic with TrimColorClass, and change Style_className to
  a dynamically-allocated string - TD
* modify fmt_tempname() to check for buffer overflow - TD
* check/modify for potential buffer overflows:  HTAlert.c, LYBookMark.c,
  LYKeymap.c, LYPrint.c (including splitting it up into functions) - TD
* change GetOptValues to return status separately from the decoded value, in
  case the options form is damaged (suggested by LP) - TD
* add new function HTAddXpand to use in special case where Lynx is building
  shell command using data from user's configuration, which should not be
  quoted.  Use this in LYEdit.c to allow $EDITOR to be given as the editor
  name (request by PG) - TD
* add new function LYOpenTraceLog, to combine logic in LYMain.c and
  LYMainLoop.c, including Lynx's version message - TD
* fix some discrepancies between the code and the documentation (help files),
  for the alternate line edit keybindings, that were first included in the
  distribution somewhere around -dev.3, or so - KED
* added a delete-to-beginning-of-line (for the alt bindings only), and a help
  page that describes the alternate bindings - KED
* improved description of "HTML error tolerance" - KW
* changes for handling lynxcgi:  handle failure of execve(), by showing the
  system error and then _exit()ing the child process.  Make sure REQUEST_METHOD
  is always set.  Added checks for EINTR and other errors from read() - KW
* DOSPATH or EMX:  remove strange code dealing with root of local drive from
  is_url() and HTDOS_name()/HTDOS_wwwname(), add right code at the earlier
  stage in LYFillLocalFileURL() - LP (thanks KW)
* relax warning from HTAlert to HTUserMsg on REFRESH_URL_NOT_ABSOLUTE - LP
* more tweaks on transfer rate calculation - LP
* modify HTSACopy and HTSACat in case the source and destination are the same
  pointer - TD
* tested/removed redundant OS/2 EMX adjustment to filename from LYEdit.c - TD
* optimized LYEdit.c by moving calls on HTSYS_name(filename) to a single place
  near the top - LP
* forms-based options menu:  prevent spoofing attempts from possible overruns
  (e.g., user can doing 'e'dit in 'o'ptions and get core dump if
  display_char_set gets an illegal number such as 50, or hang the keyboard with
  illegal Line edit style) - LP
* forms-based options menu:  add new logical section - Document Layout,
  currently with "HTML error tolerance" (TagSoup/SortaSGML), "Pop-up for select
  fields", "Show images" (no_alt/labels/links) and "Verbose images".  New
  switches added for information purposes mostly, they duplicate hot keys but
  not so hidden from user's view.  Documentation updated also.  (Oh yes, "Line
  edit style" option is now available when we have a real choice >1) - LP
* split cfg_defs.sh into two script based on revised script from PG - TD
* minor fixes for top-level makefile.in - PG
* fixes for makefiles with gcc 2.8.1 using DJGPP 2.02 (do not use "-c -o"
  combination, strip trailing blanks from makefile.sla, change optimization
  level to -O2) - DK
* rename New_DTD variable to Old_DTD, change logic for -tagsoup option to be
  consistent with sense in lynx.cfg (reported by LP)
1998-12-26 (2.8.2dev.12)
* use HTSprintf0 in LYCgi.c - TD
* add tab-completion on URL's, by using previously-entered strings for
  matching (patch by Kari Davidsson <karid@isholf.is>) - TD
* add version number to trace log (patch by IC)
* modify HTDOS_name to be consistent with HTVMS_name, which does not modify
  its parameter (reported by LP).  Also, modify HTDOS_name and HTDOS_wwwName
  so they allocate space for the result rather than using a static buffer - TD
* modify LYEdit.c to use HTAddParam - TD
* make HREF/NAME for "Environment" consistent in Lynx_users_guide.html
  (reported by LP)
* correct DOS/EMX logic in LYEdit.c which incremented 'filename' pointer when
  its length was greater than 1 rather than recopying the string, causing a
  core dump when 'filename' was freed (reported by LP, this applies to
  2.8.1rel.2) - TD
* correct sense of 'already_exists()' function from dev.11, which caused
  various file-menu operations to stop working (reported by IC) - TD
1998-12-24 (2.8.2dev.11)
* use HTSprintf/HTSprintf0 in about half of the WWW library files where
  applicable:  HTAABrow.c HTAAServ.c HTAAUtil.c HTAccess.c HTAnchor.c HTDOS.c
  HTFTP.c HTFWriter.c HTFile.c HTFinger.c HTFormat.c HTGopher.c - TD
* eliminate most duplicate gettext parameters, reduced the number of files
  listed in po/POTFILES.in to a size that may allow build with the Solaris
  xgettext utility - TD
* correct rule for remaking po/makefile - TD
* workaround for HPUX sed program, providing '$' anchors for ".*" expressions,
  which is redundant, but should be harmless (suggested by Jean-Yves Levesque
  <Jean-Yves.Levesque.jyves@nortelnetworks.com>)
* add new help file, keystrokes/environments.html - LP
* fix HTReadProgress():  more accurate transfer rate calculation - LP
* update slang makefile.dos, and corresponding INSTALLATION notes - DK
* correct my integration of IZ's LY_CHANGE_LINK code, which resulted in an
  out-of-bounds index into revmap (reported by LP, LV) - TD
* add note about sendmail for Win32 to lynx.cfg - JS
* add note for successful build on NeXT to INSTALLATION (Christian Jensen
  <cejensen@winternet.com>)
* add checks for null return from malloc to HTInit.c, LYMainLoop.c, LYUtils.c,
  (patch by John Bley <jbb6@acpub.duke.edu>)
* remove reference to 'persistent_cookies' in LYCookie.c which prevented
  compile when persistent cookies configure option was disabled (report
  by PG) - KW
* move assignment to SHELL back from WWW/Library/makefile.in to CommonMakefile,
  and revert use of $CONFIG_SHELL in configure script, since this appears to
  stop auto-configure from finding working include feature of 'make' on CLIX
  (reported by Alex Matulich) - TD
1998-12-16 (2.8.2dev.10)
* FROM_FILE is not used any more for a domain (although it is currently still
  defined.  Renamed COOKIE_FLAG_PERSISTENT to COOKIE_FLAG_FROM_FILE.  Don't
  change a domain's "behavior" (ACCEPT_ALWAYS, REJECT_ALWAYS, or QUERY_USER)
  just because there was a persistent cookie for it.  Users who want to always
  accept cookies from a domain without prompting should use
  COOKIE_ACCEPT_DOMAINS - KW
* FREE domain_entry objects when they are not used any more.  Other minor leak
  removed - KW
* some (few) changes for draft-ietf-http-state-man-mec-10.txt.  Don't accept
  invalid port lists (this may need more tweaking).  Added some comments - KW
* try to preserve cookies (within a domain) in the same order in which they
  were received, although this is probably not necessary after all.  There is
  no difference any more w.r.t.  insertion into the list between cookies from
  the file and cookies from response headers - KW
* use <= instead of < comparison when checking whether a cookie has expired -KW
* don't write expired cookies, cookies with discard attribute, or cookies
  without expiration date to persistent file - KW
* don't call HTConfirmCookie for cookies read from file.  This doesn't change
  the logic since previously HTConfirmCookie allowed all file cookies anyway -
  KW
* don't delete the domain_list if it becomes empty.  Doing this could result in
  unnecessary multiple atexit()'s - KW
* write the cookie file even if we now have no cookies, if we have previously
  read cookies from the file.  The file should be updated if all cookies that
  were in it are expired or superseded or deleted - KW
* when reading file cookies, set attributes in a way that (hopefully) makes
  more sense than just ignoring them.  See comments in LYLoadCookies.
  We are restricted a lot by the choice of a Netscape-compatible cookie file
  format, some version 1 properties just cannot be stored in it AFAIK.  Some
  more tweaking in LYLoadCookies - KW
* setting a domains behavior to accept "A)lways" didn't actually work, it had
  the same effect as "P)rompt".  Corrected this simple (probably cut-and-paste)
  error - KW
* some changes in what is displayed on Cookie Jar page:  FROM_FILE is a
  property of individual cookies, not of domains as previously.  Cookies from
  file (which haven't been updated) are shown as "(from a previous session)".
  Show expiration time ("Max.  Gobble Date") whenever we have one.  The state
  of the "discard" attribute is already displayed separately - KW
* made color styles code work much better with TagSoup parsing mode.  A new
  flag bit is set for some tags in HTMLDTD which indicates that, even though
  they may be otherwise handled as SGML_EMPTY, this emptiness is fake.  This
  can only work reasonably for elements that require an end tag (not for LI,
  for example) - KW
* added SUMMARY attribute for TABLE element to HTMLDTD (but we don't do
  anything with it) - KW
* split_line:  Try to account for changes in anchor position and extent in all
  possible cases.  This improves some cases where the selectable text could
  become too short and, in extreme cases, a link could become erroneously
  "hidden" - KW
* split_line:  color style changes after the split position are moved to the
  correct position in the new line - KW
* set TextAnchor's line_num in HText_beginInput, so that split_line can adjust
  the input field's position properly if a split moves it to the next line.
  Should solve problem reported for www.lycos.com - KW
* don't refuse to read from file-descriptor 0 in HTDoRead for Unix if it is not
  a tty.  The socket fd from HTDoConnect can be 0 if fd 0 was not open when
  lynx was started non-interactively - KW
* increase INIT_LINE_SIZE in HTTP.c slightly from 1024 to 1536, so that for a
  typical ethernet MTU the first packet of a response can more often be read in
  with a single read() - KW
* add a missing FREE() in HTTP.c - KW
* use case mapping from ftp.unicode.org /Public/UNIDATA for case-insensitive
  user search (thanks "Kari E.  Hurtta" <Kari.Hurtta@ozone.FMI.FI>), new file
  src/chrtrans/caselower.h added.  This is used instead of UPPER8 assumption
  introduced in 2.8 release (see 1998-02-27).  There is no difference in speed
  though - LP
* fix links in History/Visited Links page for documents with blank
  <TITLE></TITLE>, also remove leading spaces from titles to make output a
  little better - LP
* use djgpp's <sys/config.h> file, which contains default values for autoconf
  style definitions - LP
* updated lynx.man, lynx.hlp for "SEE ALSO" sections - KED, JS
* optimize the test commands specified in the mailcap file by remembering which
  tests have been run already.  (patch by Marc Huber <marc@sixpack.de>)
* add lint rule to makefile.in, as well as corresponding rule in WWW/... - LV
* update version in makefile.in to 2-8-2 - PG
* fix makefiles to build with DJGPP (problem introduced in dev8) - LP
* use new symbol KEYMAP_SIZE to get rid of various constants relating to the
  size of keymap[] array, e.g, 0x293, 659 - TD
* add new mouse and keymap functionality to lynx:
  a) If one clicks mouse *near* a link, the "point/focus" is moved to this link
     (without actual activation);
  b) One can bind keys with ordinals larger than DO_NOTHING;
  c) Primitive context sensitive menu added to the middle button of a mouse
     (currently ncurses only);
  Current micro-problem with "c" is that I do not know how to refresh a screen
  before triggering the action, so if the action chosen from the menu would
  not redraw the screen, the menu outline is left on the screen - IZ
* modify LYKeymap.c so that it can show internal keymaps above 0400 as
  hexadecimal codes even if they do not appear in the function-key table -IZ
* add HTOptParam to avoid spurious quoting of blanks in rlogin URLs by
  HTAddParam - TD
* correct missing assignment in remote_session(), from dev.9 changes for
  HTAddParam, which broke telnet/rlogin URLs (reported by IC) - TD
1998-12-12 (2.8.2dev.9)
* change location-not-absolute message from an alert to user-message - TD
* check for EINTR from read() call in HTDoRead, and retry if necessary.  This
  change only for Unix.  Interrupted read() system calls should be rare (or
  impossible, depending on the system implementation?) since the read() is only
  done after a successful select(), but checking can't hurt - KW
* check for read read() errors in HTDoRead and HTCopy, and generate alert
  messages for unexpected errors.  HTCopy still returns HT_LOADED to indicate
  success if any data have been received before an unexpected error or
  disconnection.  Previously this happened without any indication to the user
  that something was wrong and a document or file might be incomplete.  These
  changes currently only for Unix - KW
* added/enhanced comments in HTFormat.c to document current behavior of HTCopy,
  HTFileCopy, HTGzFileCopy, HTParseSocket, HTParseFile, and HTParseGzFile - KW
* moved definition of HT_NO_DATA to HTUtils.h, changed value of some status
  codes to libwww5-like values while we're at it - KW
* correct uninitialized de variable in LYCookie.c when dump_output_immediately
  is set.  Also, made a slight change to this mode in LYMain.c, so that cookies
  received will also be written to the cookie file; cleanup() is not called in
  -dump mode (reported by Elwin Oost) - BJP
* correct include-path for chrtrans makefile to allow builds outside the
  source tree (Masashi Fujita)
* minor cleanup of LYCookie.c, add some traces - BJP
* add support for content encoding for x-bzip2, bzip2 for suffix "bz2" - HN
* add po directory to install-bin and uninstall rules - TD
* modify the environment variable logic to avoid freeing string given to putenv
  until after giving it a new string - TD
* add several environment variables to LYPrint.c - KED
* add ENVIRONMENT section to lynx.man and lynx.hlp - KED
* add installation note about --enable-gzip-help - KED
* update installation notes for WAIS - DK
* add/use new functions for building up command-string for shell commands,
  which quote parameters as needed:  HTAddParam(), HTEndParam().  Moved the
  logic in quote_pathname to HTQuoteParameter, extending that function to quote
  the parameter only if it contains characters which are problems with various
  shells (e.g., wildcards), and to escape backslashes.  In particular, use
  these functions to ensure that the user and port strings in HTTelnet.c are
  quoted (fixes a hole reported by Art Mulder <art@openbsd.org> - TD
* modify print-to-file logic to permit writing to pipe, provided that the
  user does not have no-shell restriction - TD
* split-out logic for LYValidateFilename() from printfile() and LYDownload - TD
* whitespace fixes - BJP
* add configure option --with-nls-datadir, to allow installer to specify
  alternate locale data directory.  A separate option from --datadir is
  required because the GNU gettext code is usually installed under
  $(prefix)/share rather $(prefix)/lib - TD
* add configure check for gettimeofday, to implement 0.1 second interval
  for skipping HTCheckForInterrupt() - TD
* modify configure script to generate references to $CONFIG_SHELL rather than
  /bin/sh, to allow some testing with alternate shells.  Autoconf uses this
  variable for a similar purpose - TD
* correct missing case for 'o', octal in StrAllocVsprintf (reported by IC) - TD
* fix -restrictions=bookmark check in forms-based options menu (reported by KW
  & Rodiger Geys) - LP
* fix memory leaks in LYPrint.c and UCdomap.c - KW
* when printing HEAD to email use URL in the subject, was title.  (it was
  especially annoying when we have 8bit title being sent as 7bit:  no charset
  information is supplied for letters with 7bit message body) - LP
* remove "temp fix for HText_trimHightext side effect from partial mode by
  introducing a flag in HText_beginInput()" from 1998-09-12 since it is now not
  needed after KW's changes in HText_trimHightext.  - LP
1998-12-03 (2.8.2dev.8)
* use HTSprintf/HTSprintf0 in LYCookie.c, LYLocal.c - TD
* correct logic in OpenHiddenFile, which did not check if a failure to open a
  file for append was due to the file's not existing and hence causing
  IsOurFile to return failure.  This caused the -traversal option to fail
  (reported by Francis Irving <francis@ncgraphics.co.uk>, applies to
  2.8.1rel.2) - TD
* fixed line number removal code in HText_endAnchor in several places, it was
  modifying the wrong line which could lead to memory corruption - KW
* tweaks in HText_startAnchor and HText_endAnchor for handling link numbers:
  don't swallow space after number if line was split, find link number on
  previous line even it it is at the very end, adjust line split position after
  number removal.  Generate TRACE output in interesting cases - KW
* prevent havoc (access to already freed memory etc.) caused by multiple
  recursive invocations of HTAnchor_delete on the same HTParentAnchor.  This
  does not seem to actually happen normally during a session, but can occur
  when the HTAnchor structures are cleaned up while handling a terminating
  signal or outofmem condition - KW
* reset the HTAnchor "underway" flag during final cleanup, so structures are
  not prevented from being freed.  This also should only make a difference when
  handling a terminating signal or outofmem condition - KW
* show sticky-bit in directory listings - LW
* correct options-message on Print page - IC
* update installation note about freewais library (reported by Chris Maden
  <crism@oreilly.com>) - TD
* improvements to mouse code, ncurses-based, from IZ (Ilya Zakharevich)
  a) Mouse navigation inside text entry fields;
  b) Mouse navigation to a text entry field (including an empty one)
  c) Mouse navigation to a specific position of a text field (since I do not
     know which fields are text fields, I implemented "b" and "c" for
     F_TEXTAREA_TYPE and F_TEXT_TYPE only, search for these symbols in the
     patch);
  d) Mouse navigation in menus:  To scroll, one can click on top/bottom border
     (single=byline, double=bypage, triple=beg/end), or above/below menu
     (single=bypage, double=beg/end)) mouse-3 ==> quit;
  e) Double-click-1 on the first and last row are interpreted as goto-
     start/end/main-window (depending on the location of the click).
  Other Changes:
  a) Ask ncurses for all mouse events, but increase mouseinterval() to simulate
     current behavior (which is effectively an infinite mouseinterval() +
     masking of repeated clicks);
  b) Earlier clicking to the left of a link would activate the link.  I see no
     use for this, so consider this a bug.
* HText_trimHightext (GridText.c):  don't apply final adjustment repeatedly to
  an anchor that has already been handled by this function; the function may be
  called repeatedly if partial display is enabled.  Some other changes in this
  function, to interact better with the other GridText.c functions, especially
  for partial display mode.  We don't have to handle all anchors if the new
  parameter "final" is not set.
  Also empty anchors should now generally not any more move down over empty
  lines, if they happen at a line end.  Made some trace messages give more
  information - KW
* color styles:  reset screen style cache to avoid random coloring when a link
  is unhighlighted - KW
* tweak in HText_setLastOptionValue:  if an OPTION tag was directly followed by
  several newlines, characters could be dropped - KW
* tweak havevisible() function in LYBookmark.c to compare against Unicode
  value rather than ASCII when checking for blanks. - LP
* ifdef user/group function caching calls so that this builds with djgpp, which
  doesn't need/support this (patch by Gisle Vanem)
* documentation updates for NLS - HN
* separate some html from gettext in LYCgi.c, LYHistory.c, LYLocal.c - JS
* avoid setting recent_sizechange during the very first start_curses call for
  ncurses.  This would result in an unnecessary refresh after loading the first
  document - KW
* added logic to display_page to avoid repainting the full screen contents in a
  specific situation:  if it has been called before (for the same lines in the
  same document) during partial display, and is now being called normally (not
  during partial display).  If this applies, the normal line content is not
  redrawn, but the title line and form fields are still repainted, and updating
  of the links structures is always done.  There are additional checks for
  recent_sizechange and a text->stale flag (which was already implemented but
  unused) to do the full redraw if that may be needed.  This should avoid
  unnecessary screen 'blinking' with curses when partial display is used (which
  didn't seem to happen with slang) - KW
* modify SGML.c to check for SGML_ELEMENT tag contents, fixing a case where an
  entity that appears within a TABLE but outside of any table row TR will be
  displayed by Lynx _without_ its entities being interpreted (analysis by Alan
  J Flavell <flavell@a5.ph.gla.ac.uk>, applies to 2.8.1rel.2) - KW
* check that stdin is really a tty before trying to select from it in the
  NSL-FORK logic in HTParseInet(), file HTTCP.c (reported by Kim DeVaughn, for
  someone who was unable to run lynx -dump in a cron job, applies to
  2.8.1rel.2) - TD, BL
* updates for lynx_help_main.html (JS, IC).
* change fopen for write in LYCookie.c to LYNewTxtFile so that the resulting
  file will be readable by only the owner (Bill Nottingham <wen2@po.cwru.edu>
  suggested using umask, but that may not be portable enough) - TD
* use CONST in some places in UCdomap.c and makeuctb, to make more tables
  sharable (suggested by LP) - TD
* fixes for SunOS K&R compiler with/without unproto wrapper, i.e., definition
  of 'const' - TD
1998-11-23 (2.8.2dev.7)
* convert KEY_ENTER to newline in LYgetch() to make Lynx work with IRIX's
  iris-ansi terminfo description, which equates the kent capability with
  carriage return.  Doing this will allow lynx to use the keypad "enter" key as
  an alias for carriage return on most terminals - KW
* correct a few missing ifdef's for disabling the partial-display logic - TD
* add/use new functions HTAA_UidToName(), HTAA_NameToUid(), HTAA_GidToName()
  and HTAA_NameToGid() to hide details of code which uses pwd.h and grp.h,
  as well as to cache the returned user/group names, improving performance
  in the dired screen - TD
* modify HTCheckForInterrupt() to check for interrupt no more than one per
  second, since this check is comparatively slow - TD
* modify ANSI_VARARGS case for HTSprintf() and HTSprintf0() to always use
  ANSI prototypes, since __STDC__ may not necessarily be defined on some
  systems, resulting in an inconsistent definition - PG
* add install-full rule to makefile.in - LV
* modify PutDefs macro in LYShowInfo.c to check for nonnull table[N].value,
  which may be null due to limitations of cfg_defs.sh script on some
  platforms where an empty string was intended (reported by LV, PG, applies
  to 2.8.1rel.2) - TD
* correct typo in 'make distclean' rule; an extra '-' prevented removal of
  .orig and .rej files (patch by LV).
1998-11-21 (2.8.2dev.6)
* add call on dbug_init to LYMain.c, allowing use of the debugging code built
  into the WATTCP code which is included in the DJGPP port of lynx.  This is
  activated by placing lines in the WATTCP.CFG file for:
    DEBUG.MODE= (choices are HEADERS, DUMP, or ALL)
    DEBUG.PROTO= (choices are TCP, UDP, or  ALL)
    DEBUG.FILE= (name of log file.  Defaults to WATTCP.DBG)
  This adds about 2K to the size of the stripped, compressed executable.  You
  get a log of the headers and/or a binary dump of the packets sent and
  received.  Maybe this will help in determining where ftp is failing in this
  port - DK
* correct definitions for ANSI_VARARGS, HAVE_STDARG_H in HTUtils.h (reported
  by LP, for djgpp) - TD
* correct logic in StrAllocVsprintf(), remove spurious test on dst_len
  (analysis by LV) - TD
1998-11-21 (2.8.2dev.5)
* modify HTLoadFile() to make compressed files work with OS/2 EMX and
  LYSystem() to convert forward slashes in pathnames to backslashes, also for
  EMX (patches by Ilya Zakharevich).
* documentation nits (apostrophes) in lynx.cfg and userdefs.h - LV
* fix inconsistent newlines in po/it.po (report by Irving_Wolfe@Wolfe.net) - TD
* modify config.guess, added Intergraph 2430 CLIX machines (reported by Alex
  Matulich <matuli_a@marlin.navsea.navy.mil>) - TD
* minor fix in LYCharSets.c according to recent changes in UCDefs.h introduced
  by IBM OS/2 codepage number - LP
* modify configure script to work with --enable-nls built into a subdirectory
  of the source tree (reported by PG) - TD
* disable regeneration of intl/po2tbl.sed and po/POTFILES if --disable-nls
  configure option is specified - TD
* add configure test for stdarg.h vs varargs.h - TD
* fixes to work with SunOS K&R compiler - TD
* don't trim trailing and leading spaces from unformatted text lines in some
  cases (split_line in GridText.c).  Prevents corruption of some uuencoded
  files when they are displayed and then 'P'rinted (although 'D'ownload should
  be used instead) - KW
* some changes in HText_appendCharacter (GridText.c).  Splitting of long SOURCE
  lines now works with color styles - KW
* workaround for multiple anchors in the same (invalid) HTML document with the
  same NAME and different destinations (HTAnchor.c) - KW
* check for 'z'ap while constructing local directory listings (non-VMS only, in
  HTFile.c) - KW
* added a couple outofmem checks (HTAnchor.c).  Minor TRACE message change in
  GridText.c for -tlog / USE_TRACE_LOG disabled - KW
* when adding bookmark entries, don't accept a title string which appears to
  consist only of blank characters (LYBookmark.c).  When rendering a bookmark
  file, use hiddenlinks=merge counting, so that numbers after entries with
  empty titles don't get out of whack (GridText.c).  This should prevent 'R'
  from removing the wrong bookmark entry - KW
* prevent generation of some unnecessary temp files when constructing mailcap
  file test commands (HTInit.c) - KW
* include LYLeaks.h in UCdomap.c for memory leak detection - KW
* fixed various memory leaks (UCdomap.c, LYShowInfo.c, LYReadCFG.c, LYMain.c,
  LYDownload.c, LYBookmark.c, HTML.c, DefaultStyle.c) - KW
* escape '&' and '<' in HTML generated to display current lynx.cfg option
  values (LYReadCFG.c) - KW
* revert logic in split_line.  Emphasis highlighting that should extend over
  several lines was being lost at line breaks (GridText.c).  (IsSpecialAttrChar
  probably shouldn't return true for LY_SOFT_NEWLINE since in most places it
  tests whether to skip a character position, but as long as this special char
  is only used in SOURCE mode it cannot mess up any anchor positions so it
  should be ok.  - KW
* correct character counting in SOURCE display continuation lines.  A
  highlighted search target would be shown shifted left by one character
  position because the LY_SOFT_NEWLINE special was displayed as '+' but not
  counted (GridText.c) - KW
* prevent generation of invalid/unparseable comments if
  UCSaveBookmarksInUnicode is in effect, other minor changes in
  LYBookmark.c - KW
* correction for color styles in HText_appendCharacter (GridText.c).  At some
  point a memmove was replaced by a for loop, but source and destination were
  reversed and the counter was wrong - KW
* modify HTSprintf/HTSprintf0 to use a more generic approach to varargs by
  using only va_alist in the parameter list - TD
* correct html expression in LYShowInfo.c of dev.3 which did not allow the temp
  file with the lynx.cfg settings to be accessed from the Configuration
  Definitions page (patch by IC - Ismael Cordeiro).
* correct "Exiting" message format in cleanup_sig(), which had unexpanded %d
  (reported by BJP) - TD
* add to config.hin the definitions set by AM_GNU_GETTEXT macro (PG pointed
  out that this also sets 'inline', needed for GNU gettext) - TD
* modify MakeNewTitle() to check for null pointer, fixing core dump with
  verbose images when value[src_type] is null (reported by John Bley
  <jbb6@acpub.duke.edu> for 2.8.1rel.2) - TD
1998-11-18 (2.8.2dev.4)
* change default for configure option of NLS (gettext) to disabled until we
  finish porting it to implementations other than GNU gettext.  Also,
  change default for include-gettext configure option to "with" - TD
* suppress cookie-storing if the value is null - BJP
* ifdef'd alternative set of line-edit bindings with EXP_ALT_BINDINGS, add
  configure option --enable-alt-bindings, rename DELEOL to DELEL, remove
  binding of DELEL to '\'. - TD
* add alternative set of line-edit bindings to change the behavior of the ^B
  and ^F line editor bindings to provide emacs/tcsh like behavior (cursor
  left/right), instead of "word" deletes.  Corrected a bug in the ^R (LYE_DELN)
  function, which is described as "delete next character", but was in fact
  performing identically to ^D (LYE_DELC) "delete current character".  Added a
  function called LYE_DELEL, which does the expected thing, and deletes
  from the current cursor position, to the EOL.
  New bindings:
    ^B = LYE_BACK   cursor backwards
    ^F = LYE_FORW   cursor forwards
    ^K = LYE_DELEOL delete to end-of-line
    ^T = LYE_DELNW  delete next word
    ^X = LYE_DELPW  delete previous word
    ^^ = LYE_UPPER  upper case line (not active when kbd-layout binding is)
    ^_ = LYE_LOWER  lower case line
  KED ((Kim DeVaughn <kimdv@best.com>)).
* modify to show address to submit to on the statusline when in advanced user
  mode.  Also fixes one small typo in LYMainLoop.c.  (suggested by
  <erisson@sw-tech.com>) - BJP
* modify HTParseInet() so that it works if stdin has been redirected to
  /dev/null, e.g., when running a cron job (reported by John H.  DuBois III
  <spcecdt@armory.com>) - BL
* minor documentation updates to lynx.cfg (Larry Virden).
* change some character constants from '\hex' and '\octal' form to decimal,
  to persuade compilers that upper-128 compares are legal - TD
* ifdef'd KEYBOARD_LAYOUT with EXP_KEYBOARD_LAYOUT, add configure option
  --enable-kbd-layout - TD
* implement EXP_CHARTRANS_AUTOSWITCH for OS/2 EMX (Sergey Svishchev).
* add 'a' response when printing a file to allow append rather than overwrite
  (Sergey Svishchev).
* add KEYBOARD_LAYOUT to lynx.cfg, to support character-translation on input,
  add missing line editing style selection to Options form.  This is enabled
  and disabled by the line edit control/uparrow (Sergey Svishchev
  <svs@ropnet.ru>).
* use exit_immediately() to reduce some signal-function clutter - LP
* correct dependency in src/makefile.in for cfg_defs.h (Masashi Fujita
  <objectx@bandit.co.jp>)
* change quoted includes in intl directory to bracketed includes - TD
1998-11-16 (2.8.2dev.3)
* misc documentation updates for the gettext/internationalization - LP
* rename po/makefile.in.in to po/makefile.inn, and modify distclean rule to
  remove the remaining generated files - TD
* add preliminary changes from PG (pg@sweng.stortek.com) to support port to
  OS/390, some ifdef'd with __MVS__, some with EBCDIC and NOT_ASCII.
* modify LYCookie.c to accept cookies with no value, in case the site resets a
  cookie by nulling out the value (reported by Larry Virden) - BJP
* modify cookie parsing to ignore comment lines beginning with a '#' (reported
  by Jonathan Bobin indicates that Netscape adds comments back, confusing Lynx)
  - BJP
* highlight option letters in old options screen (adapted from patch by Ismael
  Cordeiro) - TD
* use HTSprintf functions in HText_SubmitForm(), user_message(),
  LYLoadIMGmap(), HTTelnet.c.  (The HTTelnet.c modifications fix a security
  hole reported by Martin Mokrejs) - TD
* add HTSprintf, HTSprintf0 functions, to use in resolving potential buffer
  overflows - TD
* modify HTVMS_purge() to rename the remaining file to version 1 unless a
  permissions problem was encountered - TD
1998-11-10 (2.8.2dev.2)
* some testing against Solaris gettext implementation, enough to see that it is
  not really compatible either source or binary with GNU gettext.  For the time
  being, I recommend building NLS support only with GNU gettext (and
  --with-included-gettext to avoid conflict with Solaris' gettext in the
  standard library).  Otherwise use the --disable-nls configure option - TD
* various changes to configure script and makefiles to make this build with and
  without NLS - TD
* undo spurious substitutions such as gettext("") - TD
* modify some gettext() expressions to avoid embedding HTML in them - TD
* restore definitions in LYMessages_en.h - TD
* first cut of integrating Jim Spath's changes to incorporate message library
  support.
1998-09-20
* Files edited for language hooks:
  src/HTAlert.c src/HTInit.c src/HTML.c src/LYBookmark.c src/LYCgi.c
  src/LYClean.c src/LYCookie.c src/LYCurses.c src/LYDownload.c src/LYEdit.c
  src/LYForms.c src/LYGetFile.c src/LYMail.c src/LYMain.c src/LYMainLoop.c
  src/LYMap.c src/LYNews.c src/LYPrint.c src/LYUpload.c src/LYUtils.c
  src/LYexit.c
  WWW/Library/Implementation/HTAABrow.c WWW/Library/Implementation/HTAAProt.c
  WWW/Library/Implementation/HTAccess.c WWW/Library/Implementation/HTFTP.c
  WWW/Library/Implementation/HTFWriter.c WWW/Library/Implementation/HTFinger.c
  WWW/Library/Implementation/HTFormat.c WWW/Library/Implementation/HTGopher.c
  WWW/Library/Implementation/HTMIME.c WWW/Library/Implementation/HTNews.c
  WWW/Library/Implementation/HTRules.c WWW/Library/Implementation/HTStyle.c
  WWW/Library/Implementation/HTTCP.c WWW/Library/Implementation/HTTP.c
  WWW/Library/Implementation/HTVMSUtils.c WWW/Library/Implementation/HTWAIS.c
  WWW/Library/Implementation/HTWSRC.c
1998-09-08 (2.8.1dev25-intl)
* Resynch with dev tree - JES
1998-09-07 (2.8.1dev.21-intl)
* About half through language hooks in WWW/Lib... - JES
  Integrated part of Chebucto's French translations. - JES
* Included latest ABOUT-NLS from GNU project,
1998-08-27 (2.8.1dev.21-intl)
* Tested language hooks using src/LYNews.c and Italian messages file
  provided by Sabato De Rosa <sabato.derosa@usa.net>.  Made changes to
  LYMain.c, LYMainLoop.c, LYNews.c and HTNews.c. - JES
1998-08-27 (2.8.1dev.21-intl)
* add hooks to GNU gettext for international language support - JES
  (This is an experimental modification that will be patched into
  the main Lynx release after other platform testing.  I've only done
  NetBSD.)

1998-11-05 (2.8.2dev.1)
* relax the cookie sanity checking for version 0 (old) cookies _only when_ the
  user has accept_all_cookies set (patch by Risto Widenius
  <widenius@ling.helsinki.fi>)
* modify get_listen_socket() to check if master_socket is set before attempting
  to use it in FD_CLR (patch by Karl-Andre Skevik <karls@kosmo.inet.no>)
* minor documentation fixes - DK
* use $(LIBS) symbol in src/chrtrans/makefile.in (reported by Alois Maier
  <m9235159@grz08u.unileoben.ac.at>)
* Fix core dump which may happen after printing-to-email. - LP
* Move read_rc() before parsing any command-line arguments (except -help)
  so the latter will override any .lynxrc settings.  In particular, the problem
  was detected with -cookie_file= which was ignored after saving values
  from Options menu. - LP
* Chartrans bug: LYNXIMGMAP now shows the text in right charset.
  (The page was converted twice, fixed by adding META charset to this internal
  page.  The bug was in all versions of Lynx starting from 2.7.1ac) - LP
* Oops, my typo from pre3 back to 27-09-98: windows-1252 appears twice
  in the list of character sets in options menu, was also typo in docs. - LP
* modify HTDOS.c to permit compile with K&R compiler - TD
1998-10-27 (2.8.1rel.2)
* tidy up version numbers - TD
* modify HTDOS.h to permit compile with K&R compiler - TD

1998-10-24 (2.8.1rel.1)
-----------------------
* reorganize lynx_help_main.html - PW
* minor change to WWW/.../tcp.h to eliminate redefinition warning by DEC C - TD
* move checking for command-line "-head" and related options before curses
  initialization so that program exits with correct terminal settings
  (report by LV, fix by BL).
* correct uninitialized index into id_append in makeuctb, which causes problems
  with def7_uni.tbl (analysis by LP)
* add TAGSOUP flag to lynx.cfg to set initial state of Tag Soup vs SortaSGML
  (request by LP) - TD
* add PERSISTENT_COOKIES flag to lynx.cfg to allow disabling the persistent
  cookies feature in a Lynx executable (request by BJP) - TD
* modify read_cfg so that it does not display included-file information when
  NO_CONFIG_INFO is defined (reported by LP) - TD
* minor/cosmetic fixes for comments and documentation - LP
* revised patch for nsl-fork, which does not rely on WNOWAIT definition - BL
* include termio.h in LYCurses.c only #ifdef TERMIO_AND_CURSES (Philippe
  De Muyter <phdm@macqel.be>)
* modify cfg_defs.sh to work when the 'set' command emits double-quotes
  (pg@sweng.stortek.com)
* update obsolete copy of HTFWriter.c to add content-encoding for HTFileSuffix
  (reported by David Helder <dhelder@umich.edu) - TD
1998-10-17 (2.8.1pre.11)
* add dependency on cfg_defs.h to src/makefile.in for LYShowInfo.o
  (pg@sweng.stortek.com)
* modify add_item_to_list() so that if the restriction flag is omitted from
  a download/upload/extern line in lynx.cfg, it is assumed true.  Also check
  for null command string in LYExtern.c (bug report by HN) - TD
* modify logic in forms-options menu so that assume_char_set now works
  correctly for any LYRawMode value by synchronizing gen_options() and
  postoptions() via rawmode memory - LP
* correct ifdef'ing in LYShowInfo.c for non-Unix platforms - LP
* modify nsl_fork logic to handle a case where child exits successfully
  right after parent's select timed out (reported by Serge Munhoven) - BL
* small updates to lynx_help files and other documentation (BJP, PW, LV).
* add #define's for later work to simplify configuring the maximum number
  of cookies (suggested by BJP) - TD
* flush output in makeuctb, as possible fix for build problems on systems that
  do not implement POSIX 'exit()' call (reported by Serge Munhoven
  <munhoven@mema.ucl.ac.be> and Jan Hlavacek <lahvak@math.ohio-state.edu>) - TD
* put GOTOBUFFER, JUMPBUFFER and QUIT_DEFAULT_YES back the way they used to be
  (majority decision) - TD
1998-10-14 (2.8.1pre.10)
* add/use HTSYS_purge and HTSYS_remove functions (based on report by Tony
  Bolton and patch by BJP dealing with removing older versions of cookie files)
  - TD
* add --disable-config-info option - TD
* change configure script --enable-forms-options to --disable-forms-options,
  add --disable-menu-options - TD
* comment-out FM's code to fold cookie headers and force cookies to be
  presented in the same order that they were received - BJP
* use full "Implementation" directory name in include path in WWW djgpp
  makefile - DK
* use HTDOS_name() to force DOS temporary-directory into consistent form - DK
* include HTVMSUtils.h and HTDOS.h from LYUtils.h, consolidate some ifdef's
  using macro HTSYS_name - TD
* another fix for HTTCP.c, for lookups with Lynx/32 - WB
* add fallback to $TMPDIR for Lynx temporary directory on Unix - TD
* remove verbose_links variable due to popular demand - TD
1998-10-10 (2.8.1pre.9)
* add verbose_links variable to lynx.cfg and userdefs.h to control whether Lynx
  should show "(LINK)" before links (request/patch by Moshe Zadka
  <moshez@math.huji.ac.il>) - TD
* change defaults in lynx.cfg and userdefs.h, add comments - PW
  (a) defaults are stated for `verbose' & `KB';
  (b) GOTOBUFFER & JUMPBUFFER defaults to TRUE;
  (c) QUIT_DEFAULT_YES defaults to FALSE
* restore suggested file name in download menu:  it is really useful for other
  download methods which should be available in menu when `save to disk' is
  disabled.  Remove local_path/ prefix (LYNX_SAVE_SPACE if any) from visible
  suggested file name string near the top instead - LP
* restore newline position when toggling comments parsing (at least we could
  return to previous screen to try comments toggling twice) - LP
* add a link from keystrokes help for edit_help.html (input line keys) - LP
* corrected to make -nostatus command-line option override HTReadProgress - TD
* updates to lynx-dev.html (Al Gilman).
* modify NSL-fork support in HTTCP.c to use waitpid call to reap child
  processes which may otherwise become orphaned.  The new variable
  "dns_patience" represents how many seconds we're willing to wait for DNS to
  respond (should later make it configurable) - BL
* modify PutTextInput and PutDefs macros in LYOptions.c and LYShowInfo.c to
  avoid pre-ANSI compilers attempting to substitute macro parameters in
  coincidental matches within quoted strings - BL
  gcc -Wtraditional reports the first, but not the second, which is "n"
  substituted into "\n" - TD
* add an error-check for fg/bg values to lynx_chg_color function in case
  lynx.cfg specifies color names not in Lynx's table - BL
* modify IsOurFile function to accommodate links-to-links, so that users whose
  home directory is reached by that type of path can save .lynxrc file
  (reported by PW) - TD
1998-10-04 (2.8.1pre.8)
* modify HTTCP.c to copy soc_in from phost in HTParseInet, making Lynx/32 do
  lookups again - WB
* modify LYCurses.c to compile mouse-code with Borland C and PDCURSES 2.3 - WB
* correct backward logic in CF_TERMIOS_AND_CURSES (reported by LE) - TD
1998-10-04 (2.8.1pre.7)
* add special-case CF_TERMIOS_AND_CURSES configure macro (fixes problem
  reported by Philippe De Muyter) - TD
* update/reorganize option_help.html - PW
* restore newline position when return from the Print menu or follow a link
